#!/usr/bin/wish8.0

# TkMAME 0.35pre11 (08/24/99)
#
# Copyright (c) 1999 Christopher Stone
#
# E-Mail:    tkmame@ztnet.com
# Home Page: http://tkmame.retrogames.com
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


# Comment from the author:
# This is my first Tcl/Tk application, the code will reflect this.

# TODO (noarch)
#==============================
# add picture file converter
# add gui to create groups/edit roms in tkroms.cfg file
# add upload to MARP feature
#
# TODO (Unix)
#==============================
# save config info into ~/.xmame/gamenamerc file
#
# TODO (Windows):
#==============================
# remove -ntsc switch
# remove -double switch
# fix stretch to match rc1 style (ie, -stretch/-nostretch)
# add -monitor pulldown (standard, ntsc, pal, arcade)
# add -tweak/-notweak
# add -centerx option
# add -centery option
# add -waitinterlace option
# add historyfile option
# add mameinfofile option
# waitvsync, vsync & triplebuffer should mutually exclusive
# vesamode & triplebuffer should enable vesa



#  These are user customizations for Linux users:

# Working directory is where TkMAME data files and other xmame user
# specific data files go.  TkMAME tries to find the tkroms.cfg file in
# this directory.  TkMAME will also write its own data files to this
# directory and to subdirectories under this one.
# Typically this is set to $HOME/.xmame

set xmame_working_dir [file join / $env(HOME) .xmame]

# Image directory is where you hold all your graphics images for TkMAME
# to display.  I place mine in an image directory under the .xmame directory.

#set xmame_image_dir [file join / $xmame_working_dir images]
set xmame_image_dir "[file join / $xmame_working_dir flyers]:[file join / $xmame_working_dir png]"

# The Document directory is where TkMAME looks for files such as cheat.dat
# and gamelist.txt.  TkMAME uses gamelist.txt to extract notes for a game.
# A typical location for this is /usr/src/xmame-0.xx/doc.  I have set up
# a soft link to this directory under my .xmame directory and define the
# document dir as follows:

#set xmame_doc_dir [file join / $xmame_working_dir doc]
set xmame_doc_dir "[file join / $xmame_working_dir doc]:[file join / usr src xmame doc]:[file join / usr games xmame doc]:[file join / $xmame_working_dir tkmame]:$env(HOME)"


# End of user customizations...source code follows..only modify if you know
# what you are doing....

# The Img package is required to view .PNG formated images
package require Img

# read in the text strings for your particular language
#set language_file [auto_execok language.tcl]
#if { $language_file == "" } {
#    set language_file ./language.tcl
#}
#source $language_file

# English to English translation by Christopher Stone : ))
# And I got a C- in English too!

set t(0001) "Enter MAME Executable"
set t(0002) "Browse..."
set t(0003) "Executable Files"
set t(0004) "All Files"
set t(0005) "Open"
set t(0006) "Okay"
set t(0007) "Error"
set t(0008) "Please enter a valid executable."
set t(0009) "Cancel"
set t(0010) "Please wait while loading."
set t(0011) "Unable to match patterns in"
set t(0012) "Warning"
set t(0013) "MAME configuration file not found."
set t(0014) "Unable to parse MAME commands."
set t(0015) "Unable to find ROMs."
set t(0016) "ROM copy limit exceeded."
set t(0017) "ROM definition"
set t(0018) "not unique."
set t(0019) "No ROM images found.  Exiting."
set t(0020) "Use Mouse"
set t(0021) "Swap Joystick Axis"
set t(0022) "Analog Joystick"
set t(0023) "Analog Mouse"
set t(0024) "Grab Mouse"
set t(0025) "No Joystick"
set t(0026) "i386 Style Joystick"
set t(0027) "FM Town Pad"
set t(0028) "X11 Extension"
set t(0029) "Linux Joystick Driver"
set t(0030) "JoyStick:"
set t(0031) "X11 Joystick:"
set t(0032) "Pad Device:"
set t(0033) "Dubble Buffering"
set t(0034) "Cabinet View"
set t(0035) "Full Screen"
set t(0036) "Network Map Key"
set t(0037) "Master"
set t(0038) "Slave"
set t(0039) "Cabinet"
set t(0040) "FX Gamma"
set t(0041) "Height Scale:"
set t(0042) "Width Scale:"
set t(0043) "Scale:"
set t(0044) "Skip"
set t(0045) "out of 60 FPS"
set t(0046) "MIT Shared Memory"
set t(0047) "Dirty Rectangles"
set t(0048) "Private Color Map"
set t(0049) "Full Screen"
set t(0050) "XFlush/XSync Refresh"
set t(0051) "Throttle"
set t(0052) "True Color"
set t(0053) "Other Command"
set t(0054) "Brightness"
set t(0055) "Gamma Correction"
set t(0056) "Flip X"
set t(0057) "Flip Y"
set t(0058) "Rotate Left"
set t(0059) "Rotate Right"
set t(0060) "No Rotation"
set t(0061) "Volume"
set t(0062) "Beam"
set t(0063) "Flicker"
set t(0064) "Antialiasing"
set t(0065) "Translucency"
set t(0066) "Sound"
set t(0067) "Fake Sound"
set t(0068) "Audio Device"
set t(0069) "Sample Rate:"
set t(0070) "Timer Frequency"
set t(0071) "Frag Size:"
set t(0072) "Num Frags"
set t(0073) "Rom Path"
set t(0074) "Spool Dir"
set t(0075) "Cheat"
set t(0076) "Log"
set t(0077) "Ignore"
set t(0078) "Record:"
set t(0079) "Alt.MAME"
set t(0080) "You do not have any ROM images contained in this group."
set t(0081) "Input"
set t(0082) "GL/Net"
set t(0083) "Video"
set t(0084) "Tweaks"
set t(0085) "Sound"
set t(0086) "Other"
set t(0087) "Image"
set t(0088) "Font:"
set t(0089) "Font Style:"
set t(0090) "Size:"
set t(0091) "Regular"
set t(0092) "Bold Italic"
set t(0093) "Italic"
set t(0094) "Bold"
set t(0095) "OK"
set t(0096) "Effects"
set t(0097) "Strikeout"
set t(0098) "Underline"
set t(0099) "Sample"
set t(0100) "Every good boy\n does fine."
set t(0101) "Untitled"
set t(0102) "MAME Files"
set t(0103) "Text Files"
set t(0104) "Select a file to load"
set t(0105) "Select file name to save"
set t(0106) "File"
set t(0107) "Edit"
set t(0108) "New"
set t(0109) "Open..."
set t(0110) "Insert..."
set t(0111) "Save"
set t(0112) "Save As..."
set t(0113) "Exit"
set t(0114) "Cut"
set t(0115) "Copy"
set t(0116) "Paste"
set t(0117) "Search: "
set t(0118) "Find Again"
set t(0119) "Overwrite?"
set t(0120) "Overwrite Existing Configuration File?"
set t(0121) "TkMAME found some snapshots.  Do you want to convert one of these for TkMAME to use?"
set t(0122) "Convert Snapshot"
set t(0123) "Select Image"
set t(0124) "Convert"
set t(0125) "Invalid Selection"
set t(0126) "Please make a selection."
set t(0127) "File conversion failed."
set t(0128) "Shall I delete the other snap shots?"
set t(0129) "Delete other Files?"
set t(0130) "Warning:  Your soundcard is set to -1.  This has been known to cause problems with TkMAME.  Please edit your MAME.CFG file and change the soundcard setting to something other than -1."
set t(0131) "File Not Found:"
set t(0132) "No Data Found."
set t(0133) "No Notes Found."
set t(0134) "No missing ROMs"
set t(0135) "ROMs supported by MAME:"
set t(0136) "ROMs you are missing:"
set t(0137) "ROMs found by TkMAME:"
set t(0138) "ROM COUNT NOT INCLUDING NEO GEO ROMS"
set t(0139) "Options"
set t(0140) "Reset keyboard/dip-switch configuration for"
set t(0141) "Reset Keyboard/Dip-Switch Settings?"
set t(0142) "Reset High Scores"
set t(0143) "Could not find file"
set t(0144) "Reset high scores for"
set t(0145) "Reset High Scores"
set t(0146) "Overwrite Existing File"
set t(0147) "Overwrite Notes File?"
set t(0148) "
This will perform diagnostics on the files found in the following\nROM path specification(s):"
set t(0149) "It is recommended that this ROM path specification correctly specifies\nthe directories where your MAME ROMs are located.  If the ROM path\nspecification is incorrect, you may edit the MAME.CFG file by selecting\n'Default MAME Configuration' from the Edit menu, and edit the rompath\nsetting.  Once this setting is changed, you must restart TkMAME."
set t(0150) "Run Diagnostics"
set t(0151) "The following duplicate ROMs were found:"
set t(0152) "Duplicate ROMs"
set t(0153) "The following unknown ROMs were found:"
set t(0154) "These may be files located in your ROM Path, or ROMs found in the tkroms.cfg file."
set t(0155) "Do you wish to exclude NEO GEO ROMS in the report?"
set t(0156) "Neo Geo ROMS"
set t(0157) "TkMAME has found"
set t(0158) "ROMs out of a possible"
set t(0159) "ROMs.  Do you wish to verify the checksums for each of these ROMs?"
set t(0160) "ROMs.  Do you wish to verify the samples for each of these ROMs?"
set t(0161) "WARNING: This could take a long time!"
set t(0162) "Verify all ROMs"
set t(0163) "Please Wait..."
set t(0164) "Verify ROMs"
set t(0165) "Data Saved"
set t(0166) "Verify all ROM samples"
set t(0167) "Data Saved"
set t(0168) "Diagnostics data has been saved to"
set t(0169) "Do you want to download the latest cheat data from Pugsy's Cheat Page?"
set t(0170) "Download Cheats?"
set t(0171) "Downloading CHEAT.DAT:"
set t(0172) "bytes received"
set t(0173) "Save Cheat data?  The old cheat.dat file will be renamed to cheat.bak."
set t(0174) "Save Cheat Data?"
set t(0175) "HTTP transfer reset."
set t(0176) "Search:"
set t(0177) "Launch MAME"
set t(0178) "View"
set t(0179) "Missing ROMs"
set t(0180) "Notes on Selected ROM"
set t(0181) "List ROM Details"
set t(0182) "Failed."
set t(0183) "Unable to read"
set t(0184) "List ROM Clones"
set t(0185) "List MAME Games"
set t(0186) "MAME Read Me File"
set t(0187) "File Not Found"
set t(0188) "Information"
set t(0189) "Test"
set t(0190) "Default"
set t(0191) "User selected font."
set t(0192) "User did not select a font."
set t(0193) "Resolution:"
set t(0194) "Color Depth:"
set t(0195) "Pixel Doubling:"
set t(0196) "100% Faster"
set t(0197) "200% Faster"
set t(0198) "300% Faster"
set t(0199) "Normal"
set t(0200) "Speed"
set t(0201) "VESA"
set t(0202) "Scanlines"
set t(0203) "NTSC"
set t(0204) "VSync"
set t(0205) "VGA Frequency:"
set t(0206) "SyncedTweak"
set t(0207) "Skip Lines"
set t(0208) "Skip Columns"
set t(0209) "Prompt on Startup"
set t(0210) "Silence"
set t(0211) "SoundCard:"
set t(0212) "Bit Sampling"
set t(0213) "OPL:"
set t(0214) "Stereo"
set t(0215) "Ignore Config"
set t(0216) "Alt. ROM Name:"
set t(0217) "Unknown ROMs"
set t(0218) "MAME Read Me File (Unix)"
set t(0219) "TkMAME Read Me File"
set t(0220) "Beta Info"
set t(0221) "Error Log"
set t(0222) "What's New"
set t(0223) "What's Old"
set t(0224) "Cheat Documentation"
set t(0225) "Game Information"
set t(0226) "Selected ROM"
set t(0227) "Verify"
set t(0228) "Samples for ROM"
set t(0229) "Cheat Data"
set t(0230) "Default MAME Configuration"
set t(0231) "Change MAME Executable and Path..."
set t(0232) "Reset Keyboard/Dip-Switch Settings for ROM"
set t(0233) "Reset High Scores for Selected Game"
set t(0234) "Re-read Notes from README.TXT File"
set t(0235) "Colors"
set t(0236) "TkMAME Default"
set t(0237) "Light Steel Blue"
set t(0238) "Light Slate Gray"
set t(0239) "Windows Default"
set t(0240) "Background..."
set t(0241) "Foreground..."
set t(0242) "Active Background..."
set t(0243) "Active Foreground..."
set t(0244) "Disabled Foreground..."
set t(0245) "Highlight Background..."
set t(0246) "Highlight Color..."
set t(0247) "Insert Background..."
set t(0248) "Select Color..."
set t(0249) "Select Background..."
set t(0250) "Trough Color..."
set t(0251) "Diagnostics..."
set t(0252) "Download Latest Cheats..."
set t(0253) "About"
set t(0254) "Written by"
set t(0255) "Launch MAME"
set t(0256) "Configure ROM"
set t(0257) "Remove Configuration"
set t(0258) "Remove Current Configuration File?"
set t(0259) "View Graphics"
set t(0260) "View Notes"
set t(0261) "Verify ROM"
set t(0262) "Verify Samples"
set t(0263) "List Clones"
set t(0264) "Change Font"
set t(0265) "Group:"
set t(0266) "Mouse"
set t(0267) "Debug"
set t(0268) "Name:"
set t(0269) "Vector"
set t(0270) "License"
set t(0271) "Cursor"
set t(0272) "Auto Frameskip"
set t(0273) "Planar"
set t(0274) "XIL"
set t(0275) "MT-XIL"
set t(0276) "*Video Mode"
set t(0277) "*Use Caution"
set t(0278) "Getting MAME Version Information"
set t(0279) "Copyright (c) 1999 Christopher Stone"
set t(0280) "E-Mail: tkmame@ztnet.com -- Web Page: http://tkmame.retrogames.com"
set t(0281) "Getting list of available ROMs"
set t(0282) "Getting list of available clones"
set t(0283) "Getting list of your ROMs"
set t(0284) "Loading customized ROM information from TKROMS.CFG file"
set t(0285) "Getting color information for ROMs"
set t(0286) "Getting wrong orientation information for ROMs"
set t(0287) "Getting year and manufacturer information for ROMs"
set t(0288) "Loading the TkMAME GUI"
set t(0289) "No Wait Vsync"
set t(0290) "Artwork"
set t(0291) "Samples"
set t(0292) "US Patriotic"
set t(0293) "Toggle Auto-Raise Windows"
set t(0294) "Profiler"
set t(0295) "Triple Buffer"
set t(0296) "Vesa Mode"
set t(0297) "Stretch"
set t(0298) "Game History File"

. configure -cursor top_left_arrow

# This procedure defines the default colors for TkMAME
proc set_tkmame_default_colors { } {
    global def

    set def(activeBackground)    "#808080"
    set def(activeForeground)    "#00ff00"
    set def(background)          "#d9d9d9"
    set def(disabledForeground)  "#888888"
    set def(foreground)          "#000000"
    set def(highlightBackground) "#d9d9d9"
    set def(highlightColor)      "#8080ff"
    set def(insertBackground)    "#ff0000"
    set def(selectColor)         "#8080ff"
    set def(selectBackground)    "#8080ff"
    set def(troughColor)         "#aaaeb0"
}


# This procedure changes the pallete to the default color settings
proc set_palette { } {
    global def

    tk_setPalette                                     \
	background          $def(background)          \
	activeBackground    $def(activeBackground)    \
	activeForeground    $def(activeForeground)    \
	disabledForeground  $def(disabledForeground)  \
	foreground          $def(foreground)          \
	highlightBackground $def(highlightBackground) \
	highlightColor      $def(highlightColor)      \
	insertBackground    $def(insertBackground)    \
	selectColor         $def(selectColor)         \
	selectBackground    $def(selectBackground)    \
	troughColor         $def(troughColor)
}

# This procedure sets windows default color
proc set_default_colors { } {
    global def

    if { [is_windows] } {
	set def(background)          SystemButtonFace
	set def(foreground)          SystemButtonText
	set def(troughColor)         SystemScrollbar
	set def(activeBackground)    SystemHighlight
	set def(activeForeground)    SystemHighlightText
	set def(disabledForeground)  SystemDisabledText
	set def(highlightBackground) SystemButtonFace
	set def(highlightColor)      SystemWindowFrame
	set def(insertBackground)    SystemWindowText
	set def(selectColor)         SystemWindow
	set def(selectBackground)    SystemHighlight
    } else {
	set_tkmame_default_colors
    }
}

proc set_tkmame_us_patriotic_colors { } {
    global def

    set def(activeBackground)    "#0000ff"
    set def(activeForeground)    "#ffffff"
    set def(background)          "#ffffff"
    set def(disabledForeground)  "#888888"
    set def(foreground)          "#0000ff"
    set def(highlightBackground) "#eeffff"
    set def(highlightColor)      "#ff0000"
    set def(insertBackground)    "#ff0000"
    set def(selectColor)         "#ff0000"
    set def(selectBackground)    "#fe0000"
    set def(troughColor)         "#00a8f0"
}

# this procedure changes a default color setting
proc set_color { option color } {
    global def
    set def($option) $color
    set_palette
}

# Set up TkMAME default colors
set_tkmame_default_colors
set_palette


set debuging off; # valid values are on and off
global debuging
set ver "0.35-pre11" ; # script version number
set rom_config_file tkroms.cfg ; # ROM redefinitions

font create courierfont -family Courier -size 12 -weight normal
font create courierbold -family Courier -size 12 -weight bold

# withdraw toplevel window until ready to display
wm withdraw .

# Set up debuging windows [ first things first (-; ]

set debug_top .debug
set debug_text .debug.frm.text
global debug_text debug_top

# Logs a message to the debug window
proc debug_log { message } {
    global debuging debug_text

    if { $debuging == "on" } {
	$debug_text insert end "$message\n"
	$debug_text see end
    }
}

# Turns debuging on or off
proc debug { on_or_off } {
    global debuging debug_top

    if { $debuging != $on_or_off } {
	if { $on_or_off == "on" } {
	    if { ![winfo exists $debug_top] } {
		debug_create
	    } else {
		wm deiconify $debug_top
	    }
	} else {
	    wm withdraw $debug_top
	}
	set debuging $on_or_off
    }
}

# Creates debuging window
proc debug_create { } {
    global debug_top debug_text text_bg text_fg

    toplevel $debug_top
    set frm $debug_top.frm
    frame $frm -bd 0
    text $debug_text -yscrollcommand "$frm.v_scroll set" \
	    -xscrollcommand "$debug_top.h_scroll set"
    scrollbar $debug_top.h_scroll -orient horizontal \
	    -command "$debug_text xview"
    scrollbar $frm.v_scroll -command "$debug_text yview"
    pack $frm.v_scroll -side right -fill y
    pack $debug_top.h_scroll -side bottom -fill x
    pack $debug_text -expand 1 -fill both
    pack $frm -side top -fill both -expand 1
    wm geometry $debug_top 400x240-0-0
}

# Build debuging window if debuging is on
if { $debuging == "on" } {
    debug_create
}

proc is_windows { } {
    global tcl_platform
    if { $tcl_platform(platform) == "windows" } {
	return 1
    } else {
	return 0
    }
}

proc is_windows31 { } {
    global tcl_platform
    if { [is_windows] } {
	if { ![is_windows95] && ![is_windows98] && ![is_windowsNT] } {
	    return 1
	}
    }
    return 0
}

proc is_windows95 { } {
    global tcl_platform
    if { [is_windows] } {
	if { $tcl_platform(os) == "Windows 95" &&
	     $tcl_platform(osVersion) == "4.0" } {
	    return 1
	}
    }
    return 0
}

proc is_windows98 { } {
    global tcl_platform
    if { [is_windows] } {
	if { $tcl_platform(os) == "Windows 95" &&
	     $tcl_platform(osVersion) == "4.10" } {
	    return 1
	}
    }
    return 0
}

proc is_windowsNT { } {
    global tcl_platform
    if { $tcl_platform(os) == "Windows NT" } {
	return 1
    }
    return 0
}

proc is_unix { } {
    global tcl_platform
    if { $tcl_platform(platform) == "unix" } {
	return 1
    }
    return 0
}

proc is_linux { } {
    global tcl_platform
    if { $tcl_platform(os) == "Linux" } {
	return 1
    }
    return 0
}

if { [is_unix] } {
    set autoraise 0
} else {
    set autoraise 1
}

proc myraise { W } {
    global autoraise
    if { [is_windows] || $autoraise } {
	raise $W
    }
}

if { [is_windows] } {
    set ini tkmame.ini ; # ini file
} else {
    set ini .tkmamerc
}

# Check for presense of working directory
set space " "
set slashspace "\\ "

proc replace { data_string search replace } {
    set len [string length $data_string]
    for { set i 0 } { $i <= $len } { incr i } {
	set char [string index $data_string $i]
	if { [string compare $char $search] == 0 } then {
	    set left  [string range $data_string 0 [expr $i - 1]]
	    set right [string range $data_string [expr $i + 1] end]
	    set data_string "$left$replace$right"
	    set rlen [string len $replace]
	    if { $rlen > 1 } then {
		incr i [expr $rlen - 1]
	    }
	}
    }
    return $data_string
}

if { [is_windows] } {
    set wd [pwd]
} else {
    set wd [file join [replace $xmame_working_dir $space $slashspace] tkmame]
}

if { ![file isdirectory $wd] } { 
    file mkdir $wd
}
if { ![file isdirectory [file join / $wd notes]] } {
    cd $wd
    file mkdir notes
}
if { ![file isdirectory [file join / $wd config]] } {
    cd $wd
    file mkdir config
}
if { ![file isdirectory [file join / $wd tmp]] } {
    cd $wd
    file mkdir tmp
}


# this centers a window on the screen
proc center_window { window } {
    update
    set x [expr ([winfo screenwidth .] / 2) - ([winfo width $window] / 2)]
    set y [expr ([winfo screenheight .] / 2) - ([winfo height $window] / 2)]
    wm geometry $window +$x+$y
    update
}

# dialog to get a valid executable file
proc get_executable { } {
    global exe bypass_notice t
    set bypass_notice 0
    set exe ""
    toplevel .dialog
    set top .dialog
    wm withdraw $top
    set frm $top.frm
    frame $frm -bd 5 -relief ridge
    frame $frm.frm0 
    label $frm.frm0.label -text $t(0001)
    frame $frm.frm1 -bd 1 
    set frm1 $frm.frm1
    entry $frm1.entry -textvariable mame_exe -width 30 
    if { [is_windows] } {
      $frm1.entry configure -state disabled
    } else {
      focus $frm1.entry
    }
    button $frm1.browse -text $t(0002) -command { 
	if { [is_windows] } {
#		{ $t(0003) { .exe .EXE } }
	    set file_types {
		{ "Executable Files" { .exe .EXE } }
	    }
	} else {
#		{ $t(0004) { "*" } }
	    set file_types {
		{ "All Files"  * }
	    }
	}
	if { [info exists mame_basedir] } {
	    set initial_dir $mame_basedir
	} else {
	    set initial_dir [pwd]
	}
	set mame_exe [tk_getOpenFile -initialdir $initial_dir -title $t(0005) \
		-filetypes $file_types]
	raise .dialog
    }
    set frm2 $top.frm.frm2
    frame $frm2 
    button $frm2.okay -text $t(0006) -command {
	if { ( $mame_exe != "" ) && [file executable $mame_exe] } {
	    set exe $mame_exe
	    destroy .dialog
	} else {
	    tk_messageBox -title $t(0007) -type ok -icon error \
		    -message $t(0008)
	}
    }
    button $frm2.cancel -text $t(0009) -command { 
	set exe ""
	destroy .dialog
    }
    pack $frm.frm0.label -anchor w 
    pack $frm.frm0 -fill x
    pack $frm1.entry -anchor w -fill x -padx 5 -side left -expand 1
    pack $frm1.browse -side left -padx 5 -anchor e
    pack $frm1 -fill x -anchor w
    pack $frm2.okay $frm2.cancel -side left -fill both -padx 5 \
	    -pady 5 -expand 1
    pack $frm2 -fill both -expand 1
    pack $frm -fill x -anchor w -expand 1
    focus $frm2.okay
    bind $top <Key-Return> {
	if { ( $mame_exe != "" ) && [file executable $mame_exe] } {
	    set exe $mame_exe
	    destroy .dialog
	} else {
	    tk_messageBox -title $t(0007) -type ok -icon error \
		    -message $t(0008)
	}
    }
    if { [is_windows] } {
      wm overrideredirect $top 1
    }
    center_window $top
    wm deiconify $top
    myraise $top
    wm minsize $top [winfo width $top] [winfo height $top]
    tkwait window $top
    return $exe
}

# get the mame executable from the ini file or if the ini file doesn't
# exist, have user select the default executable and write a new ini
# file
set wf [file join / $wd $ini] ; # working file
if { [file readable $wf] && [file isfile $wf] } {
    set ini_fd [open $wf r]
    if { [gets $ini_fd mame] == -1 || ![file executable $mame] } {
	close $ini_fd
	set mame [get_executable]
	if { $mame == "" } { exit }
	set ini_fd [open $wf w]
	puts $ini_fd $mame
	close $ini_fd
    }
} else {
    set mame [get_executable]
    if { $mame == "" } { exit }
    set ini_fd [open $wf w]
    puts $ini_fd $mame
    close $ini_fd
}

set doc_file ""
proc doc_exists { docdir doc } {
    global doc_file

    if { [is_unix] } { set delimeter ":" } else { set delimeter ";" }
    foreach dir [split $docdir $delimeter] {
	set filename [file join / $dir $doc]
	if { [file exists $filename] } {
	    set doc_file $filename
	    return 1
	}
    }
    return 0
}

# put up a splash screen

proc splash_create { image product copyright msg } {
    global tcl_version tk_version tcl_platform tcl_patchLevel

    splash_remove
    toplevel .splash
    wm withdraw .splash
    wm overrideredirect .splash 1    
    set frm .splash.top
    frame $frm -bd 2 -relief groove -bg white
    label $frm.logo -image $image -background white
    label $frm.product -text "$product" -background white -foreground blue
    message $frm.copyright -text "$copyright" -width 3i -background white \
	-foreground blue
    label $frm.tclversion -background white -foreground blue -text \
	"Tcl $tcl_version/Tk $tk_version, $tcl_patchLevel"
    label $frm.osversion -background white -foreground blue -text \
	"$tcl_platform(os) $tcl_platform(osVersion)"
    pack $frm.logo -side top -fill x -pady 4 -ipadx 4 -ipady 4
    pack $frm.product $frm.copyright $frm.tclversion $frm.osversion \
	-side top -fill x
    pack $frm -side top -fill x -padx 8 -pady 4
    set frm .splash.bottom
    frame $frm -bd 2 -relief groove -background white
    label $frm.msg -background white -foreground red -text "$msg" -anchor w
    pack $frm.msg -side top -ipadx 6 -ipady 4
    pack $frm -side bottom -fill x -padx 8 -pady 4
    dialog_position .splash
    wm deiconify .splash
    update
}

proc splash_update { msg } {
    set name .splash.bottom.msg
    if { [winfo exists $name] } {
	$name config -text "$msg"
	update
    }
}

proc splash_remove { } {
    if { [winfo exists .splash] } { destroy .splash }
}

proc dialog_position { dlg } {
    set width  [winfo screenwidth  .]
    set height [winfo screenheight .]
    set x [expr ($width/2)  - 260]
    set y [expr ($height/2) - 260]
    wm geometry $dlg +$x+$y
}

# this is the base64 uuencoded gif image from my web page
set tkmame_logo "
R0lGODlhHAKWAKUAAP////+qqv9ycv9VVf85Of8AAP/Hx/+Ojv8dHf/j42gT
qlUAquyXquPj/46O/wAA/zk5/zgAx6qq/1VV/7NeqnJy//VLVcfH/6oAVR0d
/404qo0AcnEAjsYAOeIAHcwGOYFl4xwA4+gGHemxx9mEqvgWHdkvVXJyco6O
jsfHxzk5OaqqquPj41VVVQAAAB0dHf//////////////////////////////
/////////////////////////////////yH5BAEKAD8ALAAAAAAcApYAAAb+
QIBwSCwaj8ikcslsOp/QqHRKrVqv2Kx2y+16v+CweEwum8/otHrNbrvf8Lh8
Tq/b7/i8fs/v+/+AgYKDhIWGh4iJiouMjY6PkJGSk5SVlpeYmZqbnJ2en6Ch
oqOkpaanqKmqq6ybAQECAwMEBbW2t7KyrwGtvb6/hgYHAwi3xsfItwQDAgEG
wNDR0mwBxMnX2NfLB7zT3t/gUwYC2eXm1wgD3OHs7eEHtOfy88fp6+74+agH
xfT+/7fsdZOTIIG+gwjHGOgHsKHDAgLZJIBXYGDCixirJBjwsKPHWsycjYEV
r9aBjChTOjnwsaXLArpEanw1K9kAlThzDtn4sqf+T5i5mu0amsuauZs6k2Zc
2FGW0FcGmRgYCqvoz6u2LCrdii8AwJDPykx9NSwXVnPpBgwNy7VtO47z1LGt
k4BqgLJF8zL0R2Cu27/u4JZD0KzT3ZIwASvGJxjbAL+cEjAksLhyOK/YEByI
CkryLchPEsQSANqyaUqYkWkutReBxtZaT8uGlDrgyVIscVWpbYsA59nAGSU4
drvUcGOxn/C+VTy4c0STf5MiZ6x0k+XKpD/fDghuc1PIrmQTwL18ILjk94W3
kg2p+fd7BCcPtRekeMfw8+fxXIt0mqnWwWEAMu5RUY5+CNoxYEACaLfFVLFA
FCAcjdlS4BQHJqghQfX+FUDAKxMusYssrX13h033YePghiyiIdpgecVoVnsh
xoFdYuxlM1+LPJYhWocfEVDYH9Qdc6EU5ezY45Jj1DWjP2lxU+MdQOJYRYXH
KMnklhLZpWUgxxF4BZbIcWkmSjdaSQWZt3x55pvesKnmFHLW4iaceAKDmDFH
RlFnRXkGyg5+Vvx5p6CInrIgioXqmOijwKTp4ZiOQmopK0UmQ6mKl3aayp+b
XuPpqKbseUyompKqaigZJtGABLDCagSopFwwQQYPPABBBResmmerQkjgwAQQ
5GrssblOUIEEFmQzSgPFIpsrBL36auai1wRwQQXRSuvtsRg4C0VVFioiAa7+
3+ZagbVcSlqLAunGa+wC4jLxozEIrPjEsNFmUEEDalQgr7EZAMxuj+4WsMDA
8dKLzXUd5nvFBN5mkAbFDBtr8MEsZprMwhl767CoS5Dp28TprltGAxiH/IDK
HG/4p8IuSzsyMhYowR+fWLT87cZidFtztTEnOPMCGSgLK9FDvCqwzdhgIAES
O7fZ88ATkIHxBMS6DEHRGlZ5CwNQOCD0zcdg8MDURVRdy8koM8y0FxjDfAG6
coOtXwPmHDrEBdGibYzaaxPhdgEmTvF0Bnh/+zUYDuRqcRE+x5u13u9F3jcV
DmQg+C2EFyyE2whMuYQEkjcQubxza3GBsWxTnjH+0JgHB+0DEWxORQMaRE0w
AG73OcXruVY7MMxbNIDu5UYozzDytc+Geq6fZ2mFpISru6ffSjhfuBBPx0v7
1bmOP8TqA5sf/WI+U6A7FZJuAG5A+koRLfLExwv9FdM/4MASjUvX/9Znmtsl
qwEzA1SOPmascPWmflF4GvOGEEBpTS4L3rtgEvoXLw0SEDB3k1y1Esg9I2AD
ZA60zxaIJ7oioC9dsbtC+Fp3BKHB8IOK6R/yxGa1BSJjYSksAAbUNwXv0bAB
WMtC/h7HhPzFi4k45Mr0MjC3c0CQCdjgQAdu4YEHTDBu+xuCDb1FxCd0q4xF
GCMZo8gVCdIOWw9LkTn+PLCBBdBQClNUwgu/NcAq6BAKTkwZG5VStyMkDCJY
+MpmrICuOwoBifKC4hTwhkYjVNCCg9QJxmJIBI8xygo8LIeQTDeEp4Uxjemr
Avr6uC+GcTKTFxFYC4+QwMT5ySOEmRILK7lHb7EyCujy4BMuiawvwhIhqJvl
Ec5BSiQkUB7p0FK0fokESD6Rc8aiphPCJ75jXiSZZQxTZrLwTH+oQzvTk6QS
1IgsKgSzCtaMlza9yQ5wisgc6UGVT6IZlUY+gZvfeiUTVmmFynlLnfTESQKv
2ITcIOMDL0GACRawAIQmIZDeMiYT3mkFjK4xoUkJ5aSykCYQPECL+5QFN7z+
9AoKDiwKBL0CMY81T5BeBI7JYOh1kkEAa4ZgAx44CzJuY1BpOfIIHJXhwCxq
04R48hj5xMKNTmLDBWxRqOUCAAe/dcojoK+rUIhnuirZVHeEkjJcSAYveom7
DWBVgQBY6jA1pgV20rSsKMEpvnT6hFSJ9Vgh4IAIsBJVuxrLCfkDK0zliteL
HI5+XkgVAAz7gBGYqiMI0ApAvSVQI7TsqFH460cbe5DLPvALpnKNENh6rKlN
RKTniOrfkrgEazKVCpT1H2n18Vhb2JKcRpqt5YgwDthmKwkDE6YR0NdZPzJ2
t4G5RoPE4MkCvdQI4zAtTxeZhKIiC43d+gLDyAr+3V44VBncHUmZhuBdYx2V
BBzAAAZKgK+QMJS1d3WVsRSL24E1t7zAEAxhAsBXLSSgJL/Bb65qOtlpYcGj
xVRC/0CLTXlpFMDQGIuACFyErUrrwgCwJoOfwDAlYEy5GCwxhrl03SOEj7xL
aK97kauuMOT2vytG0Exz1Vlj3RYKHpbWKfsHYykoOFk5ZpKMX+bVbGpBtMiy
6OLEAOFjoTjJCDoyQltWZACm0pI1FsOOi4dlHgW5nUbwMReWrNsi5I/CSpUX
f8vMHSi31s375cKZj2VM9JFhz2qmM4uO58IZJ0/FRIgWiLkwXkFviLIeDG8X
xvw9IeQPx1pg84gd/Rz+Nm/MmoumApsn+OIyHFlXnE7QZqUVu5jqGdEASOoY
7HysLusZVhXgmq4nACtbg8FpSsPEBXC9a2XBWVCARrIQ8HbssLpytcYKNRco
jWkuXGBYlJYcr7v8qqVZgWUZbXbzcj2tCYhbDMBm2AR8zaVk58rSxwIDpS+H
t01vYdURJoOtaiYtCNSU2Jec83I7aOsG4LvaYdhWtpGlzE49u1vSpgK+v/tC
hGfB3Q9AdwUWnrEwzjsKbP6xEc413DQYnOMBJdXzOGjvKWB84/FGw7O9YHB+
Z6zhAOicnJ/A5jA3AeMRd11ub87uJeWWcXcGg83TkNuglw3lNhfoxMnMhJ7+
G/p0IXM6PIfuMpwnyuoxBwPXo52GU2c8eWO3eZ6PAGiRm93KaJw6Z8Vgdq7F
6u65Drin5I7JMPA932eoctKxQHK1l7vRSJj6UTH+YRNH/QvgTpe/QFt4ZFnc
TIwne8JrdnktfJzwNt+VBMwngVWHeqYg9p6uhpWxzoYPAsIK2bmZoHoL2hu/
o8r8gsfAeTX0HPRddwBZM7oEBauv3uydnRHy18K3e313qK+kAb0lcDj1Xgxg
r/QZMN75Dnvt8nPvnjyP0LIY1l7yYOZxoome6RvWdurPT1TNiu4E3bNB3fAM
WQY6z1ZM29WYf1QEtHYsyBM+X3R+6IcF+MVfOif+efS3JNlHBgOIZmowdFXA
dS1HBBCGaVMngL/TZDPXPziXeVp3BHZ2W9uSXA8IgfpXBmPHBmaXgUSAcRBg
a3smbYAWO6rnSEO3f9w0T2BXgt73LTR0bUMng3lCgqYWMmwgeIEGcoQWBYBT
cuInSELQMrc1gRWjBBwnhMJlQQAzbKVndf6ygluihPrGhGyQbba2Y/sXBRKQ
WyIXVwnoM6D1dvmFBE4YZexmeBnVfYgSMoA4SRnTBj1XfUNAcE+gOhzXBIYl
AT4zZ2l3dnrUdb7mh9E2iImycJoYQYXIBhh3ZTRGfEwgLFzDb5UEdqJIBFqo
eTFWM0gIANlXTJ34KFb+N3tUsIfv1gYZY3ckVjFEZISYyIGC+ASZV20IKC8Z
wGBx2Ec9BwFcsywSMHsNYIYa8nZokG1ukH3xRwRPJI2w0jWY6GRYxzBzSARW
h3DJqIy8Vi3h6IqAxitWYIrq1ym6SIll8HdugIeS0wTjaHjSdo+dt44U+HP/
CHiCJ49hVXpjVIst8olmoIVu0IrHQmGz6DXtFXEMs4p6iHj1d5CuSIcdtCwX
NYY7hotKRltncGpvMIkWCZLIMkDExJENJi+xGCz+BYcwyTSzqGs1Q5N4sode
eAWU9Qb8iI8bBJMHlHxbOFDKaAVyh4g4+Y/Qc4+YaI0sIndD+W3ygpXuFDL+
AneR6UItskOKtSUvtbhkNjiO2jSJP4mSXEKQXrQGOfgGcvmBTuCW/aZN3iVw
E3eOxUeFgAR1BHNHd6l2ZWgtdbkG7QWXXNCA39KNy+eHZIkE3kVeySiZxjhT
gBh5+jdiumeODnkmdjWaRXRJW/kFCsdwN7lvXiN8gclwl4eApjkEkNhvRTeF
ydVyIYSJEwCbYCOMx1KDbXByBHOTppY0DuCYIQaJMwWNo+cEGfSbvgaZtTly
w6KQV7CaFqSdxkhuIQONyxlFYuiV0iCGsWKeRRSdg3B3zKmBd+cA4CgrqVaf
9nmf+Jmf+rmf/Nmf/vmfo3ACQ4ACKSAEKVCgQoD+Agm6oFCgoE7AAifQAi2A
oA5qBBVqoAjKBAcaBSnQAifAAgCwoQD6HieAoCrgoCU6oELQAisaBSzaBCsw
oQkqoC9qoUWwAivgBDjqogDAAiy6oyNqHiugoBCqAkJgpCiAowTaAi8goU1a
oCjgoSCaAlHaAjk6BBMqoQq6AgiaAlcKAEZKBDmqAhEqoACAAh+qoBE6pCpw
omcqoRRapQW6AhFqpUIAoS3goEn6pTWKAm2qoHIqBCdQpgMqpUHqFkgaoz3K
onb6oo66ojmaAi/AAooKAC0Aoit6qWf6oWGqApgKpEUwqQAwpAAgqlaqpqOa
oyfgoDLqAkQ6oZV6qSz+4KlnaqR2OgQr4KapCgCruqIFKqqkaqeSiqmHqhSM
eqZDmqOPaqktmgIqgKN0Cq1CAKo1yqyyGqa7agQ1eqyWOqsfuqvVyq2QeqU4
OqjQaqtHEKXgSgTiOqHPWq5fWqw6kaRGiqctyqz4yqLOCq0rQKnkyqdEYKQp
MKgZCqY3iq/Weq/OuqvYmrB3aqX/aq7SWq0sgKk/OqbsirDuyq/EKq85wQKu
eqTLOrK+2qOeCqTUqqloeqQNO6oqUKAQqqxYmq87erG8yqoFGrI+6qX/6qMg
qqjVurA+uqu9aqkFuq1Ga7Id67E4IaPIyqB6yqBv+q0iKqJn2qF5OgRFSwRQ
eOq0FQqoCxqhBVq1cLqigVq1MBuhUUsEHUq1XVq2Z6qiU7u0TMslLSsG1Vq3
ZcUCFzoGfau3gBu4gju4hFu4hnu4iJu4iru4jNu4jjsEQQAAOw==
====
"

image create photo tkmame -data $tkmame_logo
splash_create tkmame "TkMAME $ver" $t(0279) $t(0278)
.splash configure -cursor watch


if { [is_unix] } {
    set mamecfg [file join / $wd tkxmamerc]
    catch { exec $mame -showconfig -stdout-file $mamecfg }
    set fd [ open $mamecfg r ]
    gets $fd output
    if { ![regexp {0\.([0-9][0-9])} $output x version] } {
	set version 34
    }
    close $fd
} else {
    regexp {0\.([0-9][0-9])} [lindex [split [exec $mame -help] \n] 0] x version
}

splash_update $t(0281)

# get all available ROMs
set output ""

proc quote_string { str } {
    return "\"${str}\""
}

if { [is_windows] } {
    set qmame [quote_string $mame]
    set qwd [quote_string $wd]
}

catch {
  set listfull [file join / $wd tmp full]
  if { [is_unix] } {
      eval exec $mame -listfull -stdout-file $listfull
  } else {
      set cmd "$qmame -listfull > [quote_string $listfull]"
      eval exec $cmd
  }
}
catch {
  set fd [open $listfull r]
  set output [read $fd]
  close $fd
}
foreach rom [split $output \n] {
    if { [string match {Name:*} $rom] } { continue } ; # not a rom
    if { [string match {Total*} $rom] } { continue } ; # not a rom
    if { $rom == "" } { continue } 
    if { [regexp {([a-z0-9_]*)[ ]*(.*)$} $rom temp rom_name rom_desc] } then {
	set rom_name [string trim $rom_name]
	set rom_desc [string trim $rom_desc "\" "]
	set rom_descriptions($rom_name) $rom_desc
	set rom_images($rom_desc) $rom_name
	lappend list_of_all_roms $rom_name
    } else {
 	tk_messageBox -title $t(0007) -type ok -icon error \
		-message "$t(0011) $qmame -listfull"
	exit
    }
}

splash_update $t(0282)

set output ""
catch { 
  set listclones [file join / $wd tmp clones]
  if { [is_unix] } {
      eval exec $mame -listclones -stdout-file $listclones
  } else {
      set cmd "$qmame -listclones > [quote_string $listclones]"
      eval exec $cmd
  }
}
catch {
  set fd [open $listclones r]
  set output [read $fd]
  close $fd
}

foreach clone [split $output \n] {
    if { [string match {Name:*} $clone] } { continue } ; # not a rom
    if { [regexp {([a-z0-9]*)[ ]*([a-z0-9]*)} $clone x c_name o_name] } {
	set c_name [string trim $c_name]
	set o_name [string trim $o_name]
	set clones($c_name) $o_name
    } else {
	tk_messageBox -title $t(0007) -type ok -icon error \
		-message "$t(0011) $mame -listclones"
	exit
    }
}

# reads in a field from config file
proc read_config { fd str } {
    seek $fd 0 start
    while { [gets $fd data] >= 0 } {
	if { [is_unix] } {
	    if { ([string range $data 0 0] == "#") || ($data == "") } {
		continue
	    }
	    set lhs [string trim [lindex [split $data " \t"] 0]]
	    set lhs [string tolower $lhs]
	    if { $lhs == [string tolower $str] } {
		set rhs [string trim [lindex [split $data " \t"] end]] 
		return $rhs
	    }
	} else {
	    if { [string tolower [string trim [lindex [split $data =] 0]]] \
		     == [string tolower $str] } {
		 set first [expr [string first = $data] + 1]
		 set last [string length $data]
		 set rhs [string range $data $first $last]
		 return [string trim $rhs]
	    }
	}
    }
    return ""
}

# Try to open mame.cfg
set mame_basedir [file dirname $mame]
set mame_basedir_esc [replace $mame_basedir $space $slashspace]

if { [is_windows] } {
    set mamecfg [file join / $mame_basedir mame.cfg]
    set qmamecfg [quote_string $mamecfg]
}
if { ![file isfile $mamecfg] } {
    tk_messageBox -title Warning -type ok -icon warning -message $t(0013)
    set rom_path "$mame_basedir;$mame_basedir/ROMS"
    set mamecfg_fd ""
} else {
    set mamecfg_fd [open $mamecfg r]
    set rom_path [read_config $mamecfg_fd rompath]
    if { [is_unix] } {
	set newrompath ""
	foreach dir [split $rom_path :] {
	  set dir [string trim $dir]
	  append newrompath "$dir/roms:"
	}
	set rom_path [string trimright $newrompath :]
    }
    if { $rom_path == "" } {
	set rom_path "$mame_basedir;$mame_basedir/ROMS"
    }
}

if { ![info exists list_of_all_roms] } {
  tk_messageBox -title $t(0007) -type ok -icon error -message $t(0014)
  exit
}

splash_update $t(0283)

# get list of available roms and build array of missing roms
array set missing_roms [array get rom_descriptions]
if { [is_windows] } { set delimeter \; } else { set delimeter : }
set all_groups [list {All ROMs}]
set user_groups [list {All ROMs}]
set year_groups [list {All ROMs}]
set manu_groups [list {All ROMs}]
set color_groups [list {All ROMs}]
set wori_groups [list {All ROMs}]

foreach dir [split $rom_path $delimeter] {
    set dir [string trim $dir]
    if { [is_windows] } {
	set dir [file join / $mame_basedir $dir]
	if { [file isdirectory $dir] } {
	    cd $dir
	}
	set files [glob -nocomplain *]
    } else {
	if { [file isdirectory $dir] } {
	    cd $dir
	    set files [glob -nocomplain *]
	} else {
	    set trimpoint [expr [string length $dir] - 5]
	    set newdir [string range $dir 0 $trimpoint]
	    if { [file isdirectory $newdir] } {
		cd $newdir
		set files [glob -nocomplain *]
	    } else {
		set files ""
	    }
	}
    }
    if { ![info exists files] } {
	tk_messageBox -title $t(0007) -type ok -icon error -message $t(0015)
	exit
    }
    foreach file $files {
	set file [string tolower [string trim $file]]
	if { [file isdirectory $file] && \
		 ( [lsearch $list_of_all_roms $file] != -1 ) } {
	    if { [lsearch [array names missing_roms] $file] != -1 } {
		append your_roms "$rom_descriptions($file)\n"
		lappend list_of_your_roms $file
		unset missing_roms($file)
	    } else {
		append duplicate_roms "$file, "
	    }
	} elseif { [regexp -nocase {(.*)\.\z\i\p} $file tmp rom] \
		       && ( [lsearch $list_of_all_roms $rom] != -1 ) } {
	    if { [lsearch [array names missing_roms] $rom] != -1 } {
		append your_roms "$rom_descriptions($rom)\n"
		lappend list_of_your_roms $rom
		unset missing_roms($rom)
	    } else {
		append duplicate_roms "$file, "
	    }
	} elseif { $file != "dir.txt" } {
	    append unknown_roms "$file, "
	}
    }
    cd $wd
}

if { ![info exists list_of_your_roms] } {
  tk_messageBox -title $t(0007) -type ok -icon error -message $t(0015)
  exit
}

# make clones and noclones groups
set noclones "No Clones"
set noneogeo "No NeoGeo"
lappend all_groups $noclones Clones NeoGeo $noneogeo
lappend user_groups $noclones Clones NeoGeo $noneogeo
set groups(No\ Clones) ""
set groups(Clones) ""
set groups(NeoGeo) ""
set groups($noneogeo) ""
foreach rom [split $your_roms \n] {
    if { $rom != "" } {
	if { [info exists clones($rom_images($rom))] } {
	    if { $clones($rom_images($rom)) == "neogeo" } {
		append groups(NeoGeo) "\n$rom"
	    } else {
		append groups(Clones) "\n$rom"
		append groups($noneogeo) "\n$rom"
	    }
	} else {
	    append groups($noclones) "\n$rom"
	    append groups($noneogeo) "\n$rom"
	}
    }
}

# add color and wrong orientation groups
if { [is_unix] } {
    splash_update $t(0285)
    set output ""
    catch { 
	set listcolors [file join / $wd tmp colors]
	eval exec "$mame -listcolors -stdout-file $listcolors"
    }
    catch {
	set fd [open $listcolors r]
	set output [read $fd]
	close $fd
    }
    foreach l [split $output \n] {
	if { [string match {Name:*} $l] } { continue } ; # not a rom
	if { [string match {Total*} $l] } { continue } ; # not a rom
	if { [string match "" $l] } { continue } ; # not a rom
	set e [string wordend $l 0]
	set r [string trim [string range $l 0 $e]]
	set c "Colors: [string trim [string range $l [expr $e + 1] end]]"
	
	if { [lsearch $all_groups $c] == -1 } {
	    lappend all_groups $c
	    lappend color_groups $c
	}
	append groups($c) "\n$rom_descriptions($r)"
    }


    splash_update $t(0286)
    set output ""
    catch { 
	set wrongorient [file join / $wd tmp wrongorient]
	eval exec "$mame -wrongorientation -stdout-file $wrongorient"
    }
    catch {
	set fd [open $wrongorient r]
	set output [read $fd]
	close $fd
    }
    foreach l [split $output \n] {
	if { [string match {Name:*} $l] } { continue } ; # not a rom
	if { [string match {Total*} $l] } { continue } ; # not a rom
	if { [string match {Found*} $l] } { continue } ; # not a rom
	if { [string match "" $l] } { continue } ; # not a rom
	set e [string wordend $l 0]
	set r [string trim [string range $l 0 $e]]
	set o "Orientation: [string trim [string range $l [expr $e + 1] end]]"
	
	if { [lsearch $all_groups $o] == -1 } {
	    lappend all_groups $o
	    lappend wori_groups $o
	}
	append groups($o) "\n$rom_descriptions($r)"
    }
}

splash_update $t(0287)

set output ""
catch { 
    set listgames [file join / $wd tmp games]
    if { [is_unix] } {
	eval exec $mame -listgames -stdout-file $listgames
    } else {
	eval exec $mame -listgames > $listgames
    }
}
catch {
    set fd [open $listgames r]
    set output [read $fd]
    close $fd
}
foreach l [split $output \n] {
    set y [string trim [string range $l 0 4] "? "]
    if { [string length $y] != 4 } { set y "Unknown" }
    set m [string range $l 5 34]
    set w 35
    if { [string range $l 34 34] != " " } {
	set w [string wordend $l 34]
	set m [string range $l 5 $w]
	incr w
    }
    set m [string trim $m]
    set m [replace [replace $m \[ ""] \] ""]
    set g [string trim [string range $l $w [string length $l]]]
    set y "Year: $y"
    if { [info exists rom_images($g)] && \
	     [lsearch $list_of_your_roms $rom_images($g)] != -1 } {
	if { [lsearch $all_groups $y] == -1 } {
	    lappend all_groups $y
	    lappend year_groups $y
	}
	if { [lsearch $all_groups $m] == -1 } {
	    lappend all_groups $m
	    lappend manu_groups $m
	}
	append groups($y) "\n$g"
	append groups($m) "\n$g"
    }
}

proc cg_desc { old_definition new_definition } {
    global your_roms
    foreach line [split $your_roms \n] {
	if { $line == "" } { continue }
	if { [string compare $line $old_definition] != 0 } {
	    append data "$line\n"
	} else {
	    append data "$new_definition\n"
	}
    }
    return $data
}

splash_update $t(0284)

proc error_dialog { title message } {
    tk_messageBox -title $title -type ok -icon error -message $message
}

proc good_file { file } {
    return [expr [file isfile $file] && [file readable $file]]
}

proc read_file { file } {
    set data ""
    catch {
	set fd [open $file r]
	set data [read $fd]
	close $fd
    }
    return $data
}

proc read_cfg_error { } {
    global t
    error_dialog $t(0007) $t(0019)
    exit
}

proc get_lhs { line delimeter } {
    set index [string first $delimeter $line]
    if { $index <= 0 } {
	return ""
    } else {
	return [string trim [string range $line 0 [expr $index - 1]]]
    }
}

proc get_rhs { line delimeter } {
    set index [string first $delimeter $line]
    if { $index <= 0 } {
	return ""
    } else {
	return [string trim [string range $line [expr $index + 1] end]]
    }
}

proc is_copy { rom } {
    return [expr [string compare [string index $rom 0] "+"] == 0]
}

proc have_rom { rom } {
    global list_of_your_roms
    return [expr [lsearch $list_of_your_roms $rom] != -1]
}

proc mame_rom { rom } {
    global list_of_all_roms
    return [expr [lsearch $list_of_all_roms $rom] != -1]
}

proc increment_copies { rom } {
    global copies t
    if { ![info exists copies($rom)] } {
	set copies($rom) 0
    } else {
	if { $copies($rom) < 9 } {
	    incr copies($rom)
	} else {
	    error_dialog $t(0007) $t(0016)
	    exit
	}
    }
}

proc add_copy { rom desc } {
    global cdesc copies rom_images rom_descriptions your_roms t
    set rom [string trimleft $rom +]
    if { [have_rom $rom] } {
	increment_copies $rom
	set cdesc($desc) $copies($rom)
	if { [info exists rom_images($desc)] } {
	    error_dialog $t(0007) $t(0018)
	    exit
	}
	set copy_rom "${rom}$copies($rom)"
	set rom_descriptions($copy_rom) $desc
	set rom_images($desc) $rom
	append your_roms "$desc\n"
    }
}

proc replace_desc { data old new } {
    foreach line [split $data \n] {
	if { $line == "" } { continue }
	if { [string compare $line $old] != 0 } {
	    append new_data "$line\n"
	} else {
	    append new_data "$new\n"
	}
    }
    return $new_data
}

proc change_description { rom desc } {
    global your_roms rom_descriptions rom_images
    set your_roms [replace_desc $your_roms $rom_descriptions($rom) $desc]
    unset rom_images($rom_descriptions($rom))
    set rom_descriptions($rom) $desc
    set rom_images($desc) $rom
}

proc add_new_rom { rom desc } {
    global list_of_your_roms rom_descriptions rom_images missing_roms \
	your_roms list_of_all_roms
    lappend list_of_your_roms $rom
    lappend list_of_all_roms $rom
    set rom_descriptions($rom) $desc
    set rom_images($desc) $rom
    if { [info exists missing_roms($rom)] } { unset missing_roms($rom) }
    append your_roms "$desc\n"
}

proc process_cfg_definition { data } {
    set rom  [get_lhs $data =]
    set desc [get_rhs $data =]
    if { [is_copy $rom] } {
	add_copy $rom $desc
    } elseif { [have_rom $rom] } {
	change_description $rom $desc
    } else {
	add_new_rom $rom $desc
    }
}

proc process_cfg_group { data } {
    global current_group groups ugroups all_groups user_groups uc_groups
    if { [info exists current_group] && $groups($current_group) == "" } {
	set all_groups [lreplace $all_groups end end] 
    }
    set group [string trim $data \[\]]
    if { $group != "" } {
	if { [lsearch $all_groups $group] == -1 } {
	    lappend all_groups $group
	    lappend user_groups $group
	    set groups($group) ""
	    set ugroups($group) ""
	    incr uc_groups
	}
	set current_group $group
    }
}

proc add_rom_to_group { rom } {
    global copies rom_descriptions groups ugroups current_group
    if { [have_rom $rom] } {
	append groups($current_group) "\n$rom_descriptions($rom)"
	append ugroups($current_group) "\n$rom_descriptions($rom)"
	if { [info exists copies($rom)] } {
	    for {set i 0} {$i <= $copies($rom)} {incr i} {
		append groups($current_group) "\n$rom_descriptions($rom$i)"
		append ugroups($current_group) "\n$rom_descriptions($rom$i)"
	    }
	}
    }
}

proc process_cfg_other { rom } {
    global uc_groups list_of_your_roms missing_roms your_roms unknown_roms \
	rom_descriptions
    if { $rom != "" } {
	if { [mame_rom $rom] } {
	    if { $uc_groups } {
		add_rom_to_group $rom
	    } elseif { [have_rom $rom] } {
		lappend list_of_your_roms $rom
		if { [info exists missing_roms($rom)] } {
		    unset missing_roms($rom)
		}
		append your_roms "$rom_descriptions($rom)\n"
	    } else {
		append unknown_roms "$rom, "
	    }
	}
    }
}

proc read_cfg { file } {
    if { ![good_file $file] } { return }
    set data [read_file $file]
    if { $data == "" } { read_cfg_error }
    foreach line [string trim [split $data \n]] {
	switch -glob $line {
	    \#* { continue }
	    *\=* { process_cfg_definition $line }
	    {\[*\]} { process_cfg_group $line }
	    default { process_cfg_other $line }
	}
    }
}

set uc_groups 0
read_cfg [file join / $wd $rom_config_file]
set your_roms [string trim $your_roms \n]

if { [info exists duplicate_roms] } {
    set duplicate_roms [string trimright $duplicate_roms ", "]
}
if { [info exists unknown_roms] } {
    set unknown_roms [string trimright $unknown_roms ", "]
}

# if you dont have any roms, just exit
if { ![info exists your_roms] } {
    tk_messageBox -title $t(0007) -type ok -icon error -message $t(0019)
    exit
} else {
    set your_roms [string trimright $your_roms \n]
}

splash_update $t(0288)

# make a sorted list of your roms, and a sorted lower-case list of your roms
set slyroms [lsort -dictionary [split $your_roms \n]]
set sllyroms [lsort -dictionary [split [string tolower $your_roms] \n]]

# set up clean up routine for exiting
proc my_exit { } {
    global mamecfg_fd wd list textedit myfont t def autoraise
    if { $mamecfg_fd != "" } { close $mamecfg_fd }
    set current_index [$list curselection]
    set geometry_file [file join / $wd tkmame.geo]
    set fd [open $geometry_file w]
    puts $fd "font create myfont [font actual myfont]"
    puts $fd ".frame.list configure -font myfont"
    puts $fd "set def(activeBackground)    $def(activeBackground)"
    puts $fd "set def(activeForeground)    $def(activeForeground)"
    puts $fd "set def(background)          $def(background)"
    puts $fd "set def(disabledForeground)  $def(disabledForeground)"
    puts $fd "set def(foreground)          $def(foreground)"
    puts $fd "set def(highlightBackground) $def(highlightBackground)"
    puts $fd "set def(highlightColor)      $def(highlightColor)"
    puts $fd "set def(insertBackground)    $def(insertBackground)"
    puts $fd "set def(selectColor)         $def(selectColor)"
    puts $fd "set def(selectBackground)    $def(selectBackground)"
    puts $fd "set def(troughColor)         $def(troughColor)"
    if { [info exists autoraise] } {
	puts $fd "set autoraise $autoraise"
    } else {
	if { [is_windows] } {
	    puts $fd "set autoraise 1"
	} else {
	    puts $fd "set autoraise 0"
	}
    }
    if { $current_index == "" } {
	puts $fd ".frame.list selection set 0"
	puts $fd ".frame.list activate 0"
	puts $fd ".frame.list see 0"
    } else {
	puts $fd ".frame.list selection set $current_index"
	puts $fd ".frame.list activate $current_index"
	puts $fd ".frame.list see $current_index"
    }

    set geo [winfo geometry .]
    if { [is_unix] } {
	if { [regexp {([0-9]+)\x([0-9]+)\+([0-9]+)\+([0-9]+)} $geo tmp wval \
		  hval xval yval] != -1 } {
	    incr yval -24
	    incr xval -4
	    set geo "${wval}x${hval}+${xval}+$yval"
	 }
    }
    puts $fd "wm geometry . $geo"

    set geo [winfo geometry .graphics]
    if { [is_unix] } {
	if { [regexp {([0-9]+)\x([0-9]+)\+([0-9]+)\+([0-9]+)} $geo tmp wval \
		  hval xval yval] != -1 } {
	    incr yval -24
	    incr xval -4
	    set geo "${wval}x${hval}+${xval}+$yval"
	}
    }
    puts $fd "wm geometry .graphics $geo"
    if { [winfo ismapped .graphics] } then {
	puts $fd "set graphics_check on"
	puts $fd "set graphics_mapped 1"
    }
    
    if { [winfo ismapped .options] } then {
	puts $fd "set options_check on"
	puts $fd "set options_mapped 1"
	set geo [winfo geometry .options]
	if { [is_unix] } {
	    if { [regexp {([0-9]+)\x([0-9]+)\+([0-9]+)\+([0-9]+)} $geo tmp \
		      wval hval xval yval] != -1 } {
		incr yval -24
		incr xval -4
		set geo "${wval}x${hval}+${xval}+$yval"
	    }
	}
	puts $fd "wm geometry .options $geo"
    }
    
    if { [winfo exists .edit ] && [winfo ismapped .edit] \
	    && ( $textedit(save_name) != "Untitled" ) } {
	puts $fd "view_file $textedit(save_name)"
	set geo [winfo geometry .edit]
	if { [is_unix] } {
	    if { [regexp {([0-9]+)\x([0-9]+)\+([0-9]+)\+([0-9]+)} $geo tmp \
		      wval hval xval yval] != -1 } {
		incr yval -24
		incr xval -4
		set geo "${wval}x${hval}+${xval}+$yval"
	    }
	}
	puts $fd "wm geometry .edit $geo"
	puts $fd "set edit_mapped 1"
    }
    close $fd
    exit
}

# translate yes and no strings to 0 and 1 (for windoze only)
proc yes { str } {
    if { [is_windows] } {
	if { $str == "yes" } { return 1 } else { return 0 }
    } else { 
	if { $str == "" } { return 0 } else { return $str }
    }
}

proc read_default_boolean { parameter fd } {
    if { $fd == "" } {
	return 0 
    } else {
	return [yes [read_config $fd $parameter]] 
    }
}

proc read_default_string { parameter fd } {
    if { $fd == "" } {
	return ""
    } else {
	return [read_config $fd $parameter]
    }
}


# gets default values from a file
proc read_default { param fd } {
    global p version

    if { [is_windows] } {
	switch $param {
	    scanlines    { return [read_default_boolean $param $fd] }
	    vsync        { return [read_default_boolean $param $fd] }
	    waitvsync    { return [read_default_boolean $param $fd] }
	    triplebuffer { return [read_default_boolean $param $fd] }
	    alwayssynced { return [read_default_boolean $param $fd] }
	    vesa         { return [read_default_boolean $param $fd] }
	    ntsc         { return [read_default_boolean $param $fd] }
	    ym3812opl    { return [read_default_boolean $param $fd] }
	    ym2203opl    { return [read_default_boolean $param $fd] }
	    romdir       { return [read_default_string  $param $fd] }
	    double {
		if { $fd == "" } {
		    return [lindex $p(doubles) 0]
		} else {
		    set tmp [read_config $fd double]
		    if { $tmp == "yes" } {
			return [lindex $p(doubles) 1]
		    } elseif { $tmp == "no" } {
			return [lindex $p(doubles) 2]
		    } else {
			return [lindex $p(doubles) 0]
		    }
		}
	    }
	    vgafreq {
		if { $fd == "" } {
		    return [lindex $p(vgafreqs) 0]
		} else {
		    set tmp [read_config $fd vgafreq]
		    if { [lsearch $p(vgafreqs) $tmp] != -1 } {
			return $tmp
		    } else {
			return [lindex $p(vgafreqs) 0]
		    }
		}
	    }
	    depth {
		if { $fd == "" } {
		    return [lindex $p(depths) 0]
		} else {
		    set tmp [read_config $fd depth]
		    if { [lsearch $p(depths) $tmp] != -1 } {
			return $tmp
		    } else {
			return [lindex $p(depths) 0]
		    }
		}
	    }
	    vesamode {
		if { $fd == "" } {
		    return [lindex $p(vesamodes) 2]
		} else {
		    set tmp [read_config $fd vesamodes]
		    if { [lsearch $p(vesamodes) $tmp] != -1 } {
			return $tmp
		    } else {
			return [lindex $p(vesamodes) 2]
		    }
		}
	    }
	    stretch {
		if { $fd == "" } {
		    return [lindex $p(stretches) 0]
		} else {
		    set tmp [read_config $fd stretch]
		    if { [lsearch $p(stretches) $tmp] != -1 } {
			return $tmp
		    } else {
			return [lindex $p(stretches) 0]
		    }
		}
	    }
	    skiplines {
		if { $fd == "" } {
		    return 0
		} else {
		    set tmp [read_config $fd skiplines]
		    if { ( $tmp >= -255 ) && ( $tmp <= 255 ) } {
			return $tmp
		    } else {
			return 0
		    }
		}
	    }
	    skipcolumns {
		if { $fd == "" } {
		    return 0
		} else {
		    set tmp [read_config $fd skipcolumns]
		    if { ( $tmp >= -255 ) && ( $tmp <= 255 ) } {
			return $tmp
		    } else {
			return 0
		    }
		}
	    }
	    soundcard {
		if { $fd == "" } {
		    return [lindex $p(soundcards) 0]
		} else {
		    set tmp [read_config $fd soundcard]
		    if { ( $tmp >= -1 ) && ( $tmp <= 7 ) } {
			incr tmp
			return [lindex $p(soundcards) $tmp]
		    } else {
			return [lindex $p(soundcards) 0]
		    }
		}
	    }
	    resolution {
		if { $fd == "" } {
		    return [lindex $p(resolutions) 0]
		} else {
		    set tmp [read_config $fd resolution]
		    if { [lsearch $p(resolutions) $tmp] != -1 } {
			return $tmp
		    } elseif { $tmp == "auto" } {
			return [lindex $p(resolutions) 0]
		    } else {
			return [lindex $p(resolutions) end]
		    }
		}
	    }
	    samplebits {
		if { $fd == "" } {
		    return 0
		} else {
		    set tmp [read_config $fd samplebits]
		    if { $tmp == "16" } {
			return 1
		    } else {
			return 0
		    }
		}
	    }
	}
    } else {
	switch $param {
	    xsync          { return [read_default_boolean $param $fd] }
	    dirty          { return [read_default_boolean $param $fd] }
	    privatecmap    { return [read_default_boolean $param $fd] }
	    forcetruecolor { return [read_default_boolean $param $fd] }
	    fullscreen     { return [read_default_boolean x11-mode $fd] }
	    throttle       { return [read_default_boolean $param $fd] }
	    mitshm         { return [read_default_boolean $param $fd] }
	    dblbuffer      { return [read_default_boolean $param $fd] }
	    cabview        { return [read_default_boolean $param $fd] }
	    netmapkey      { return [read_default_boolean $param $fd] }
	    sound          { return [read_default_boolean $param $fd] }
	    fakesound      { return [read_default_boolean $param $fd] }
	    samplebits     { return [read_default_boolean 8bit   $fd] }
	    swapjoyaxis    { return [read_default_boolean $param $fd] }
	    analogstick    { return [read_default_boolean $param $fd] }
	    analogmouse    { return [read_default_boolean $param $fd] }
	    grabmouse      { return [read_default_boolean $param $fd] }
	    cursor         { return [read_default_boolean $param $fd] }
	    autoframeskip  { return [read_default_boolean $param $fd] }
	    planar         { return [read_default_boolean $param $fd] }
	    xil            { return [read_default_boolean $param $fd] }
	    mtxil          { return [read_default_boolean $param $fd] }
	    spooldir       { return [read_default_string  $param $fd] }
	    slave          { return [read_default_string  $param $fd] }
	    cabinet        { return [read_default_string  $param $fd] }
	    master         { return [read_default_string  $param $fd] }
	    x11joyname     { return [read_default_string  $param $fd] }
	    paddevname     { return [read_default_string  $param $fd] }
	    romdir         { return [read_default_string rompath $fd] }
	    scale {
		if { $fd == "" } {
		    return 1.0
		} else {
# set scale [format "%1.1f" [read_config $fd scale]]
		    set scale [read_config $fd scale]
		    if { $scale == "" || $scale == 0.0 } {
			return 1.0
		    } else {
			return $scale
		    }
		}
	    }
	    widthscale {
		if { $fd == "" } {
		    return 1.0
		} else {
		    return [format "%1.1f" [read_config $fd widthscale]]
		}
	    }
	    heightscale {
		if { $fd == "" } {
		    return 1.0
		} else {
		    return [format "%1.1f" [read_config $fd heightscale]]
		}
	    }
	    fxgamma {
		if { $fd == "" } {
		    return 1.0
		} else {
		    set tmp [read_config $fd "fxgamma"]
		    if { ( $tmp >= 0.5 ) && ( $tmp <= 2.0 ) } {
			return $tmp
		    } else {
			return 1.0
		    }
		}
	    }
	    audiodevice {
		if { $fd == "" } {
		    return "/dev/dsp"
		} else {
		    return [read_config $fd audiodevice]
		}
	    }
	    videomode {
		if { $fd == "" } {
		    return 0
		} else {
		    set tmp [read_config $fd videomode]
		    if { ( $tmp >= 0 ) && ( $tmp <= 2) } {
			return [lindex $p(videomodes) $tmp]
		    } else {
			return [lindex $p(videomodes) 0]
		    }
		}
	    }
	    timerfreq {
		if { $fd == "" } {
		    return 50
		} else {
		    return [read_config $fd timerfreq]
		}
	    }
	    numfrags {
		if { $fd == "" } {
		    return 5
		} else {
		    return [read_config $fd numfrags]
		}
	    }
	    fragsize {
		if { $fd == "" } {
		    return 512
		} else {
		    return [read_config $fd fragsize]
		}
	    }
	}
    }
    switch $param {
	profiler       { return [read_default_boolean $param $fd] }
	artwork        { return [read_default_boolean $param $fd] }
	samples        { return [read_default_boolean $param $fd] }
	altmame        { return [read_default_boolean $param $fd] }
	ignorecfg      { return [read_default_boolean $param $fd] }
	antialias      { return [read_default_boolean $param $fd] }
	norotate       { return [read_default_boolean $param $fd] }
	ror            { return [read_default_boolean $param $fd] }
	rol            { return [read_default_boolean $param $fd] }
	flipx          { return [read_default_boolean $param $fd] }
	flipy          { return [read_default_boolean $param $fd] }
	mouse          { return [read_default_boolean $param $fd] }
	translucency   { return [read_default_boolean $param $fd] }
	stereo         { return [read_default_boolean $param $fd] }
	debug          { return [read_default_boolean $param $fd] }
	cheat          { return [read_default_boolean $param $fd] }
	cheatfile      { return [read_default_string  $param $fd] }
	record_name    { return [read_default_string  $param $fd] }
	mame_exec      { return [read_default_string  $param $fd] }
	other          { return [read_default_string  $param $fd] }

	frameskip {
	    if { $fd == "" } {
		return [lindex $p(frameskips) 0]
	    } else {
		set tmp [read_config $fd frameskip]
		if { $tmp == "auto" } {
		    return [lindex $p(frameskips) 0]
		} elseif { ( $tmp >= 0 ) && ( $tmp <= 12 ) } {
		    if { [is_windows] } {
			return [expr $tmp * 5]
		    } else {
			return $tmp
		    }
		} else {
		    return [lindex $p(frameskips) 0]
		}
	    }
	}
	volume {
	    if { $fd == "" } {
		return 0 
	    } else {
		set tmp [read_config $fd volume]
		if { ($tmp >= -32) && ($tmp <= 0) } {
		    return $tmp
		} else {
		    return 0
		}
	    }
	}
	record {
	    if { $fd == "" } {
		return [lindex $p(recordings) 0]
	    } else {
		set tmp [read_config $fd record]
		if { [lsearch $p(recordings) $tmp] != -1 } {
		    return $tmp
		} else {
		    return [lindex $p(recordings) 0]
		}
	    }
	}
	log {
	    if { $fd == "" } {
		if { [is_unix] } {
		    return "xmame.log"
		} else {
		    return 0
		}
	    } else {
		if { [is_unix] } {
		    return "xmame.log"
		} else {
		    return [yes [read_config $fd log]]
		}
	    }
	}
	beam {
	    if { $fd == "" } {
		return 1
	    } else {
		set tmp [read_config $fd beam]
		if { ( $tmp >= 1 ) && ( $tmp <= 2 ) } {
		    return $tmp
		} else {
		    return 1
		}
	    }
	}
	flicker {
	    if { $fd == "" } {
		return 0
	    } else {
		set tmp [read_config $fd flicker]
		if { ( $tmp >= 0 ) && ( $tmp <= 100 ) } {
		    return $tmp
		} else {
		    return 0
		}
	    }
	}
	gamma {
	    if { $fd == "" } {
		return 1.2
	    } else {
		if { [is_unix] } {
		    set tmp [read_config $fd gamma-correction]
		} else {
		    set tmp [read_config $fd gamma]
		}
		if { ( $tmp >= 0.5 ) && ( $tmp <= 2.0 ) } {
		    return $tmp
		} else {
		    return 1.2
		}
	    }
	}
	brightness {
	    if { $fd == "" } {
		return 100
	    } else {
		set tmp [read_config $fd brightness]
	    }
	    if { ( $tmp >= 1 ) && ( $tmp <= 100 ) } {
		return $tmp
	    } else {
		return 100
	    }
	}
	samplerate {
	    if { $fd == "" } {
		return 22050
	    } else {
		set tmp [read_config $fd samplerate]
		if { $tmp == "" } {
		    return 22050
		} else {
		    return $tmp
		}
	    }
	}
	joystick {
	    if { [is_windows] } {
		if { $fd == "" } {
		    return [lindex $p(joysticks) 0]
		} else {
		    set tmp [read_config $fd joystick]
		    if { [lsearch $p(joynames) $tmp] == -1 } {
			return [lindex $p(joysticks) 0]
		    } else {
			set index [lsearch $p(joynames) $tmp]
			return [lindex $p(joysticks) $index]
		    }
		}
	    } else {
		set tmp [read_config $fd joytype]
		if { ( $tmp >= 0 ) && ( $tmp <= 4) } {
		    return [lindex $p(joysticks) $tmp]
		} else {
		    return [lindex $p(joysticks) 0]
		}
	    }
	}
    }
}

# gets a default value from the mame.cfg file

proc def { parameter } {
    global mamecfg_fd def t

    if { [info exists def($parameter)] } {
	return $def($parameter)
    } else {
	set def($parameter) [read_default $parameter $mamecfg_fd]
	return $def($parameter)
    }
}

proc load_default_ps { } {
    global p f s
    if { [is_windows] } {
	cdrop $f(res).frameskip    $s(frameskip)  disabled $p(frameskips)
	cdrop $f(res).res          $s(resolution) disabled $p(resolutions)
	cdrop $f(res).depth        $s(depth)      disabled $p(depths)
	cdrop $f(res).vesamode     $s(vesamode)   disabled $p(vesamodes)
	cdrop $f(res).stretch      $s(stretch)    disabled $p(stretches)
	cdrop $f(res).vgafreq      $s(vgafreq)    disabled $p(vgafreqs)
	cdrop $f(res).double       $s(double)     disabled $p(doubles)
	cdrop $f(other).record     $s(record)     disabled $p(recordings)
	cdrop $f(other).joy        $s(joystick)   disabled $p(joysticks)
	cdrop $f(sound).opl        $s(opl)        disabled $p(opls)
	cdrop $f(sound).soundcard  $s(soundcard)  disabled $p(soundcards)
	cdrop $f(sound).samplerate $s(samplerate) normal   $p(samplerates)
    } else {
	cdrop $f(input).joystick $s(joystick) disabled $p(joysticks)
	cdrop $f(other).f_record.record $s(record) disabled $p(recordings)
	cdrop $f(video).hscale $s(heightscale) disabled $p(scales)
	cdrop $f(video).wscale $s(widthscale) disabled $p(scales)
	cdrop $f(video).scale $s(scale) disabled $p(scales)
	cdrop $f(video).frameskip $s(frameskip) disabled $p(frameskips)
	cdrop $f(sound).fragsize $s(fragsize) disabled $p(fragsizes)
	cdrop $f(sound).samplerate $s(samplerate) normal $p(samplerates)
	set switch_list \
	    [list x11joyname paddevname cabinet master slave other \
		 audiodevice timerfreq numfrags romdir cheat spooldir log \
		 videomode]
	for {set i 0} {$i < [llength $switch_list]} {incr i} {
	    cb_conf [lindex $switch_list $i]
	}
    }
}

# resets options to their default settings
proc load_defaults { fd } {
    global s p

    if { [is_windows] } {
	set switch_list \
	    [list double vgafreq depth resolution soundcard ym3812opl \
		 ym2203opl joystick romdir ntsc skiplines skipcolumns \
		 samplerate alwayssynced vsync waitvsync triplebuffer \
		 vesamode stretch]
	for {set i 0} {$i < [llength $switch_list]} {incr i} {
	    set sw [lindex $switch_list $i]
	    set s($sw) [read_default $sw $fd]
	}
	if { $s(ym3812opl) == 1 } {
	    set s(opl) ym3812opl
	} elseif { $s(ym2203opl) == 1 } {
	    set s(opl) ym2203opl
	} else {
	    set s(opl) None
	}
    } else {
	set switch_list \
	    [list joystick swapjoyaxis analogstick analogmouse grabmouse \
		 x11joyname paddevname romdir scale widthscale heightscale \
		 mitshm xsync dirty privatecmap forcetruecolor fullscreen \
		 spooldir fxgamma dblbuffer cabview netmapkey \
		 slave cabinet master fakesound audiodevice timerfreq \
		 numfrags fragsize samplerate \
		 cursor autoframeskip planar xil mtxil videomode]
	for {set i 0} {$i < [llength $switch_list]} {incr i} {
	    set sw [lindex $switch_list $i]
	    set s($sw) [read_default $sw $fd]
	}
    }
    set switch_list \
	[list throttle translucency altmame mame_exec ignorecfg log scanlines \
	     antialias vesa beam flicker ror rol norotate flipx flipy \
	     stereo samplebits mouse cheat debug gamma brightness sound \
	     volume other cheatfile frameskip artwork samples profiler \
	     record record_name]
    for {set i 0} {$i < [llength $switch_list]} {incr i} {
	set sw [lindex $switch_list $i]
	set s($sw) [read_default $sw $fd]
    }
    set s(cb_cheat) $s(cheat)
    set s(cheat) $s(cheatfile)
    load_default_ps
}

proc cdrop { widget_name text state list } {
    $widget_name.ent configure -state normal
    $widget_name.ent delete 0 end
    $widget_name.ent insert 0 $text
    $widget_name.ent configure -state $state
    $widget_name.top.frame.list activate [lsearch $list $text]
}

# creates a drop down list
proc dlc { basename text width height variable initial_value state } {
    upvar #0 $variable var
    set var "$initial_value"
    set top $basename.top
    frame $basename -bd 0 
    label $basename.lbl -text $text -anchor e
    if { $width } {
	entry $basename.ent -width $width 
    } else {
	entry $basename.ent
    }
    bind $basename.ent <KeyRelease> {
	drop_list_set_val $basename.ent $variable
	update_command_line 0
    }
    $basename.ent insert 0 "$initial_value"
    $basename.ent configure -state $state
    drop_button $basename.drop $basename.top $basename.ent
    bind $basename.ent <Return> \
        "drop_list_set_val $basename.ent $variable"
    bind $basename.ent <Key-Escape> "wm withdraw $top"
    pack $basename.lbl -side left -anchor w
    pack $basename.ent -side left -expand 1 -fill x 
    pack $basename.drop -side right -anchor e
    toplevel $top -cursor top_left_arrow
    wm overrideredirect $top 1
    wm withdraw $top 
    set frm $top.frame
    frame $frm -bd 4 -relief sunken
    if { $width } {
	listbox $frm.list -height $height -width $width -selectmode single \
	    -yscrollcommand "$frm.scrollbar set"
    } else {
	listbox $frm.list -height $height -selectmode single \
	    -yscrollcommand "$frm.scrollbar set"
    }
    bind $frm.list <Key-Escape> "wm withdraw $top"
    bind $frm.list <FocusOut> "wm withdraw $top"
    scrollbar $frm.scrollbar -command "$frm.list yview" 
    pack $frm.scrollbar -side right -fill y
    pack $frm.list -side left 
    pack $frm -side top 
    bind $frm.list <ButtonRelease-1> \
	    "drop_list_click $top $basename.ent $variable $state"
    pack $basename
    return $frm.list
}

# Returns selected item for a single-select list.
proc list_selected { listname } {
    set indx [$listname curselection]
    if { $indx != "" } {
        set item [$listname get $indx]
        return $item
    } else {
	tk_messageBox -title Error -type ok -icon error -message \
	    "Please Select a ROM..."
        return "";
    }
}

# Places value in global variable.
proc drop_list_set_val { entry variable } {
    upvar #0 $variable var
    set value [$entry get]
    set var $value
}

# Handles click on drop list widget.
proc drop_list_click { basename entry variable state } {
    global list current_index t
    catch {
        set selected [list_selected $basename.frame.list]
        if { $selected != "" } {
	    $entry configure -state normal
            $entry delete 0 end
            $entry insert 0 "$selected"
	    $entry configure -state $state
            drop_list_set_val $entry $variable
	    $list selection set $current_index
	    $list activate $current_index
	    update_command_line 0
        }
    }
    wm withdraw $basename
}

# Makes drop list visible. Create with dlc.
proc show_drop_list { basename associated_widget } {
    set x [winfo rootx $associated_widget]
    set y [winfo rooty $associated_widget]
    set y [expr $y + [winfo height $associated_widget]]
    wm geometry $basename +$x+$y
    update
    wm deiconify $basename
    raise $basename
    focus $basename.frame.list 
}

# Creates a button with a drop-down bitmap.
proc drop_button { name toplevel entry } {
    global button_bg button_fg button_abg button_afg current_index list t
    button $name -image dnarrow -width 13 -height 13 -command \
	    "show_drop_list $toplevel $entry"
    bind $name <ButtonPress> {
	set current_index [$list curselection]
    }
    return $name
}

# Bitmap data for down arrow bitmap.
set dnarrow_data "
#define dnarrow2_width 18
#define dnarrow2_height 18
static unsigned char dnarrow2_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfc, 0xff, 0x00, 0xf8, 0x7f, 0x00,
   0xf8, 0x7f, 0x00, 0xf0, 0x3f, 0x00, 0xf0, 0x3f, 0x00, 0xe0, 0x1f, 0x00,
   0xc0, 0x0f, 0x00, 0xc0, 0x0f, 0x00, 0x80, 0x07, 0x00, 0x80, 0x07, 0x00,
   0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfc, 0xff, 0x00,
   0xfc, 0xff, 0x00, 0x00, 0x00, 0x00};
"
set stardata "
R0lGODlhEAAQAKEAAAAAAP8AAP///////yH5BAEAAAAALAAAAAAQABAAAAIlhA8RyKwN1YNILmrs
pPqeDkpJqFVkQ3pZqrJe+VnrFj8iJmNVAQA7
"

image create bitmap dnarrow -data $dnarrow_data
image create photo star -data $stardata

# creates a check button
proc cbc { basename variable text initial_value } {
    upvar #0 $variable var
    checkbutton $basename -variable $variable -text $text \
	    -command { update_command_line 0 }
    set var "$initial_value"
}

# raises all windows
set edit_mapped 0
set options_mapped 0
set graphics_mapped 0
proc raise_all_windows { window } {
    global edit_mapped options_mapped graphics_mapped t
    if { $edit_mapped  } {
	if { ![winfo viewable .edit] } {
	    wm overrideredirect .edit 0
	    wm deiconify .edit
	}
	myraise .edit
    }
    if { $options_mapped } {
	if { ![winfo viewable .options] } {
	    wm overrideredirect .options 0
	    wm deiconify .options
	}
	myraise .options
    }
    if { $graphics_mapped } {
	if { ![winfo viewable .graphics] } {
	    wm overrideredirect .graphics 0
	    wm deiconify .graphics
	}
	myraise .graphics
    }
    myraise .
    myraise $window
    update
    if { [winfo exists $window] } {
	focus $window
    }
}

proc minimize_all_windows { } {
    global edit_mapped options_mapped graphics_mapped t
    if { [winfo exists .edit] && [winfo ismapped .edit] } {
	set edit_mapped 1
	wm overrideredirect .edit 1
	wm withdraw .edit
    } else {
	set edit_mapped 0
    }
    if { [winfo ismapped .options] } {
	set options_mapped 1
	wm overrideredirect .options 1
	wm withdraw .options
    } else {
	set options_mapped 0
    }
    if { [winfo ismapped .graphics] } {
	set graphics_mapped 1
	wm overrideredirect .graphics 1
	wm withdraw .graphics
    } else {
	set graphics_mapped 0
    }
}

proc cb_conf { widget } {
    global s

    if { $widget == "cheat" } {
	set dwidget "cheatfile"
    } else {
	set dwidget $widget
    }
    if { $s($widget) != "" && $s($widget) != [def $dwidget] } {
	set s(cb_$widget) 1
    } else {
	set s(cb_$widget) 0
    }
    update_command_line 0
}

# options dialog

set options .options
toplevel $options
wm protocol $options WM_DELETE_WINDOW {
    wm withdraw $options 
    set options_check off
    set options_mapped 0
}
wm geometry $options 485x245
wm withdraw $options

if { [is_windows] } {

    ### Resolution
    set f(res) .options.resolution
    frame $f(res)

    set p(resolutions) \
	[list Automatic 256x256 224x288 288x224 320x204 200x320 240x272   \
	     320x200 320x240 400x300 400x600 320x400 320x480 512x384 640x350 \
	     640x400 640x480 800x600 1024x768 1152x864 1280x960 1280x1024 \
	     1600x1200 None]

    set res [dlc $f(res).res $t(0193) 12 8 s(resolution) [def resolution] \
	    disabled]
    foreach e [split $p(resolutions)] {	$res insert end $e }
    set p(depths) [list 16 8 15]
    set depth [dlc $f(res).depth $t(0194) 2 3 s(depth) [def depth] disabled]
    foreach e [split $p(depths)] { $depth insert end $e }
    set p(vesamodes) [list vesa1 vesa2b vesa2l vesa3]
    set vm [dlc $f(res).vesamode $t(0296) 6 4 s(vesamode) [def vesamode] \
	    disabled]
    foreach e [split $p(vesamodes)] { $vm insert end $e }
    set p(stretches) [list off "800x600" "1024x768"]
    set strch [dlc $f(res).stretch $t(0297) 8 3 s(stretch) [def stretch] \
	    disabled]
    foreach e [split $p(stretches)] { $strch insert end $e }
    set p(doubles) [list Automatic Forced None]
    set dble [dlc $f(res).double $t(0195) 10 3 s(double) [def double] disabled]
    foreach e [split $p(doubles)] { $dble insert end $e }
    set p(frameskips) [list auto 0 5 10 15 20 25 30 35 40 45 50 55]
    set frameskip [dlc $f(res).frameskip $t(0044) 5 12 s(frameskip) \
		       [def frameskip] disabled]
    foreach e [split $p(frameskips)] { $frameskip insert end $e }
    label $f(res).l_frameskip -text $t(0045)
    cbc $f(res).vesa s(vesa) $t(0201) [def vesa]
    cbc $f(res).scanlines s(scanlines) $t(0202) [def scanlines]
    cbc $f(res).ntsc s(ntsc) $t(0203) [def ntsc]
    cbc $f(res).vsync s(vsync) $t(0204)	[def vsync]
    cbc $f(res).waitvsync s(waitvsync) $t(0289) [def waitvsync]
    cbc $f(res).triplebuffer s(triplebuffer) $t(0295) [def triplebuffer]
    cbc $f(res).artwork s(artwork) $t(0290) [def artwork]
    set p(vgafreqs) [list Auto 0 1 2 3]
    set vfreq [dlc $f(res).vgafreq $t(0205) 5 5 s(vgafreq) [def vgafreq] \
		   disabled]
    foreach e [split $p(vgafreqs)] { $vfreq insert end $e }
    frame $f(res).f_other -relief flat -bd 1
    cbc $f(res).f_other.other s(cb_other) $t(0053) 0
    entry $f(res).f_other.entry -textvariable s(other) 
    pack $f(res).f_other.other -side left
    pack $f(res).f_other.entry -side left -fill x -expand 1
    bind $f(res).f_other.entry <KeyRelease> { cb_conf other }
 
    grid config $f(res).res         -row 0 -column 0 -columnspan 2 -sticky we
    grid config $f(res).depth       -row 0 -column 2 -sticky we
    grid config $f(res).vesamode    -row 0 -column 3 -sticky we
    grid config $f(res).vgafreq     -row 0 -column 4 -sticky we

    grid config $f(res).double      -row 1 -column 0 -columnspan 2 -sticky we
    grid config $f(res).stretch     -row 1 -column 2 -sticky we
    grid config $f(res).frameskip   -row 1 -column 3 -sticky we
    grid config $f(res).l_frameskip -row 1 -column 4 -sticky w

    grid config $f(res).vesa         -row 2 -column 0 -sticky w
    grid config $f(res).scanlines    -row 2 -column 1 -sticky w
    grid config $f(res).triplebuffer -row 2 -column 2 -sticky w
    grid config $f(res).artwork      -row 2 -column 3 -sticky w

    grid config $f(res).vsync        -row 3 -column 0 -sticky w
    grid config $f(res).waitvsync    -row 3 -column 1 -sticky w
    grid config $f(res).ntsc         -row 3 -column 2 -sticky w

    grid config $f(res).f_other -row 4 -column 0 -columnspan 5 -sticky we
    grid propagate $f(res) 1
    

    ### Tweaks
    set f(tweaks) .options.tweaks
    frame $f(tweaks)

    cbc $f(tweaks).flipx s(flipx) $t(0056) [def flipx]
    cbc $f(tweaks).flipy s(flipy) $t(0057) [def flipy]
    cbc $f(tweaks).rol s(rol) $t(0058) [def rol]
    cbc $f(tweaks).ror s(ror) $t(0059) [def ror]
    cbc $f(tweaks).norotate s(norotate) $t(0060) [def norotate]
    cbc $f(tweaks).synced s(alwayssynced) $t(0206) [def alwayssynced]
    scale $f(tweaks).skiplines -from -255 -to 255 -label $t(0207) \
	-variable s(skiplines) -orient horizontal -highlightthickness 0 \
	-width 10 -command scale_update_command
    set skiplines [def skiplines]
    scale $f(tweaks).skipcolumns -from -255 -to 255 -label $t(0208) \
	-variable s(skipcolumns) -orient horizontal -width 10 \
	-highlightthickness 0  -command scale_update_command
    set skipcolumns [def skipcolumns]
    scale $f(tweaks).brightness -from 1 -to 100 -label $t(0054) \
	-variable s(brightness) -orient horizontal -width 10 \
	-highlightthickness 0 -command scale_update_command
    set s(brightness) [def brightness]
    scale $f(tweaks).gamma -from 0.5 -to 2.0 -label $t(0055) \
	-resolution .01 -variable s(gamma) -orient horizontal \
	-highlightthickness 0 -command scale_update_command -width 10
    set s(gamma) [def gamma]
    
    grid config $f(tweaks).flipx -row 0 -column 0 -sticky w
    grid config $f(tweaks).flipy -row 0 -column 1 -sticky w
    grid config $f(tweaks).rol -row 1 -column 0 -sticky w
    grid config $f(tweaks).ror -row 1 -column 1 -columnspan 2 -sticky w
    grid config $f(tweaks).norotate -row 1 -column 2 -sticky w
    grid config $f(tweaks).synced -row 0 -column 2 -sticky w
    grid config $f(tweaks).skiplines -row 2 -column 0 -sticky snew
    grid config $f(tweaks).skipcolumns -row 2 -column 1 -sticky snew
    grid config $f(tweaks).gamma -row 2 -column 2 -columnspan 2 -sticky snew
    grid propagate $f(tweaks) 1


    ### Sound/Vector
    set f(sound) .options.sound
    frame $f(sound)
    
    frame $f(sound).f -bd 0
    scale $f(sound).f.beam -from 1 -to 2 -label $t(0062) -resolution .01 \
	-variable s(beam) -orient horizontal -highlightthickness 0 \
	-command scale_update_command -width 10
    set s(beam) [def beam]
    scale $f(sound).f.flicker -from 0 -to 100 -label $t(0063) -resolution .01 \
	-variable s(flicker) -orient horizontal -highlightthickness 0 \
	-command scale_update_command -width 10
    set s(flicker) [def flicker]
    scale $f(sound).f.volume -from -32 -to 0 -label $t(0061) \
	-variable s(volume) -orient horizontal -highlightthickness 0 \
	-command scale_update_command -width 10
    set s(volume) [def volume]
    pack $f(sound).f.beam $f(sound).f.flicker $f(sound).f.volume -side left \
	    -fill x -expand 1
    frame $f(sound).f2 -bd 0
    label $f(sound).f2.label -text $t(0068)
    entry $f(sound).f2.entry -textvariable switchs(audiodevice) -width 12
    set s(audiodevice) [def audiodevice]
    pack $f(sound).f2.label $f(sound).f2.entry -side left -fill x \
	-expand 1
    bind $f(sound).f2.entry <KeyRelease> {
	update_command_line 0
    }
    cbc $f(sound).antialias s(antialias) $t(0064) [def antialias]
    cbc $f(sound).samples s(samples) $t(0291) [def samples]
    set p(soundcards) \
	[list $t(0209) $t(0210) "Sound Blaster" "Sound Blaster AWE 32" \
	     "Pro Audio Spectrum" "Ultrasound Max" "Ultrasound"        \
	     "Windows Sound System" "Ensoniq Soundscape"]
    set sndcard [dlc $f(sound).soundcard $t(0211) 20 8 s(soundcard) \
		     [def soundcard] disabled]
    $sndcard insert end \
	[lindex $p(soundcards) 0] [lindex $p(soundcards) 1] \
	[lindex $p(soundcards) 2] [lindex $p(soundcards) 3] \
	[lindex $p(soundcards) 4] [lindex $p(soundcards) 5] \
	[lindex $p(soundcards) 6] [lindex $p(soundcards) 7] \
	[lindex $p(soundcards) 8]
    cbc $f(sound).samplebits s(samplebits) "16 $t(0212)" [def samplebits]
    set p(opls) [list None ym3812opl ym2203opl]
    set opl [dlc $f(sound).opl $t(0213) 10 3 s(opl) [def opl] disabled]
    foreach e [split $p(opls)] { $opl insert end $e }
    set p(samplerates) [list 22050 11025 44100]
    set samplerate [dlc $f(sound).samplerate $t(0069) 7 3 s(samplerate) \
			[def samplerate] normal]
    foreach e [split $p(samplerates)] { $samplerate insert end $e }
    cbc $f(sound).stereo s(stereo) $t(0214) [def stereo]
    cbc $f(sound).translucency s(translucency) $t(0065) [def translucency]
    cbc $f(sound).sound s(sound) $t(0066) [def sound]
    
    grid config $f(sound).f -row 0 -column 0 -columnspan 3 -sticky ew
    grid config $f(sound).samples -row 0 -column 3 -sticky w
    grid config $f(sound).antialias -row 1 -column 0 -sticky w
    grid config $f(sound).opl -row 1 -column 1 -sticky w
    grid config $f(sound).samplebits -row 1 -column 2 -sticky w
    grid config $f(sound).translucency -row 1 -column 3 -sticky w
    grid config $f(sound).soundcard -row 2 -column 0 -columnspan 2 -sticky ew
    grid config $f(sound).samplerate -row 2 -column 2 -sticky w
    grid config $f(sound).stereo -row 2 -column 3 -sticky w
    grid propagate $f(sound) 1
    

    ### Other
    set f(other) .options.other
    frame $f(other)

    set p(joysticks) \
	[list "No Joystick" "Normal 2 Button Joystick" "Dual Joysticks" \
	     "Stick/Pad with 4 buttons" "Stick/Pad with 6 buttons" \
	     "Stick/Pad with 8 buttons" "CH Flightstick Pro" \
	     "Wingman Extreme" "Microsoft Sidewinder" "Gravis GamePad Pro" \
	     "SNES pad on LPT1" "SNES pad on LPT2" "SNES pad on LPT3"]
    set p(joynames) \
	[list none standard dual 4button 6button 8button fspro wingex \
	     sidewinder gamepadpro sneslpt1 sneslpt2 sneslpt3]
    frame $f(other).f_cheat -relief flat -bd 1
    cbc $f(other).f_cheat.cheat s(cb_cheat) $t(0075) [def cheat]
    entry $f(other).f_cheat.entry -textvariable s(cheat) -width 20
    pack $f(other).f_cheat.cheat -side left
    pack $f(other).f_cheat.entry -side left -fill x -expand 1
    bind $f(other).f_cheat.entry <KeyRelease> { cb_conf cheat }
    cbc $f(other).mouse s(mouse) $t(0266) [def mouse]
    cbc $f(other).debug s(debug) $t(0267) [def debug]
    cbc $f(other).log s(log) $t(0076) [def log]
    cbc $f(other).joystick s(joystick) $t(0030) [def joystick]
    cbc $f(other).altmame s(altmame) $t(0079) [def altmame]
    frame $f(other).f0 -relief flat -bd 1
    entry $f(other).f0.executable -textvariable s(mame_exec) 
    $f(other).f0.executable configure -state disabled
    pack $f(other).f0.executable -fill x -expand 1
#	    { $t(0003) { .exe .EXE .bat .BAT } }
    button $f(other).browse -text $t(0002) -command {
	set file_types { { "Executable Files" { .exe .EXE } } }
	if { [info exists mame_basedir] } {
	    set initial_dir $mame_basedir
	} else {
	    set initial_dir [pwd]
	}
	set tmp_mame [tk_getOpenFile -initialdir $initial_dir -title $t(0005) \
			  -filetypes $file_types]
	if { ( $tmp_mame != "" ) && [file executable $tmp_mame] } {
	    if { [string compare $tmp_mame $mame] == 0 } {
		set s(mame_exec) ""
		set s(altmame) 0
	    } else {
		set s(mame_exec) $tmp_mame
		set s(altmame) 1
	    }
	    update_command_line 0
	}
    }
    cbc $f(other).ignorecfg s(ignorecfg) $t(0215) [def ignorecfg]
    set joystick [dlc $f(other).joy $t(0030) 20 10 s(joystick) [def joystick] \
		      disabled]
    $joystick insert end \
	[lindex $p(joysticks) 0] [lindex $p(joysticks) 1] \
	[lindex $p(joysticks) 2] [lindex $p(joysticks) 3] \
	[lindex $p(joysticks) 4] [lindex $p(joysticks) 5] \
	[lindex $p(joysticks) 6] [lindex $p(joysticks) 7] \
	[lindex $p(joysticks) 8] [lindex $p(joysticks) 9] \
	[lindex $p(joysticks) 10] [lindex $p(joysticks) 11] \
	[lindex $p(joysticks) 12]

    set p(recordings) [list Normal Record Playback]
    set record [dlc $f(other).record $t(0078) 8 3 s(record) \
		    [lindex $p(recordings) 0] disabled]
    foreach e [split $p(recordings)] { $record insert end $e }
    label $f(other).label -text $t(0268) -anchor e 
    frame $f(other).f1 -relief flat -bd 1
    entry $f(other).f1.record_name -textvariable s(record_name) -width 8
    set record_name_entry $f(other).f1.record_name
    bind $f(other).f1.record_name <KeyRelease> {
	update_command_line 0
    }
    pack $f(other).f1.record_name -fill x -expand 1
    cbc $f(other).altromdir s(cb_romdir) $t(0216) 0
    frame $f(other).f2 -relief flat -bd 1 
    entry $f(other).f2.rom_dir -textvariable s(romdir) 
    bind $f(other).f2.rom_dir <KeyRelease> { cb_conf romdir }
    pack $f(other).f2.rom_dir -fill x -expand 1
    cbc $f(other).profiler s(profiler) $t(0294) [def profiler]
    
    grid config $f(other).f_cheat -row 0 -column 0 -columnspan 2 -sticky w
    grid config $f(other).mouse -row 2 -column 0 -sticky w
    grid config $f(other).joy -row 0 -column 2 -columnspan 2 -sticky w
    grid config $f(other).debug -row 1 -column 0 -sticky w
    grid config $f(other).log -row 1 -column 1 -sticky w
    grid config $f(other).record -row 1 -column 2 -sticky we
    grid config $f(other).f1 -row 1 -column 3 -sticky w
    grid config $f(other).altmame -row 2 -column 1 -sticky w
    grid config $f(other).f0 -row 2 -column 2  -sticky ew
    grid config $f(other).browse -row 2 -column 3 -sticky w
    grid config $f(other).ignorecfg -row 3 -column 0 -sticky w
    grid config $f(other).profiler -row 3 -column 1 -sticky w
    grid config $f(other).altromdir -row 3 -column 2 -sticky e
    grid config $f(other).f2 -row 3 -column 3 -sticky ew
    grid propagate $f(other) 1

} else {

    ### Input
    set f(input) .options.input
    frame $f(input)

    cbc $f(input).mouse s(mouse) $t(0020) [def mouse]
    cbc $f(input).swapjoyaxis s(swapjoyaxis) $t(0021) [def swapjoyaxis]
    cbc $f(input).analogstick s(analogstick) $t(0022) [def analogstick]
    cbc $f(input).analogmouse s(analogmouse) $t(0023) [def analogmouse]
    cbc $f(input).grabmouse s(grabmouse) $t(0024) [def grabmouse]
    cbc $f(input).cursor s(cursor) $t(0271) [def cursor]
    set p(joysticks) [list $t(0025) $t(0026) $t(0027) $t(0028) $t(0029)]
    set joystick [dlc $f(input).joystick $t(0030) 22 5 s(joystick) \
		      [def joystick] disabled]
    $joystick insert end \
	[lindex $p(joysticks) 0] [lindex $p(joysticks) 1] \
	[lindex $p(joysticks) 2] [lindex $p(joysticks) 3] \
	[lindex $p(joysticks) 4]
    frame $f(input).f_x11joyname -relief flat -bd 1
    cbc $f(input).f_x11joyname.x11joyname s(cb_x11joyname) $t(0031) 0
    entry $f(input).f_x11joyname.entry -textvariable s(x11joyname) -width 20
    pack $f(input).f_x11joyname.x11joyname -side left
    pack $f(input).f_x11joyname.entry -side right
    bind $f(input).f_x11joyname.entry <KeyRelease> { cb_conf x11joyname }
    frame $f(input).f_paddevname -relief flat -bd 1
    cbc $f(input).f_paddevname.paddevname s(cb_paddevname) $t(0032) 0
    entry $f(input).f_paddevname.entry -textvariable s(paddevname) -width 20
    pack $f(input).f_paddevname.paddevname -side left
    pack $f(input).f_paddevname.entry -side right
    bind $f(input).f_paddevname.entry <KeyRelease> { cb_conf paddevname }
    grid config $f(input).mouse        -row 0 -column 0 -sticky w
    grid config $f(input).joystick     -row 0 -column 1 -columnspan 2 -sticky e
    grid config $f(input).swapjoyaxis  -row 1 -column 0 -sticky w
    grid config $f(input).f_x11joyname -row 1 -column 1 -columnspan 2 -sticky ew
    grid config $f(input).analogstick  -row 2 -column 0 -sticky w
    grid config $f(input).f_paddevname -row 2 -column 1 -columnspan 2 -sticky ew
    grid config $f(input).analogmouse  -row 3 -column 0 -sticky w
    grid config $f(input).grabmouse    -row 3 -column 1 -sticky w
    grid config $f(input).cursor       -row 3 -column 2 -sticky w

    ### GL/Network
    set f(glnet) .options.glnet
    frame $f(glnet)

    cbc $f(glnet).dblbuffer s(dblbuffer) $t(0033) [def dblbuffer]
    cbc $f(glnet).cabview s(cabview) $t(0034) [def cabview]
    cbc $f(glnet).netmapkey s(netmapkey) $t(0036) [def netmapkey]
    frame $f(glnet).f_master -relief flat -bd 1
    cbc $f(glnet).f_master.master s(cb_master) $t(0037) \
	[string compare [def master] ""]
    entry $f(glnet).f_master.entry -textvariable s(master) -width 2
    pack $f(glnet).f_master.master -side left
    pack $f(glnet).f_master.entry -side left
    bind $f(glnet).f_master.entry <KeyRelease> { cb_conf master }
    frame $f(glnet).f_slave -relief flat -bd 1 
    cbc $f(glnet).f_slave.slave s(cb_slave) $t(0038) \
	[string compare [def slave] ""]
    entry $f(glnet).f_slave.entry -textvariable s(slave) -width 20
    pack $f(glnet).f_slave.slave -side left
    pack $f(glnet).f_slave.entry -side right
    bind $f(glnet).f_slave.entry <KeyRelease> { cb_conf slave }
    frame $f(glnet).f_cabinet -relief flat -bd 1 
    cbc $f(glnet).f_cabinet.cabinet s(cb_cabinet) $t(0039) \
	[string compare [def cabinet] ""]
    entry $f(glnet).f_cabinet.entry -textvariable s(cabinet) -width 20
    pack $f(glnet).f_cabinet.cabinet -side left
    pack $f(glnet).f_cabinet.entry -side right
    bind $f(glnet).f_cabinet.entry <KeyRelease> { cb_conf cabinet }
    scale $f(glnet).fxgamma -from 0.5 -to 2.0 -label $t(0040) \
	-variable s(fxgamma) -orient vertical -highlightthickness 0 \
	-command scale_update_command -width 10 -resolution .01
    set s(fxgamma) [def fxgamma]
    grid config $f(glnet).fxgamma   -row 0 -column 0 -rowspan 3
    grid config $f(glnet).dblbuffer -row 0 -column 1 -sticky w
    grid config $f(glnet).f_slave   -row 0 -column 2 -sticky ew
    grid config $f(glnet).cabview   -row 1 -column 1 -sticky w
    grid config $f(glnet).f_cabinet -row 1 -column 2 -sticky ew
    grid config $f(glnet).f_master  -row 2 -column 2 -sticky ew
    grid config $f(glnet).netmapkey -row 2 -column 1 -sticky w
    
    ### Video
    set f(video) .options.video
    frame $f(video)

    set p(scales) [list 0.5 1.0 1.5 2.0]
    set hscale [dlc $f(video).hscale $t(0041) 3 4 s(heightscale) \
		    [def heightscale] disabled]
    foreach e [split $p(scales)] { $hscale insert end $e }
    set wscale [dlc $f(video).wscale $t(0042) 3 4 s(widthscale) \
		    [def widthscale] disabled]
    foreach e [split $p(scales)] { $wscale insert end $e }
    set scale [dlc $f(video).scale $t(0043) 3 4 s(scale) [def scale] disabled]
    foreach e [split $p(scales)] { $scale insert end $e }
    set p(frameskips) [list 0 5 10 15 20 25 30 35 40 45 50 55]
    set frameskip [dlc $f(video).frameskip $t(0044) 2 12 s(frameskip) \
		       [def frameskip] disabled]
    foreach e [split $p(frameskips)] { $frameskip insert end $e }
    label $f(video).l_frameskip -text $t(0045)
    cbc $f(video).mitshm s(mitshm) $t(0046) [def mitshm]
    cbc $f(video).dirty s(dirty) $t(0047) [def dirty]
    cbc $f(video).privatecmap s(privatecmap) $t(0048) [def privatecmap]
    cbc $f(video).fullscreen s(fullscreen) $t(0049) [def fullscreen]
    cbc $f(video).artwork s(artwork) $t(0290) [def artwork]
    cbc $f(video).xsync s(xsync) $t(0050) [def xsync]
    cbc $f(video).throttle s(throttle) $t(0051) [def throttle]
    cbc $f(video).truecolor s(forcetruecolor) $t(0052) [def truecolor]
    frame $f(video).f_other -relief flat -bd 1
    cbc $f(video).f_other.other s(cb_other) $t(0086) 0
    entry $f(video).f_other.entry -textvariable s(other) 
    pack $f(video).f_other.other -side left
    pack $f(video).f_other.entry -side left -fill x -expand 1
    bind $f(video).f_other.entry <KeyRelease> { cb_conf other }
    cbc $f(video).autoframeskip s(autoframeskip) $t(0272) 0
    grid config $f(video).hscale      -row 0 -column 0 -sticky e
    grid config $f(video).mitshm      -row 0 -column 1 -sticky w
    grid config $f(video).xsync       -row 0 -column 2 -sticky w
    grid config $f(video).wscale      -row 1 -column 0 -sticky e
    grid config $f(video).dirty       -row 1 -column 1 -sticky w
    grid config $f(video).throttle    -row 1 -column 2 -sticky w
    grid config $f(video).scale       -row 2 -column 0 -sticky e
    grid config $f(video).privatecmap -row 2 -column 1 -sticky w
    grid config $f(video).fullscreen  -row 2 -column 2 -sticky w
    grid config $f(video).frameskip   -row 3 -column 0 -sticky e
    grid config $f(video).l_frameskip -row 3 -column 1 -sticky w
    grid config $f(video).autoframeskip -row 3 -column 2 -sticky w
    if { $version < 35 } {
	grid config $f(video).f_other -row 4 -column 0 -columnspan 2 -sticky ew
	grid config $f(video).truecolor -row 2 -column 2 -sticky w
    } else {
	grid config $f(video).f_other -row 4 -column 0 -columnspan 2 -sticky ew
	grid config $f(video).artwork -row 4 -column 2 -sticky w
    }

    ### Tweaks
    set f(tweaks) .options.tweaks
    frame $f(tweaks)

    frame $f(tweaks).frm
    scale $f(tweaks).frm.brightness -from 1 -to 100 -label $t(0054) \
	-variable s(brightness) -orient horizontal -highlightthickness 0 \
	-command scale_update_command -width 10
    set s(brightness) [def brightness]
    scale $f(tweaks).frm.gamma -from 0.5 -to 2.0 -label $t(0055) \
	-variable s(gamma) -orient horizontal -highlightthickness 0 \
	-command scale_update_command -width 10 -resolution .01
    set s(gamma) [def gamma]
    pack $f(tweaks).frm.brightness $f(tweaks).frm.gamma -side left -fill x \
	-expand 1
    set p(videomodes) [list Normal "Tweak/scanlines" "Tweak/noscanlines"]
    set videomode [dlc $f(tweaks).videomode $t(0276) 15 3 s(videomode) \
		       [def videomode] disabled]
    $videomode insert end [lindex $p(videomodes) 0] [lindex $p(videomodes) 1] \
	[lindex $p(videomodes) 2] 

    cbc $f(tweaks).flipx s(flipx) $t(0056) [def flipx]
    cbc $f(tweaks).flipy s(flipy) $t(0057) [def flipy]
    cbc $f(tweaks).rol s(rol) $t(0058) [def rol]
    cbc $f(tweaks).ror s(ror) $t(0059) [def ror]
    cbc $f(tweaks).norotate s(norotate) $t(0060) [def norotate]
    cbc $f(tweaks).planar s(planar) $t(0273) [def planar]
    cbc $f(tweaks).xil s(xil) $t(0274) [def xil]
    cbc $f(tweaks).mtxil s(mtxil) $t(0275) [def mtxil]
    label $f(tweaks).caution -text $t(0277)
    grid config $f(tweaks).frm       -row 0 -column 0 -sticky ew -columnspan 4
    grid config $f(tweaks).flipx     -row 1 -column 0 -sticky w
    grid config $f(tweaks).flipy     -row 1 -column 1 -sticky w
    grid config $f(tweaks).videomode -row 1 -column 2 -sticky w  -columnspan 2
    grid config $f(tweaks).rol       -row 2 -column 0 -sticky w
    grid config $f(tweaks).ror       -row 2 -column 1 -sticky w
    grid config $f(tweaks).norotate  -row 2 -column 2 -sticky w
    grid config $f(tweaks).caution   -row 2 -column 3 -sticky e
    grid config $f(tweaks).planar    -row 3 -column 0 -sticky w
    grid config $f(tweaks).xil       -row 3 -column 1 -sticky w
    grid config $f(tweaks).mtxil     -row 3 -column 2 -sticky w  -columnspan 2

    ### Vector
    set f(vector) .options.vector
    frame $f(vector)

    scale $f(vector).beam -from 1 -to 2 -label $t(0062) -resolution .01 \
	-variable s(beam) -orient horizontal -highlightthickness 0 \
	-command scale_update_command -width 10
    set s(beam) [def beam]
    scale $f(vector).flicker -from 0 -to 100 -label $t(0063) \
	-resolution .01 -variable s(flicker) -orient horizontal \
	-highlightthickness 0 -command scale_update_command -width 10
    set s(flicker) [def flicker]
    cbc $f(vector).antialias s(antialias) $t(0064) [def antialias]
    cbc $f(vector).translucency s(translucency) $t(0065) [def translucency]
    grid config $f(vector).beam -row 0 -column 0 -sticky ew
    grid config $f(vector).flicker -row 0 -column 1 -sticky ew
    grid config $f(vector).antialias -row 1 -column 0 -sticky w
    grid config $f(vector).translucency -row 1 -column 1 -sticky w

    ### Sound
    set f(sound) .options.sound
    frame $f(sound)

    scale $f(sound).volume -from -24 -to 0 -label $t(0061) \
	-variable s(volume) -orient horizontal -highlightthickness 0 \
	-width 10 -command scale_update_command
    set s(volume) [def volume]
    cbc $f(sound).stereo s(stereo) $t(0214) [def stereo]
    cbc $f(sound).samples s(samples) $t(0291) [def samples]
    cbc $f(sound).samplebits s(samplebits) "8 $t(0212)" [def samplebits]
    cbc $f(sound).sound s(sound) $t(0066) [def sound]
    cbc $f(sound).fakesound s(fakesound) $t(0067) [def fakesound]
    frame $f(sound).f_audiodev -relief flat -bd 1
    cbc $f(sound).f_audiodev.audiodev s(cb_audiodevice) $t(0068) 0
    entry $f(sound).f_audiodev.entry -textvariable s(audiodevice) -width 10
    pack $f(sound).f_audiodev.audiodev $f(sound).f_audiodev.entry -side left
    bind $f(sound).f_audiodev.entry <KeyRelease> { cb_conf audiodevice }
    set p(samplerates) [list 22050 11025 44100]
    set samplerate [dlc $f(sound).samplerate $t(0069) 7 3 s(samplerate) \
			[def samplerate] normal]
    foreach e [split $p(samplerates)] { $samplerate insert end $e }
    frame $f(sound).f_timerfreq -relief flat -bd 1
    cbc $f(sound).f_timerfreq.timerfreq s(cb_timerfreq) $t(0070) 0
    entry $f(sound).f_timerfreq.entry -textvariable s(timerfreq) -width 5
    pack $f(sound).f_timerfreq.timerfreq $f(sound).f_timerfreq.entry \
	-side left
    bind $f(sound).f_timerfreq.entry <KeyRelease> { cb_conf timerfreq }
    set p(fragsizes) [list 256 512 1024]
    set fragsize [dlc $f(sound).fragsize $t(0071) 5 3 s(fragsize) \
		      [def fragsize] disabled]
    foreach e [split $p(fragsizes)] { $fragsize insert end $e }
    frame $f(sound).f_numfrags -relief flat -bd 1
    cbc $f(sound).f_numfrags.numfrags s(cb_numfrags) $t(0072) 0
    entry $f(sound).f_numfrags.entry -textvariable s(numfrags) -width 2
    pack $f(sound).f_numfrags.numfrags $f(sound).f_numfrags.entry -side left
    bind $f(sound).f_numfrags.entry <KeyRelease> { cb_conf numfrags }
    grid config $f(sound).stereo      -row 0 -column 0 -sticky w
    grid config $f(sound).samples     -row 0 -column 1 -sticky w
    grid config $f(sound).samplebits  -row 1 -column 0 -sticky w
    grid config $f(sound).sound       -row 2 -column 0 -sticky w
    grid config $f(sound).fakesound   -row 3 -column 0 -sticky w
    grid config $f(sound).f_audiodev  -row 1 -column 1 -sticky ew
    grid config $f(sound).f_timerfreq -row 2 -column 1 -sticky ew
    grid config $f(sound).f_numfrags  -row 3 -column 1 -sticky ew
    grid config $f(sound).volume      -row 0 -column 2 -sticky ew  -rowspan 2
    grid config $f(sound).samplerate  -row 2 -column 2 -sticky ew
    grid config $f(sound).fragsize    -row 3 -column 2 -sticky ew

    
    ### Other
    set f(other) .options.other
    frame $f(other)

    frame $f(other).f_romdir -relief flat -bd 1
    cbc $f(other).f_romdir.romdir s(cb_romdir) $t(0073) 0
    entry $f(other).f_romdir.entry -textvariable s(romdir) -width 20
    pack $f(other).f_romdir.romdir -side left
    pack $f(other).f_romdir.entry -side left -fill x -expand 1
    bind $f(other).f_romdir.entry <KeyRelease> {  cb_conf romdir }
    frame $f(other).f_spooldir -relief flat -bd 1
    cbc $f(other).f_spooldir.spooldir s(cb_spooldir) $t(0074) 0
    entry $f(other).f_spooldir.entry -textvariable s(spooldir) -width 20
    pack $f(other).f_spooldir.spooldir -side left
    pack $f(other).f_spooldir.entry -side left -fill x -expand 1
    bind $f(other).f_spooldir.entry <KeyRelease> { cb_conf spooldir }
    frame $f(other).f_cheat -relief flat -bd 1
    cbc $f(other).f_cheat.cheat s(cb_cheat) $t(0075) 0
    entry $f(other).f_cheat.entry -textvariable s(cheat) -width 20
    pack $f(other).f_cheat.cheat -side left
    pack $f(other).f_cheat.entry -side left -fill x -expand 1
    bind $f(other).f_cheat.entry <KeyRelease> { cb_conf cheat }
    frame $f(other).f_log -relief flat -bd 1
    cbc $f(other).f_log.log s(cb_log) $t(0076) 0
    entry $f(other).f_log.entry -textvariable s(log) -width 20
    pack $f(other).f_log.log -side left
    pack $f(other).f_log.entry -side left -fill x -expand 1
    bind $f(other).f_log.entry <KeyRelease> { cb_conf log }
    cbc $f(other).ignorecfg s(ignorecfg) "$t(0077) .xmamerc" [def ignorecfg]
    cbc $f(other).debug s(debug) $t(0267) [def debug]
    frame $f(other).f_record -relief flat -bd 1
    set p(recordings) [list Normal Record Playback]
    set record [dlc $f(other).f_record.record $t(0078) 8 3 s(record) \
		    [lindex $p(recordings) 0] disabled]
    foreach e [split $p(recordings)] { $record insert end $e }
    entry $f(other).f_record.record_name -textvariable s(record_name) -width 8
    set record_name_entry $f(other).f_record.record_name
    bind $f(other).f_record.record_name <KeyRelease> {
	update_command_line 0
    }
    pack $f(other).f_record.record -side left
    pack $f(other).f_record.record_name -side left -fill x -expand 1
    frame $f(other).f_altmame -relief flat -bd 1
    cbc $f(other).f_altmame.altmame s(altmame) $t(0079) [def altmame]
    entry $f(other).f_altmame.executable -textvariable s(mame_exec) 
    bind $f(other).f_altmame.executable <KeyRelease> {
	if { $s(mame_exec) != "" } {
	    set s(altmame) 1
	} else {
	    set s(altmame) 0
	}
	update_command_line 0
    }
    button $f(other).f_altmame.browse -text $t(0002) -command {
	set file_types {
	    { "All Files"  * }
	}
#	set file_types { { $t(0004) { "*" } } }
	if { [info exists mame_basedir] } {
	    set initial_dir $mame_basedir
	} else {
	    set initial_dir [pwd]
	}
	set tmp_mame [tk_getOpenFile -initialdir $initial_dir -title $t(0005) \
			  -filetypes $file_types]
	if { ( $tmp_mame != "" ) && [file executable $tmp_mame] } {
	    if { [string compare $tmp_mame $mame] == 0 } {
		set s(mame_exec) ""
		set s(altmame) 0
	    } else {
		set s(mame_exec) $tmp_mame
		set s(altmame) 1
	    }
	    update_command_line 0
	}
    }
    pack $f(other).f_altmame.altmame -side left
    pack $f(other).f_altmame.executable -side left -fill x -expand 1
    pack $f(other).f_altmame.browse -side right
    cbc $f(other).profiler s(profiler) $t(0294) [def profiler]
    grid config $f(other).f_romdir -row 0 -column 0 -columnspan 2 -sticky ew
    grid config $f(other).f_spooldir -row 0 -column 2 -sticky ew
    grid config $f(other).f_cheat -row 1 -column 0 -columnspan 2 -sticky ew
    grid config $f(other).f_log -row 1 -column 2 -sticky ew
    grid config $f(other).ignorecfg -row 2 -column 0 -sticky w
    grid config $f(other).debug -row 2 -column 1 -sticky w
    grid config $f(other).f_record -row 2 -column 2 -sticky ew
    grid config $f(other).profiler -row 3 -column 0 -sticky w
    grid config $f(other).f_altmame -row 3 -column 1 -columnspan 2 -sticky ew
}

set frm .options.command_line
frame $frm -bd 1 
text $frm.command -state disabled -height 3
pack $frm.command -fill both -expand 1
pack $frm -side bottom -fill both -expand 1


proc get_description { } {
    global slyroms list last_known_selection
    if { ![info exist last_known_selection] } {
	set last_known_selection 0
    }
    if { [$list curselection] == "" } {
	set curselection $last_known_selection
	$list selection set $last_known_selection
    } else {
	set curselection [$list curselection]
	set last_known_selection $curselection
    }
    return [lindex $slyroms $curselection]
}
proc get_image_name { } {
    global rom_images
    return $rom_images([get_description])
}

proc change_group { group } {
    global sel_group groups_widget

    destroy .f2.groups
    set groups_widget [dlc .f2.groups "" 10 20 sel_group "All ROMs" disabled]
    $groups_widget insert end "All ROMs"
    set len [llength $group]
    for { set i 0 } { $i < $len } { incr i } {
	set g [lindex $group $i]
	if { $g != "All ROMs" } { $groups_widget insert end $g }
    }
    set sel_group "All ROMs"
    pack .f2.mgrps .f2.groups -side left -fill x -expand 1
    $groups_widget configure -width 40
}

proc scale_update_command { tmp } { update_command_line 0 }
proc update_command_line { use_default } {
    global sel_group last_sel_group list slyroms groups your_roms all_groups \
	sllyroms groups_widget ver main_group user_groups last_main_group \
	year_groups manu_groups color_groups wori_groups

    if { [string compare $main_group $last_main_group] } {
	set last_main_group $main_group
	set slyroms [lsort -dictionary [split $your_roms \n]]
	set sllyroms [lsort -dictionary [split [string tolower $your_roms] \n]]
	
	switch $main_group {
	    "All Groups"  { change_group [lsort -dictionary $all_groups] }
	    "User Groups" { change_group [lsort -dictionary $user_groups] }
	    "Year Groups" { change_group [lsort -dictionary $year_groups] }
	    "Manufacturer Groups" {
		change_group [lsort -dictionary $manu_groups]
	    }
	    "Wrong Orientation Groups" { 
		change_group [lsort -dictionary $wori_groups]
	    }
	    "Color Groups" { change_group [lsort -dictionary $color_groups] }
	}
    }

    if { [string compare $sel_group $last_sel_group] } {
	set last_sel_group $sel_group
	if { [string compare $sel_group [lindex $all_groups 0]] == 0 } {
	    set slyroms [lsort -dictionary [split $your_roms \n]]
	    set sllyroms [lsort -dictionary [split [string tolower $your_roms] \n]]
	} elseif { $groups($sel_group) == "" } {
	    tk_messageBox -title $t(0188) -type ok -icon info -message $t(0080)
	    set sel_group [lindex $all_groups 0]
	    set last_sel_group $sel_group
	    set slyroms [lsort -dictionary [split $your_roms \n]]
	    set sllyroms [lsort -dictionary [split [string tolower $your_roms] \n]]
	} else {
	    set slyroms \
		[lsort -dictionary [split [string trim $groups($sel_group) \n] \n]]
	    set sllyroms \
		[lsort -dictionary [split [string tolower [string trim $groups($sel_group) \n]] \n]]
	}
	$list delete 0 end
	foreach rom $slyroms { $list insert end $rom }
	set numroms [llength $slyroms]
	if { $numroms == 1 } { set r "ROM" } else { set r "ROMs" }
	if { [is_windows]} {
	    wm title . "MAME $ver - $numroms $r"
	} else {
	    wm title . "TkMAME $ver - $numroms $r"
	}
	$list selection set 0
	do_updates
    }

    set widget .options.command_line.command
    $widget configure -state normal
    $widget delete 1.0 end
    $widget insert 1.0 [get_command [get_image_name] $use_default]
    $widget configure -state disabled
}

set frm .options.button_bar1
frame $frm -bd 2 -relief raised
button $frm.save -text $t(0111) -command { save_config [get_image_name] }
button $frm.test -text $t(0189) -command {
    test_launch_mame [get_command [get_image_name] 0]
}
button $frm.default -text $t(0190) -command {
    set orig_ntsc -1
    set orig_scanlines -1
    set orig_vesa -1
    set orig_ym3812 -1
    set orig_ym2203 -1
    load_default_values
    update_command_line 0
}
pack $frm.save $frm.test $frm.default -side left -expand 1 -fill x
pack $frm -side bottom -fill x
set frm .options.button_bar2
frame $frm -bd 2 -relief raised
if { [is_unix] } {
    button $frm.input -text $t(0081) -command {
	pack forget $f(glnet)
	pack forget $f(video)
	pack forget $f(tweaks)
	pack forget $f(sound)
	pack forget $f(other)
	pack forget $f(vector)
	pack $f(input) -fill both 
    }
    button $frm.glnet -text $t(0082) -command {
	pack forget $f(input)
	pack forget $f(video)
	pack forget $f(tweaks)
	pack forget $f(sound)
	pack forget $f(other)
	pack forget $f(vector)
	pack $f(glnet) -fill both 
    }
    button $frm.video -text $t(0083) -command {
	pack forget $f(input)
	pack forget $f(glnet)
	pack forget $f(tweaks)
	pack forget $f(sound)
	pack forget $f(other)
	pack forget $f(vector)
	pack $f(video) -fill both 
    }
    button $frm.tweaks -text $t(0084) -command {
	pack forget $f(input)
	pack forget $f(glnet)
	pack forget $f(video)
	pack forget $f(sound)
	pack forget $f(other)
	pack forget $f(vector)
	pack $f(tweaks) -fill both 
    }
    button $frm.vector -text $t(0269) -command {
	pack forget $f(input)
	pack forget $f(glnet)
	pack forget $f(video)
	pack forget $f(tweaks)
	pack forget $f(other)
	pack forget $f(sound)
	pack $f(vector) -fill both 
    }
    button $frm.sound -text $t(0085) -command {
	pack forget $f(input)
	pack forget $f(glnet)
	pack forget $f(video)
	pack forget $f(tweaks)
	pack forget $f(other)
	pack forget $f(vector)
	pack $f(sound) -fill both 
    }
    button $frm.other -text $t(0086) -command {
	pack forget $f(input)
	pack forget $f(glnet)
	pack forget $f(video)
	pack forget $f(tweaks)
	pack forget $f(sound)
	pack forget $f(vector)
	pack $f(other) -fill both 
    }

    pack $frm.other $frm.sound $frm.vector $frm.tweaks $frm.video $frm.glnet \
	$frm.input -side right -expand 1 -fill x
    pack $frm  -fill x
    pack $f(input) -fill both 
} else {
    button $frm.resolution -text $t(0083) -command {
	pack forget $f(tweaks)
	pack forget $f(sound)
	pack forget $f(other)
	pack $f(res) -fill both 
    }
    button $frm.tweaks -text $t(0084) -command {
	pack forget $f(res)
	pack forget $f(sound)
	pack forget $f(other)
	pack $f(tweaks) -fill both 
    }
    button $frm.sound -text $t(0085) -command {
	pack forget $f(tweaks)
	pack forget $f(res)
	pack forget $f(other)
	pack $f(sound) -fill both 
    }
    button $frm.other -text $t(0086) -command {
	pack forget $f(tweaks)
	pack forget $f(sound)
	pack forget $f(res)
	pack $f(other) -fill both 
    }
    pack $frm.other $frm.sound $frm.tweaks $frm.resolution -side right \
	    -expand 1 -fill x
    pack $frm  -fill x
    pack $f(res) -fill both 
}

# graphics window
toplevel .graphics
wm title .graphics $t(0087)
wm withdraw .graphics
wm protocol .graphics WM_DELETE_WINDOW { 
    wm withdraw .graphics 
    set graphics_check off
    set graphics_mapped 0
}
frame .graphics.frm -bd 0
label .graphics.frm.label
pack .graphics.frm.label -fill both -expand 1
pack .graphics.frm


proc image_exists { imagedir image } {
    global image_file

    if { [is_unix] } { set delimeter ":" } else { set delimeter ";" }
    foreach dir [split $imagedir $delimeter] {
	set filename [file join / $dir $image]
	if { [file exists $filename] } {
	    set image_file $filename
	    return 1
	}
    }
    return 0
}

# updates the graphics window
set ll_image ""
set llo_image ""
set image_file ""
proc update_graphics { } {
    global mame_basedir mamecfg_fd def_pcx_dir clones t
    global ll_image llo_image rom_path xmame_image_dir image_file

    if { ![info exists def_pcx_dir] } {
	if { [is_unix] } {
	    set def_pcx_dir $xmame_image_dir
	} else {
	    set def_pcx_dir [read_config $mamecfg_fd pcx]
	}
    }
    set pcx_dir $def_pcx_dir
    set gif_image [get_image_name]
    set orig_image $gif_image
    set image_dir [file join / $mame_basedir $pcx_dir]
    if { $gif_image != $ll_image && $gif_image != $llo_image } {
	if { [image_exists $image_dir $gif_image.png] ||
	     [image_exists $image_dir $gif_image.gif] } {
	    image create photo $gif_image -file $image_file
	    set ll_image $gif_image
	    set llo_image $gif_image
	    .graphics.frm.label configure -image $ll_image
	    set w [image width $ll_image]
	    set h [image height $ll_image]
	    wm geometry .graphics ${w}x$h
	} elseif { [info exists clones($gif_image)] } {
	    set gif_image $clones($gif_image)
	    set image_dir [file join / $mame_basedir $pcx_dir]
	    set image_file ""
	    if { [image_exists $image_dir $gif_image.png] ||
                 [image_exists $image_dir $gif_image.gif] } {
		image create photo $gif_image -file $image_file
		.graphics.frm.label configure -image $gif_image
		set w [image width $gif_image]
		set h [image height $gif_image]
		wm geometry .graphics ${w}x$h
		set ll_image $gif_image
		set llo_image $orig_image
	    } elseif { [info exists ll_image] } {
		if { [lsearch [image names] $ll_image] != -1 } {
		    image delete $ll_image
		} elseif { [lsearch [image names] $llo_image] != -1 } {
		    image delete $llo_image
		}
		set llo_image ""
		set ll_image ""
	    }
	} elseif { [info exists ll_image] } {
	    if { [lsearch [image names] $ll_image] != -1 } {
		image delete $ll_image
		set llo_image ""
		set ll_image ""
	    }
	}
    }
}

proc FontDialog { font_name } {
    global fd_family fd_style fd_size fd_close t
    global fd_strikeout fd_underline

    set fd_family {}
    set fd_style  {}
    set fd_size   {}
    set fd_strikeout 0
    set fd_underline 0
    set fd_close  -1
    set families [lsort [font families]]
    set slant [font actual $font_name -slant]
    set weight [font actual $font_name -weight]
    set fd_style $t(0091)
    if { $slant == "italic" } {
        if { $weight == "bold" } {
            set fd_style $t(0092)
        } else {
            set fd_style $t(0093)
        }
    } else {
        if { $weight == "bold" } {
            set fd_style $t(0094)
        } 
    }
    set family [font actual $font_name -family]
    set fd_family $family
    set size [font actual $font_name -size]
    set fd_size $size
    set strikeout [font actual $font_name -underline]
    set fd_strikeout $strikeout
    set underline [font actual $font_name -overstrike]
    set fd_underline $underline
    set dlg .fontdialog
    toplevel $dlg
    wm protocol $dlg WM_DELETE_WINDOW "set fd_close 0"
    wm title $dlg Font
    label $dlg.family_lbl -text $t(0088) -anchor w
    entry $dlg.family_ent -textvariable fd_family
    bind  $dlg.family_ent <Key-Return> "FontDialogRegen $font_name"
    grid config $dlg.family_lbl -column 0 -row 0 -sticky w 
    grid config $dlg.family_ent -column 0 -row 1 -sticky snew 
    label $dlg.style_lbl -text $t(0089) -anchor w
    entry $dlg.style_ent -textvariable fd_style -width 11 
    bind  $dlg.style_ent <Key-Return> "FontDialogRegen $font_name"
    grid config $dlg.style_lbl -column 1 -row 0 -sticky w 
    grid config $dlg.style_ent -column 1 -row 1 -sticky snew 
    label $dlg.size_lbl -text $t(0090) -anchor w
    entry $dlg.size_ent -textvariable fd_size -width 4
    bind  $dlg.size_ent <Key-Return> "FontDialogRegen $font_name"
    grid config $dlg.size_lbl -column 2 -row 0 -sticky w
    grid config $dlg.size_ent -column 2 -row 1 -sticky snew 
    set fr $dlg.family_list
    frame $fr -bd 0
    listbox $fr.list -height 6 -selectmode single \
        -yscrollcommand "$fr.scroll set" -width 30
    scrollbar $fr.scroll -command "$fr.list yview"
    foreach f $families { $fr.list insert end $f }
    bind $fr.list <Double-Button-1> \
     "FontDialogFamily $fr.list $font_name $dlg.family_ent"
    pack $fr.scroll -side right -fill y
    pack $fr.list -side left
    grid config $fr -column 0 -row 2 -rowspan 16 
    set fr $dlg.style_list
    frame $fr -bd 0
    listbox $fr.list -height 6 -selectmode single \
        -yscrollcommand "$fr.scroll set" -width 11
    scrollbar $fr.scroll -command "$fr.list yview"
    $fr.list insert end $t(0091)
    $fr.list insert end $t(0092)
    $fr.list insert end $t(0093)
    $fr.list insert end $t(0094)
    bind $fr.list <Double-Button-1> \
     "FontDialogStyle $fr.list $font_name $dlg.style_ent"
    pack $fr.scroll -side right -fill y
    pack $fr.list -side left
    grid config $fr -column 1 -row 2 -rowspan 16 
    set fr $dlg.size_list
    frame $fr -bd 0
    listbox $fr.list -height 6 -selectmode single \
        -yscrollcommand "$fr.scroll set" -width 4
    scrollbar $fr.scroll -command "$fr.list yview"
    set i 8
    while { $i <= 32 } {
        $fr.list insert end $i
        set i [expr $i + 2]
    }
    bind $fr.list <Double-Button-1> \
      "FontDialogSize $fr.list $font_name $dlg.size_ent"
    pack $fr.scroll -side right -fill y
    pack $fr.list -side left
    grid config $fr -column 2 -row 2 -rowspan 16 
    set fr $dlg.ok_cancel
    frame $fr -bd 0
    button $fr.ok -text $t(0095) -command "set fd_close 1"
    button $fr.cancel  -text $t(0009) -command "set fd_close 0"
    pack $fr.ok -side top -fill x 
    pack $fr.cancel -side top -fill x -pady 2
    grid config $fr -column 4 -row 1 -rowspan 2 -sticky snew -padx 12
    set fr $dlg.effects
    frame $fr -bd 3 -relief groove
    label $fr.effects -text $t(0096) -anchor w
    checkbutton $fr.strikeout -variable fd_strikeout -text $t(0097) -anchor w \
	-command "FontDialogRegen $font_name"
    checkbutton $fr.underline -variable fd_underline -text $t(0098) -anchor w \
	-command "FontDialogRegen $font_name"
    pack $fr.effects $fr.strikeout $fr.underline -side top -fill x
    grid config $fr -column 1 -columnspan 2 -row 20 -rowspan 2 -sticky snew \
	    -pady 10 
    set fr $dlg.sample
    frame $fr -bd 3 -relief groove
    label $fr.l_sample -text $t(0099) -anchor w
    label $fr.sample -text $t(0100) -font $font_name -bd 2 -relief sunken
    pack  $fr.l_sample -side top -fill x -pady 4
    pack  $fr.sample -side top -pady 4 -ipadx 10 -ipady 10
    grid config $fr -column 0 -columnspan 1 -row 20 -rowspan 2 -sticky snew \
	-pady 10 -padx 2
    tkwait variable fd_close
    destroy $dlg
    if { $fd_close == 0 } {
	font configure $font_name -family $family -size $size -weight $weight \
	    -underline $underline -overstrike $strikeout -slant $slant 
    }

    return $fd_close
}

proc FontDialogFamily { listname font_name entrywidget } {
    catch {
        set item_num [$listname curselection]
        set item [$listname get $item_num]
        $entrywidget delete 0 end
        $entrywidget insert end $item
        FontDialogRegen $font_name
    }
}

proc FontDialogStyle { listname font_name entrywidget } {
    catch {
        set item_num [$listname curselection]
        set item [$listname get $item_num]
        $entrywidget delete 0 end
        $entrywidget insert end $item
        FontDialogRegen $font_name
    }
}

proc FontDialogSize { listname font_name entrywidget } {
    catch {
        set item_num [$listname curselection]
        set item [$listname get $item_num]
        $entrywidget delete 0 end
        $entrywidget insert end $item
        FontDialogRegen $font_name
    }
}

proc FontDialogRegen { font_name } {
    global fd_family fd_style fd_size  t
    global fd_strikeout fd_underline

    set weight "normal"
    if { $fd_style == $t(0092) || $fd_style == $t(0094) } {
        set weight "bold"
    }
    set slant "roman"
    if { $fd_style == $t(0092) || $fd_style == $t(0093) } {
        set slant "italic"
    }
    font configure $font_name -family $fd_family -size $fd_size -underline \
	$fd_underline -overstrike $fd_strikeout -slant $slant -weight $weight
}

# text editor
set textedit(last_directory) $mame_basedir
set textedit(save_name) $t(0101)
global textedit

proc menubar_create { toplevel menubar } {
    frame $menubar -borderwidth 2 -relief raised
    pack $menubar -side top -fill x
}

proc menu_create { menubar menu button text mnemonic } {
    global tk_version
    if { $mnemonic >= 0 } {
        menubutton $button -text $text -menu $menu -underline $mnemonic
    } else {
        menubutton $button -text $text -menu $menu
    }
    pack $button -side left
    menu $menu 
}

proc file_read { filename } {
    set data ""
    if { [file readable $filename] } {
        set fd [open $filename "r"]
        set data [read $fd]
        close $fd
    }
    return $data
}

proc file_write { filename data } {
    return [catch {
        set fileid [open $filename "w"]
        puts -nonewline $fileid $data
        close $fileid
    }]
}

proc file_load { toplevel textwidget filename } {
    set data [file_read $filename]
    if { $data != "" } {
        file_new $toplevel $textwidget $filename
        $textwidget insert end $data
    }
    update
    focus .f1.entry
    myraise .f1.entry
}

proc file_new { toplevel textwidget title } {
    set names [$textwidget tag names]
    foreach tagname $names { $textwidget tag delete $tagname }
    $textwidget delete 1.0 end
    wm title $toplevel $title
}

proc file_open_get {  } {
    global textedit t
    set file_types {
        { "MAME Files"  { .cfg .CFG .dat .DAT .txt .TXT } }
        { "Text Files"  { .txt .TXT } }
        { "All Files"  * }
    }
#    set file_types \
#	[list "$t(0102)" [list .cfg .CFG .dat .DAT .txt .TXT] \
#	     "$t(0103)" [list .txt .TXT] "$t(0004)" [list *]]
    set filename [tk_getOpenFile -initialdir $textedit(last_directory) \
        -filetypes $file_types -title $t(0104) -parent .]
    set $textedit(last_directory) [file dirname $filename]
    return $filename
}

proc file_open { toplevel textwidget } {
    set filename [file_open_get]
    if { $filename != "" } {
        file_load $toplevel $textwidget $filename
    }
}

proc file_insert { toplevel textwidget } {
    set filename [file_open_get]
    if { $filename != "" } {
        set data [file_read $filename]
        if { $data != "" } {
            $textwidget insert insert $data
        }
    }
}

proc file_save { textwidget } {
    global  textedit t
    set data [$textwidget get 1.0 {end -1c}]
    set text [string trimright $data]
    return [file_write $textedit(save_name) $data]
}

proc file_save_get {  } {
    global textedit t
    set file_types {
        { "MAME Files"  { .cfg .CFG .dat .DAT .txt .TXT } }
        { "Text Files"  { .txt .TXT } }
        { "All Files"  * }
    }
#    set file_types {
#        { "$t(0102)"  { .cfg .CFG .dat .DAT .txt .TXT } }
#        { "$t(0103)"  { .txt .TXT } }
#        { "$t(0004)"  * }
#    }
    set filename [tk_getSaveFile -initialdir $textedit(last_directory) \
        -filetypes $file_types -title $t(0105) -parent .]
    set textedit(last_directory) [file dirname $filename]
    return $filename
}

proc file_save_as { toplevel textwidget } {
    global textedit t
    set filename [file_save_get]
    if { $filename != "" } {
        set textedit(save_name) $filename
        file_save $textwidget
        wm title $toplevel $filename
    }
}

proc file_exit { } {
    destroy .edit
    set edit_mapped 0
}

proc edit_cut { textwidget } {
    set owner [selection own]
    if { $owner == $textwidget } {
        clipboard clear
        catch {
            set text [selection get]
            clipboard append $text
            $owner delete sel.first sel.last
        }
    }
}

proc edit_copy { textwidget } {
    set owner [selection own]
    if { $owner == $textwidget } {
        clipboard clear
        catch { clipboard append [selection get] }
    }
}

proc edit_paste { textwidget } {
    catch { set clip [selection get -selection CLIPBOARD] }
    set idx [$textwidget index insert]
    set owner [selection own]
    if { $owner == $textwidget } {
        catch {         
            set idx [$owner index sel.first]
            $textwidget delete sel.first sel.last
        }
    }
    catch { $textwidget insert $idx $clip }
}

global find_last_indx
set find_last_indx 1.0
proc find_text { entrywidget textwidget } {
    global find_last_indx t
    set search_for [$entrywidget get]
    set length [string length $search_for]
    set indx [$textwidget search -- $search_for $find_last_indx end]
    if { $indx == "" } {
        set find_last_indx 1.0
        set indx [$textwidget search -- $search_for $find_last_indx end]
    }
    if { $indx != ""} {
        catch { $textwidget tag remove sel sel.first sel.last }
        $textwidget tag add sel $indx "$indx + $length chars"
        $textwidget mark set insert $indx
        $textwidget see $indx
        set find_last_indx "$indx + 1 char"
    } else {
        set find_last_indx 1.0
        puts "$search_for not found"
    }
}

proc textedit_create { height } {
    global textedit textname text_bg text_fg text_ibg edit_mapped t

    toplevel .edit
    wm protocol .edit WM_DELETE_WINDOW { 
	destroy .edit 
	set edit_mapped 0
    }
    bind .edit <FocusIn> {
	if { [string compare %p PlaceOnTop] == 0 } {
	    raise_all_windows %W
	}
    }

    set textname .edit.main.text
    menubar_create .edit .edit.menubar
    menu_create .edit.menubar .edit.menubar.file.filemenu \
          .edit.menubar.file $t(0106) 0
    menu_create .edit.menubar .edit.menubar.edit.editmenu \
          .edit.menubar.edit $t(0107) 0
    set men .edit.menubar.file.filemenu
    $men add command -label $t(0108) -underline 0 \
        -command "file_new .edit $textname Untitled"
    $men add command -label $t(0109) -underline 0 \
        -command "file_open .edit $textname"
    $men add command -label $t(0110) -underline 0 \
        -command "file_insert .edit $textname"
    $men add separator
    $men add command -label $t(0111) -underline 0 \
        -command "file_save $textname"
    $men add command -label $t(0112) -underline 5 \
        -command "file_save_as .edit $textname"
    $men add separator
    $men add command -label $t(0113) -underline 1 \
            -command {file_exit}
    set men .edit.menubar.edit.editmenu
    $men add command -label $t(0114) -underline 2 \
        -command "edit_cut $textname" -accelerator "Ctrl+X"
    $men add command -label $t(0115) -underline 0 \
        -command "edit_copy $textname" \
        -accelerator "Ctrl+C"
    $men add command -label $t(0116) -underline 0 \
        -command "edit_paste $textname" \
        -accelerator "Ctrl+V"
    set frm .edit.toolbar
    frame $frm -bd 1 -relief flat
    label $frm.label -text $t(0117)
    entry $frm.search
    button $frm.again -text $t(0118) \
            -command "find_text $frm.search $textname"
    pack $frm.label -side left -fill y
    pack $frm.search -side left -fill x -expand 1
    pack $frm.again  -side left -fill y
    bind $frm.search <Key-Return> \
       "find_text $frm.search $textname"
    pack $frm -side top -fill x
    set frm .edit.main
    frame $frm -bd 4 -relief sunken
    text $frm.text -font courierfont -width 80 -height $height -wrap none \
	    -yscrollcommand "$frm.vscroll set" \
	    -xscrollcommand "$frm.hscroll set"
    scrollbar $frm.vscroll -command "$frm.text yview"
    scrollbar $frm.hscroll -command "$frm.text xview" -orient horizontal
    pack $frm.vscroll -side right  -fill y
    pack $frm.hscroll -side bottom -fill x
    pack $frm.text -side left -fill both -expand 1
    pack $frm -side right -fill both -expand 1
    bind $frm.text <Control-Key-x> "edit_cut $frm.text; break"
    bind $frm.text <Control-Key-c> "edit_copy $frm.text; break"
    bind $frm.text <Control-Key-v> "edit_paste $frm.text; break"
    pack  $frm -side top -fill both -expand 1
    update
}

# load in default values
proc load_default_values { } {
    global s p t f
    global orig_ntsc orig_scanlines orig_vesa orig_ym3812 orig_ym2203

    set switch_list \
	[list altmame mame_exec ignorecfg throttle translucency record \
	    record_name gamma brightness sound volume scanlines other \
	    vesa vysnc flipx flipy norotate log mouse antialias romdir \
	    beam flicker cheat debug rol ror samplerate frameskip joystick \
	    cheatfile samplebits stereo artwork samples profiler]
    for {set i 0} {$i < [llength $switch_list]} {incr i} {
	set item [lindex $switch_list $i]
	set s($item) [def $item]
    }
    set s(cb_cheat) $s(cheat)
    set s(cheat) $s(cheatfile)

    if { [is_windows] } {
	set switch_list \
	    [list skiplines skipcolumns ntsc ym3812opl ym2203opl \
		alwayssynced resolution depth double vgafreq frameskip \
		joystick record soundcard samplerate vsync waitvsync \
		triplebuffer stretch vesamode]
	for {set i 0} {$i < [llength $switch_list]} {incr i} {
	    set item [lindex $switch_list $i]
	    set s($item) [def $item]
	}
	if { $s(ym3812opl) == 1 } {
	    set s(opl) ym3812opl
	} elseif { $s(ym2203opl) == 1 } {
	    set s(opl) ym2203opl
	} else {
	    set s(opl) None
	}

	cdrop $f(res).res          [def resolution] disabled $p(resolutions)
	cdrop $f(res).depth        [def depth]      disabled $p(depths)
	cdrop $f(res).vesamode     [def veasmode]   disabled $p(vesamodes)
	cdrop $f(res).stretch      [def stretch]    disabled $p(stretches)
	cdrop $f(res).double       [def double]     disabled $p(doubles)
	cdrop $f(res).vgafreq      [def vgafreq]    disabled $p(vgafreqs)
	cdrop $f(res).frameskip    [def frameskip]  disabled $p(frameskips)
	cdrop $f(other).joy        [def joystick]   disabled $p(joysticks)
	cdrop $f(other).record     [def record]     disabled $p(recordings)
	cdrop $f(sound).opl        [def opl]        disabled $p(opls)
	cdrop $f(sound).soundcard  [def soundcard]  disabled $p(soundcards)
	cdrop $f(sound).samplerate [def samplerate] normal   $p(samplerates)
	set switch_list [list romdir]
	for {set i 0} {$i < [llength $switch_list]} {incr i} {
	    cb_conf [lindex $switch_list $i]
	}
	set orig_ntsc -1
	set orig_scanlines -1
	set orig_vesa -1
	set orig_ym3812 -1
	set orig_ym2203 -1
    } else {
	set switch_list \
	    [list mitshm xsync dirty privatecmap forcetruecolor fullscreen \
		 swapjoyaxis analogstick analogmouse grabmouse videomode \
		 x11joyname paddevname fakesound audiodevice timerfreq \
		 numfrags fxgamma dblbuffer cabview netmapkey slave \
		 cabinet master spooldir heightscale widthscale scale \
		 fragsize samplerate cursor autoframeskip planar xil mtxil]
	for {set i 0} {$i < [llength $switch_list]} {incr i} {
	    set item [lindex $switch_list $i]
	    set s($item) [def $item]
	}
	cdrop $f(video).hscale [def heightscale] disabled $p(scales)
	cdrop $f(video).wscale [def widthscale] disabled $p(scales)
	cdrop $f(video).scale [def scale] disabled $p(scales)
	cdrop $f(video).frameskip [def frameskip] disabled $p(frameskips)
	cdrop $f(input).joystick [def joystick] disabled $p(joysticks)
	cdrop $f(other).f_record.record [def record] disabled $p(recordings)
	cdrop $f(sound).fragsize [def fragsize] disabled $p(fragsizes)
	cdrop $f(sound).samplerate [def samplerate] normal $p(samplerates)
	set switch_list \
	    [list x11joyname paddevname cabinet master slave other videomode \
		 audiodevice timerfreq numfrags romdir cheat spooldir log]
	for {set i 0} {$i < [llength $switch_list]} {incr i} {
	    cb_conf [lindex $switch_list $i]
	}
    }
}

# saves current settings to a config file
proc save_config { image } {
    global s t p wd altmame mame_exec cdesc version
    
    set desc [get_description]
    if { [info exists cdesc($desc)] } {
	set fn ${image}.tk
	append fn $cdesc($desc)
	set config_file [file join / $wd config $fn]
    } else {
	set config_file [file join / $wd config $image.tkc]
    }
    if  { [file isfile $config_file] } then {
	if { [tk_messageBox -title $t(0119) -type yesno -icon warning \
		-message $t(0120)] == "no" } {
	    return
	}
    }
    if { [is_windows] } {
	set sep "="
	set yes yes
	set no no
    } else {
	set sep " "
	set yes 1
	set no 0
    }

    set data "\[${image}\]\n"
    if { [is_unix] } {
	append data [format "heightscale      $sep %1.1f\n" $s(heightscale)]
	append data [format "widthscale       $sep %1.1f\n" $s(widthscale)]
	append data [format "scale            $sep %1.1f\n" $s(scale)]
	append data [format "gamma-correction $sep %1.2f\n" $s(gamma)]
	append data [format "fxgamma          $sep %1.2f\n" $s(fxgamma)]
	append data "mitshm         $sep $s(mitshm)\n"
	append data "xsync          $sep $s(xsync)\n"
	append data "dirty          $sep $s(dirty)\n"
	append data "privatecmap    $sep $s(privatecmap)\n"
	append data "x11-mode       $sep $s(fullscreen)\n"
	append data "throttle       $sep $s(throttle)\n"
	append data "dblbuffer      $sep $s(dblbuffer)\n"
	append data "cabview        $sep $s(cabview)\n"
	append data "netmapkey      $sep $s(netmapkey)\n"
	append data "slave          $sep $s(slave)\n"
	append data "cabinet        $sep $s(cabinet)\n"
	append data "master         $sep $s(master)\n"
	append data "brightness     $sep $s(brightness)\n"
	append data "sound          $sep $s(sound)\n"
	append data "fakesound      $sep $s(fakesound)\n"
	append data "audiodevice    $sep $s(audiodevice)\n"
	append data "fragsize       $sep $s(fragsize)\n"
	append data "timerfreq      $sep $s(timerfreq)\n"
	append data "videomode      $sep $s(videomode)\n"
	append data "numfrags       $sep $s(numfrags)\n"
	append data "samplebits     $sep $s(samplebits)\n"
	append data "swapjoyaxis    $sep $s(swapjoyaxis)\n"
	append data "analogstick    $sep $s(analogstick)\n"
	append data "analogmouse    $sep $s(analogmouse)\n"
	append data "grabmouse      $sep $s(grabmouse)\n"
	append data "x11joyname     $sep $s(x11joyname)\n"
	append data "paddevname     $sep $s(paddevname)\n"
	append data "log            $sep $s(log)\n"
	append data "rompath        $sep $s(romdir)\n"
	append data "spooldir       $sep $s(spooldir)\n"
	append data "cursor         $sep $s(cursor)\n"
	append data "autoframeskip  $sep $s(autoframeskip)\n"
	append data "planar         $sep $s(planar)\n"
	append data "xil            $sep $s(xil)\n"
	append data "mtxil          $sep $s(mtxil)\n"
	append data "joytype        $sep [lsearch $p(joysticks) $s(joystick)]\n"
	if { $version < 35 } {
	    append data "forcetruecolor $sep $s(forcetruecolor)\n"
	}
    } else {
	append data "depth $sep $s(depth)\n"
	append data "veasmode $sep $s(vesamode)\n"
	append data "stretch $sep $s(stretch)\n"
	append data "double $sep "
	if { $s(double) == [lindex $p(doubles) 1] } {
	    append data " $yes\n"
	} elseif { $s(double) == [lindex $p(doubles) 2] } {
	    append data " $no\n"
	} else {
	    append data " auto\n"
	}
	append data "vgafreq $sep "
	if { $s(vgafreq) == [lindex $p(vgafreqs) 0] } {
	    append data " -1\n"
	} else {
	    append data " $s(vgafreq)\n"
	}
	if { $s(resolution) == [lindex $p(resolutions) 0] } {
	    append data "resolution $sep auto\n"
	} elseif { $s(resolution) != [lindex $p(resolutions) end] } {
	    append data "resolution $sep $s(resolution)\n"
	}
	append data "ntsc $sep "
	if { $s(ntsc) } then {
	    append data " $yes\n"
	} else {
	    append data " $no\n"
	}
	append data "gamma $sep $s(gamma)\n"
	append data "scanlines $sep "
	if { $s(scanlines) } {
	    append data " $yes\n"
	} else {
	    append data " $no\n"
	}
	append data "vsync $sep "
	if { $s(vsync) } {
	    append data " $yes\n"
	} else {
	    append data " $no\n"
	}
	append data "waitvsync $sep "
	if { $s(waitvsync) } {
	    append data " $yes\n"
	} else {
	    append data " $no\n"
	}
	append data "triplebuffer $sep "
	if { $s(triplebuffer) } {
	    append data " $yes\n"
	} else {
	    append data " $no\n"
	}
	append data "vesa $sep "
	if { $s(vesa) } {
	    append data " $yes\n"
	} else {
	    append data " $no\n"
	}
	append data "skiplines $sep $s(skiplines)\n"
	append data "skipcolumns $sep $s(skipcolumns)\n"
	append data "soundcard $sep "
	append data "[expr [lsearch $p(soundcards) $s(soundcard)] - 1]\n"
	append data "ym3812opl $sep "
	if { $s(ym3812opl) } {
	    append data "$yes\n"
	} else {
	    append data "$no\n"
	}
	append data "ym2203opl $sep "
	if { $s(ym2203opl) } {
	    append data "$yes\n"
	} else {
	    append data "$no\n"
	}
	append data "joystick $sep [lindex $p(joynames) [lsearch $p(joysticks) $s(joystick)]]\n"
	append data "alwayssynced $sep "
	if { $s(alwayssynced) } {
	    append data "$yes\n"
	} else {
	    append data "$no\n"
	}
	append data "samplebits $sep "
	if { $s(samplebits) } { 
	    append data "16\n"
	} else {
	    append data "8\n"
	}
	append data "cheat $sep "
	if { $s(cb_cheat) } {
	    append data "$yes\n"
	} else {
	    append data "$no\n"
	}
	append data "log $sep "
	if { $s(log) } {
	    append data " $yes\n"
	} else {
	    append data " $no\n"
	}
	if { $s(cb_romdir) && ($s(romdir) != "") } {
	    append data "romdir $sep $s(romdir)\n" 
	}
    }
    append data "debug $sep "
    if { $s(debug) } {
	append data "$yes\n"
    } else {
	append data "$no\n"
    }
    append data "cheatfile      $sep $s(cheat)\n"
    append data "volume         $sep $s(volume)\n"
    append data "stereo $sep "
    if { $s(stereo) } {
	append data " $yes\n"
    } else {
	append data " $no\n"
    }
    if { $s(other) != "" } { append data "other $sep $s(other)\n" }
    append data "translucency $sep "
    if { $s(translucency) } {
	append data " $yes\n"
    } else {
	append data " $no\n"
    }
    append data "artwork $sep "
    if { $s(artwork) } {
	append data " $yes\n"
    } else {
	append data " $no\n"
    }
    append data "samples $sep "
    if { $s(samples) } {
	append data " $yes\n"
    } else {
	append data " $no\n"
    }
    append data "profiler $sep "
    if { $s(profiler) } {
	append data " $yes\n"
    } else {
	append data " $no\n"
    }
    append data "altmame $sep "
    if { $s(altmame) } {
	append data " $yes\n"
    } else {
	append data " $no\n"
    }
    if { $s(mame_exec) != "" } {
	append data "mame_exec $sep $s(mame_exec)\n"
    }
    append data "ignorecfg $sep "
    if { $s(ignorecfg) } {
	append data " $yes\n"
    } else {
	append data " $no\n"
    }
    append data "antialias $sep "
    if { $s(antialias) } {
	append data " $yes\n"
    } else {
	append data " $no\n"
    }
    append data "beam $sep $s(beam)\n"
    append data "flicker $sep $s(flicker)\n"
    if { $s(frameskip) == "auto" } {
	append data "frameskip $sep $s(frameskip)\n"
    } else {
	append data "frameskip $sep [expr $s(frameskip) / 5]\n"
    }

    append data "ror $sep "
    if { $s(ror) } {
	append data "$yes\n"
    } else {
	append data "$no\n"
    }

    append data "rol $sep "
    if { $s(rol) } {
	append data "$yes\n"
    } else { 
	append data "$no\n"
    }

    append data "norotate $sep "
    if { $s(norotate) } {
	append data "$yes\n"
    } else {
	append data "$no\n"
    }

    append data "flipx $sep "
    if { $s(flipx) } {
	append data "$yes\n"
    } else {
	append data "$no\n"
    }

    append data "flipy $sep "
    if { $s(flipy) } { 
	append data "$yes\n"
    } else { 
	append data "$no\n"
    }

    append data "samplerate $sep $s(samplerate)\n"

    append data "mouse $sep "
    if { $s(mouse) } { 
	append data "$yes\n"
    } else {
	append data "$no\n"
    }

    if { $s(record_name) != "" } {
	if { $s(record) == [lindex $p(recordings) 1] } {
	    append data "record $sep $s(record)\n"
	    append data "record_name $sep $s(record_name)\n"
	} elseif { $s(record) == [lindex $p(recordings) 2] } {
	    append data "record $sep [lindex $p(recordings) 2]\n"
	    append data "record_name $sep $s(record_name)\n"
	} else {
	    append data "record_name $sep $s(record_name)\n"
	}
    }
    
    set fd [open $config_file w]
    puts $fd $data
    flush $fd
    close $fd
}


set orig_ntsc -1
set orig_scanlines -1
set orig_vesa -1
set orig_ym3812 -1
set orig_ym2203 -1

proc set_orig_values { use_default } {
    global mame list s p orig_ntsc orig_scanlines orig_vesa record_name_entry \
	orig_ym3812 orig_ym2203 version t f

    if { $s(resolution) != "288x224" } { 
	if { $orig_ntsc == -1 } {
	    if { $use_default == 1 } {
		set orig_ntsc [def ntsc]
	    } else {
		set orig_ntsc $s(ntsc)
	    }
	}
	$f(res).ntsc configure -state disabled
	set s(ntsc) 0 
    } elseif { ( $s(ntsc) != $orig_ntsc ) && ( $orig_ntsc != -1 ) } {
	set s(ntsc) $orig_ntsc
	set orig_ntsc -1
	$f(res).ntsc configure -state normal
    } else {
	set orig_ntsc -1
	$f(res).ntsc configure -state normal
    }
    if { ( $s(resolution) != "288x224" ) \
	    && ( $s(resolution) != "256x256" ) \
	    && ( $s(resolution) != "224x288" ) \
	    && ( $s(resolution) != "Automatic" ) \
	    && ( $s(resolution) != "None" ) } {
	if { $orig_scanlines == -1 } {
	    if { $use_default == 1 } {
		set orig_scanlines [def scanlines]
	    } else {
		set orig_scanlines $s(scanlines)
	    }
	}
	set s(scanlines) 0
	$f(res).scanlines configure -state disabled
    } elseif { ( $s(scanlines) != $orig_scanlines ) \
	    && ( $orig_scanlines != -1 ) } {
	set s(scanlines) $orig_scanlines
	set orig_scanlines -1
	$f(res).scanlines configure -state normal
    } else {
	set orig_scanlines -1
	$f(res).scanlines configure -state normal
    }
    if { ( $s(resolution) != "288x224" ) \
	    && ( $s(resolution) != "256x256" ) \
	    && ( $s(resolution) != "224x288" ) \
	    && ( $s(resolution) != "320x204" ) \
	    && ( $s(resolution) != "200x320" ) \
	    && ( $s(resolution) != "240x272" ) \
	    && ( $s(resolution) != "Automatic" ) \
	    && ( $s(resolution) != "None" ) } {
	if { $orig_vesa == -1 } {
	    if { $use_default == 1 } {
		set orig_vesa [def vesa]
	    } else {
		set orig_vesa $s(vesa)
	    }
	}
	set s(vesa) 1
	$f(res).vesa configure -state normal
    } elseif { ( $s(resolution) == "288x224" ) || \
	    ( $s(resolution) == "256x256" ) || \
	    ( $s(resolution) == "224x288" ) || \
	    ( $s(resolution) == "320x204" ) || \
	    ( $s(resolution) == "200x320" ) || \
	    ( $s(resolution) == "240x272" ) } {
	if { $orig_vesa == -1 } {
	    if { $use_default == 1 } {
		set orig_vesa [def vesa]
	    } else {
		set orig_vesa $s(vesa)
	    }
	}
	set s(vesa) 0
	$f(res).vesa configure -state disabled
    } elseif { ( $s(vesa) != $orig_vesa ) && ( $orig_vesa != -1 ) } {
	set s(vesa) $orig_vesa
	set orig_vesa -1
	$f(res).vesa configure -state normal
    } else {
	set orig_vesa -1
	$f(res).vesa configure -state normal
    }
}

# Gets the command line options
proc get_command { image use_default } {
    global mame list s p orig_ntsc orig_scanlines orig_vesa record_name_entry \
	orig_ym3812 orig_ym2203 version t f space slashspace

    if { ( $s(altmame) ) && ( $s(mame_exec) != "" ) } {
	if { [is_unix] } {
	    set cmd "[replace [replace_slashes $s(mame_exec)] $space $slashspace] "
	} else {
	    set cmd "[quote_string $s(mame_exec)]"
	}
    } else {
	if { [is_unix] } {
	    set cmd "[replace [replace_slashes $mame] $space $slashspace] "
	} else {
	    set cmd "[quote_string [replace_slashes $mame]] "
	}
    }
    if { [is_windows] } {
	if { $s(cb_romdir) && ( $s(romdir) != "" ) } { 
	    append cmd "$s(romdir) "
	} else {
	    append cmd "$image "
	}
    } else { append cmd "$image " }
    if { $s(other) != "" && $s(cb_other) } { append cmd " $s(other)" }
    if { [is_windows] } {
	if { $s(ignorecfg) } { append cmd " -ignorecfg" }
	if { ( $s(resolution) != [def resolution] ) || $s(ignorecfg) } {
	    if { $s(resolution) == "Automatic" } {
		append cmd " -resolution auto"
	    } elseif { $s(resolution) != "None" } {
		append cmd " -resolution $s(resolution)"
	    }
	}
	set_orig_values $use_default
	if { ( !$s(ignorecfg) && ( $s(depth) != [def depth] )) \
		 || ( $s(ignorecfg) && ( $s(depth) != 16 )) } {
	    append cmd " -depth $s(depth)" 
	}
	if { ( !$s(ignorecfg) && ( $s(vesamode) != [def vesamode] )) \
		 || ( $s(ignorecfg) && ( $s(vesamode) != "vesa2l" )) } {
	    append cmd " -vesamode $s(vesamode)" 
	}
	if { ( !$s(ignorecfg) && ( $s(stretch) != [def stretch] )) \
		 || ( $s(ignorecfg) && ( $s(stretch) != "off" )) } {
	    append cmd " -stretch $s(stretch)" 
	}
	if { ( !$s(ignorecfg) && ( $s(double) != [def double] )) \
		|| ( $s(ignorecfg) && $s(double) != "Auto" ) } {
	    if { $s(double) == [lindex $p(doubles) 1] } {
		append cmd " -double"
	    } elseif { $s(double) == [lindex $p(doubles) 2] } {
		append cmd " -nodouble"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(vgafreq) != [def vgafreq] )) \
		 || ( $s(ignorecfg) && ( $s(vgafreq) != "Auto" )) } {
	    if { $s(vgafreq) == "Auto" } {
		append cmd " -vgafreq -1"
	    } else {
		append cmd " -vgafreq $s(vgafreq)" 
	    }
	}
	if { $s(opl) == "ym2203opl" } {
	    set s(ym2203opl) 1
	    set s(ym3812opl) 0
	} elseif { $s(opl) == "ym3812opl" } {
	    set s(ym3812opl) 1
	    set s(ym2203opl) 0
	} else {
	    set s(ym3812opl) 0
	    set s(ym2203opl) 0
	}
	if { ( $s(soundcard) != "Sound Blaster" ) \
		&& ( $s(soundcard) != "Sound Blaster AWE 32" ) } {
	    if { $orig_ym3812 == -1 } {
		set orig_ym3812 $s(ym3812opl)
	    }
	    if { $orig_ym2203 == -1 } {
		set orig_ym2203 $s(ym2203opl)
	    }
	    cdrop $f(sound).opl None disabled $p(opls)
	    set s(ym3812opl) 0
	    set s(ym2203opl) 0
	} else {
	    if { ( $s(ym3812opl) != $orig_ym3812 ) && ( $orig_ym3812 != -1 ) } {
		set s(ym3812opl) $orig_ym3812
		set orig_ym3812 -1
		if { $s(ym3812opl) } {
		    cdrop $f(sound).opl ym3812opl disabled $p(opls)
		}
	    } else {
		set orig_ym3812 -1
		if { $s(ym3812opl) } {
		    cdrop $f(sound).opl ym3812opl disabled $p(opls)
		}
	    }
	    if { ($s(ym2203opl) != $orig_ym2203) && ($orig_ym2203 != -1) } {
		set s(ym2203opl) $orig_ym2203
		set orig_ym2203 -1
		if { $s(ym2203opl) } {
		    cdrop $f(sound).opl ym2203opl disabled $p(opls)
		}
	    } else {
		set orig_ym2203 -1
		if { $s(ym2203opl) } {
		    cdrop $f(sound).opl ym2203opl disabled $p(opls)
		}
	    }
	    if { ( !$s(ignorecfg) && ( $s(ym3812opl) != [def ym3812opl] )) \
		    || ( $s(ignorecfg) && ( $s(ym3812opl) )) } {
		if { $s(ym3812opl) } {
		    append cmd " -ym3812opl"
		} else {
		    append cmd " -noym3812opl"
		}
	    }
	    if { ( !$s(ignorecfg) && ( $s(ym2203opl) != [def ym2203opl] )) \
		    || ( $s(ignorecfg) && ( $s(ym2203opl) )) } {
		if { $s(ym2203opl) } {
		    append cmd " -ym2203opl"
		} else {
		    append cmd " -noym2203opl"
		}
	    }
	}

	if { ( !$s(ignorecfg) && ( $s(scanlines) != [def scanlines] )) \
	     || ( $s(ignorecfg) && $s(scanlines) ) } {
	    if { $s(scanlines)} {
		append cmd " -scanlines"
	    } else {
		append cmd " -noscanlines"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(vesa) != [def vesa] )) \
		 || ( $s(ignorecfg) && $s(vesa) ) } {
	    if { $s(vesa) } {
		append cmd " -vesa" 
	    } else {
		append cmd " -novesa"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(vsync) != [def vsync] )) \
		 || ( $s(ignorecfg) && $s(vsync) ) } {
	    if { $s(vsync) } {
		append cmd " -vsync"
	    } else {
		append cmd " -novsync"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(waitvsync) != [def waitvsync] )) \
		 || ( $s(ignorecfg) && $s(waitvsync) ) } {
	    if { $s(waitvsync) } {
		append cmd " -waitvsync"
	    } else {
		append cmd " -nowaitvsync"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(triplebuffer) != [def triplebuffer] )) \
		 || ( $s(ignorecfg) && $s(triplebuffer) ) } {
	    if { $s(triplebuffer) } {
		append cmd " -triplebuffer"
	    } else {
		append cmd " -notriplebuffer"
	    }
	}
	if { $s(ntsc) } { append cmd " -ntsc" }
	if { ( !$s(ignorecfg) && ( $s(joystick) != [def joystick] )) \
		|| ( $s(ignorecfg) ) } {
	    set index [lsearch $p(joysticks) $s(joystick)]
	    append cmd " -joy [lindex $p(joynames) $index]"
	}
	if { ( !$s(ignorecfg) && ( $s(skiplines) != [def skiplines] )) \
		 || ( $s(ignorecfg) && $s(skiplines) ) } { 
	    append cmd " -skiplines $s(skiplines)" 
	}
	if { ( !$s(ignorecfg) && ( $s(skipcolumns) != [def skipcolumns] )) \
		 || ( $s(ignorecfg) && $s(skipcolumns) ) } {
	    append cmd " -skipcolumns $s(skipcolumns)"
	}
	if { ( !$s(ignorecfg) && ( $s(alwayssynced) != [def alwayssynced] )) \
		 || ( $s(ignorecfg) && !$s(alwayssynced) ) } {
	    if { $s(alwayssynced) } {
		append cmd " -alwayssynced"
	    } else {
		append cmd " -noalwayssynced" 
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(soundcard) != [def soundcard] )) \
		 || ( $s(ignorecfg) && ( $s(soundcard) != $t(0209) )) } {
	    append cmd " -soundcard "
	    append cmd "[expr [lsearch $p(soundcards) $s(soundcard)] - 1]"
	}
	if { $s(log) } { append cmd " -log" }
    } else { 
	if { ( !$s(ignorecfg) && ( $s(scale) != [def scale] )) \
		 || $s(ignorecfg) } {
	    append cmd " -scale $s(scale)"
	} else {
	    if { (!$s(ignorecfg) && ($s(heightscale) != [def heightscale])) \
		     || $s(ignorecfg) } {
		append cmd " -heightscale $s(heightscale)"
	    }
	    if { (!$s(ignorecfg) && ( $s(widthscale) != [def widthscale] )) \
		     || $s(ignorecfg) } {
		append cmd " -widthscale $s(widthscale)"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(joystick) != [def joystick] )) \
		 || $s(ignorecfg) } {
	    append cmd " -joytype [lsearch $p(joysticks) $s(joystick)]"
	}
	if { ( !$s(ignorecfg) && ( $s(swapjoyaxis) != [def swapjoyaxis] )) \
		 || $s(ignorecfg) } {
	    if { $s(swapjoyaxis) } {
		append cmd " -swapjoyaxis"
	    } else {
		append cmd " -noswapjoyaxis"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(analogstick) != [def analogstick] )) \
		 || $s(ignorecfg) } {
	    if { $s(analogstick) } {
		append cmd " -analogstick"
	    } else {
		append cmd " -noanalogstick"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(analogmouse) != [def analogmouse] )) \
		 || $s(ignorecfg) } {
	    if { $s(analogmouse) } {
		append cmd " -analogmouse"
	    } else {
		append cmd " -noanalogmouse"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(grabmouse) != [def grabmouse] )) \
		 || $s(ignorecfg) } {
	    if { $s(grabmouse) } {
		append cmd " -grabmouse"
	    } else {
		append cmd " -nograbmouse"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(paddevname) != [def paddevname] )) \
		 || $s(ignorecfg) } {
	    if { (( $s(paddevname) != [def paddevname] ) && \
		       $s(cb_paddevname)) || $s(ignorecfg) } {
		append cmd " -paddevname $s(paddevname)"
	    } 
	}
	if { ( !$s(ignorecfg) && ( $s(x11joyname) != [def x11joyname] )) \
		 || $s(ignorecfg) } {
	    if { (( $s(x11joyname) != [def x11joyname] ) && \
		     $s(cb_x11joyname)) || $s(ignorecfg) } {
		append cmd " -x11joyname $s(x11joyname)"
	    }
	}
	if { ( !$s(ignorecfg) && ($s(sound) != [def sound] )) \
		 || $s(ignorecfg) } {
	    if { $s(sound) } {
		append cmd " -sound"
	    } else {
		append cmd " -nosound"
	    }
	}
	if { ( !$s(ignorecfg) && ($s(audiodevice) != [def audiodevice] )) \
		 || ( $s(ignorecfg) && ( $s(audiodevice) != "" )) } {
	    if { (( $s(audiodevice) != [def audiodevice] ) && \
		       $s(cb_audiodevice)) || $s(ignorecfg) } {
		append cmd " -audiodevice $s(audiodevice)"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(fakesound) != [def fakesound] )) \
		 || $s(ignorecfg) } {
	    if { $s(fakesound) } {
		append cmd " -fakesound"
	    }
	} 
	if { ( !$s(ignorecfg) && ( $s(timerfreq) != [def timerfreq] )) \
		 || $s(ignorecfg) } {
	    if { (( $s(timerfreq) != [def timerfreq] ) && \
		       $s(cb_timerfreq)) || $s(ignorecfg) } {
		append cmd " -timerfreq $s(timerfreq)"
	    } 
	}
	if { ( !$s(ignorecfg) && ( $s(videomode) != [def videomode] )) \
		 || $s(ignorecfg) } {
	    append cmd " -videomode [lsearch $p(videomodes) $s(videomode)]"
	}
	if { ( !$s(ignorecfg) && ( $s(numfrags) != [def numfrags] )) \
		 || $s(ignorecfg) } {
	    if { (( $s(numfrags) != [def numfrags] ) && \
		       $s(cb_numfrags)) || $s(ignorecfg) } {
		append cmd " -numfrags $s(numfrags)"
	    } 
	}
	if { ( !$s(ignorecfg) && ( $s(fragsize) != [def fragsize] )) \
		 || $s(ignorecfg) } {
	    append cmd " -fragsize $s(fragsize)"
	}
	if { ( !$s(ignorecfg) && ( $s(mitshm) != [def mitshm] )) \
		 || $s(ignorecfg) } {
	    if { $s(mitshm) } {
		append cmd " -mitshm"
	    } else {
		append cmd " -nomitshm"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(xsync) != [def xsync] )) \
		 || $s(ignorecfg) } {
	    if { $s(xsync) } {
		append cmd " -xsync"
	    } else {
		append cmd " -noxsync"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(dirty) != [def dirty] )) \
		 || $s(ignorecfg) } {
	    if { $s(dirty) } {
		append cmd " -dirty"
	    } else {
		append cmd " -nodirty"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(privatecmap) != [def privatecmap] )) \
		 || $s(ignorecfg) } {
	    if { $s(privatecmap) } {
		append cmd " -privatecmap"
	    } else {
		append cmd " -noprivatecmap"
	    }
	}
	if { $version < 35 } {
	    if { ( !$s(ignorecfg) && \
		       ( $s(forcetruecolor) != [def forcetruecolor] )) || \
		     $s(ignorecfg) } {
		if { $s(forcetruecolor) } {
		    append cmd " -forcetruecolor"
		} else {
		    append cmd " -noforcetruecolor"
		}
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(fullscreen) != [def fullscreen] )) \
		 || $s(ignorecfg) } {
	    if { $s(fullscreen) } {
		append cmd " -x11-mode 1"
	    } else {
		append cmd " -x11-mode 0"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(throttle) != [def throttle] )) \
		 || $s(ignorecfg) } {
	    if { $s(throttle) } {
		append cmd " -throttle"
	    } else {
		append cmd " -nothrottle"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(cursor) != [def cursor] )) \
		 || $s(ignorecfg) } {
	    if { $s(cursor) } {
		append cmd " -cursor"
	    } else {
		append cmd " -nocursor"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(planar) != [def planar] )) \
		 || $s(ignorecfg) } {
	    if { $s(planar) } {
		append cmd " -planar"
	    } else {
		append cmd " -noplanar"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(xil) != [def xil] )) || $s(ignorecfg) } {
	    if { $s(xil) } {
		append cmd " -xil"
	    } else {
		append cmd " -noxil"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(mtxil) != [def mtxil] )) \
		 || $s(ignorecfg) } {
	    if { $s(mtxil) } {
		append cmd " -mtxil"
	    } else {
		append cmd " -nomtxil"
	    }
	}
	if { (!$s(ignorecfg) && ( $s(autoframeskip) != [def autoframeskip] )) \
		 || $s(ignorecfg) } {
	    if { $s(autoframeskip) } {
		if { !$s(frameskip) } {
		    append cmd " -autoframeskip"
		}
	    } else {
		append cmd " -noautoframeskip"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(brightness) != [def brightness] )) \
		 || $s(ignorecfg) } {
	    append cmd " -brightness $s(brightness)"
	}
	if { ( !$s(ignorecfg) && ( $s(fxgamma) != [def fxgamma] )) \
		 || $s(ignorecfg) } {
	    append cmd " -fxgamma $s(fxgamma)"
	}
	if { ( !$s(ignorecfg) && ( $s(dblbuffer) != [def dblbuffer] )) \
		 || $s(ignorecfg) } {
	    if { $s(dblbuffer) } {
		append cmd " -dblbuffer"
	    } else {
		append cmd " -nodblbuffer"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(cabview) != [def cabview] )) \
		 || $s(ignorecfg) } {
	    if { $s(cabview) } {
		append cmd " -cabview"
	    } else {
		append cmd " -fullview"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(netmapkey) != [def netmapkey] )) \
		 || $s(ignorecfg) } {
	    if { $s(netmapkey) } { append cmd " -netmapkey" }
	}
	if { ( !$s(ignorecfg) && ( $s(slave) != [def slave] )) \
		 || ( $s(ignorecfg) && $s(slave) != "" ) } {
	    if { (( $s(slave) != [def slave] ) && $s(cb_slave)) || \
		     $s(ignorecfg) } {
		append cmd " -slave $s(slave)"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(cabinet) != [def cabinet] )) \
		 || ( $s(ignorecfg) && $s(cabinet) != "" ) } {
	    if { (( $s(cabinet) != [def cabinet] ) && $s(cb_cabinet)) || \
		     $s(ignorecfg) } {
		append cmd " -cabinet $s(cabinet)"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(master) != [def master] )) \
		 || ( $s(ignorecfg) && $s(master) != "" ) } {
	    if { (( $s(master) != [def master] ) && $s(cb_master)) || \
		     $s(ignorecfg) } {
		append cmd " -master $s(master)"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(log) != "" )) || \
		 ( $s(ignorecfg) && $s(log) != "" ) } {
	    if { (( $s(log) != "" ) && $s(cb_log)) || $s(ignorecfg) } {
		append cmd " -log $s(log)"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(spooldir) != [def spooldir] )) \
		 || ( $s(ignorecfg) && $s(spooldir) != "" ) } {
	    if { (( $s(spooldir) != [def spooldir] ) && $s(cb_spooldir)) || \
		     $s(ignorecfg) } {
		append cmd " -spooldir $s(spooldir)"
	    }
	}
	if { ( !$s(ignorecfg) && ( $s(romdir) != [def romdir] )) \
		 || ( $s(ignorecfg) && $s(romdir) != "" ) } {
	    if { (( $s(romdir) != [def romdir] ) && $s(cb_romdir)) || \
		     $s(ignorecfg) } {
		append cmd " -rompath $s(romdir)"
	    }
	}
    }
    if { $s(debug) } { append cmd " -debug" }
    if { ( !$s(ignorecfg) && ($s(volume) != [def volume] )) \
	    || $s(ignorecfg) } {
	append cmd " -volume $s(volume)"
    }
    if { ( !$s(ignorecfg) && ( $s(stereo) != [def stereo] )) \
	     || ( $s(ignorecfg) && $s(stereo)) } {
	if { $s(stereo) } {
	    append cmd " -stereo"
	} else {
	    if { [is_windows] } {
		append cmd " -nostereo"
	    } else {
		append cmd " -mono"
	    }
	}
    }
    if { ( !$s(ignorecfg) && ( $s(samplebits) != [def samplebits] )) \
	     || ( $s(ignorecfg) && $s(samplebits) ) } {
	if { $s(samplebits) } {
	    if { [is_windows] } {
		append cmd " -sb 16"
	    } else {
		append cmd " -8bit"
	    }
	} else {
	    if { [is_windows] } {
		append cmd " -sb 8"
	    } else {
		append cmd " -16bit"
	    }
	}
    }
    if { $s(cb_cheat) } {
	append cmd " -cheat"
    }
    if { ( !$s(ignorecfg) && ( $s(cheat) != "" )) || \
	     ( $s(ignorecfg) && $s(cheat) != "" ) } {
	if { (( $s(cheat) != "" ) && $s(cb_cheat)) || $s(ignorecfg) } {
	    append cmd " -cheatfile $s(cheat)"
	}
    }
    if { ( !$s(ignorecfg) && ( $s(artwork) != [def artwork] )) \
	    || $s(ignorecfg) } {
	if { $s(artwork) } {
	    append cmd " -artwork"
	} else {
	    append cmd " -noartwork"
	}
    }
    if { ( !$s(ignorecfg) && ( $s(samples) != [def samples] )) \
	    || $s(ignorecfg) } {
	if { $s(samples) } {
	    append cmd " -samples"
	} else {
	    append cmd " -nosamples"
	}
    }
    if { ( !$s(ignorecfg) && ( $s(profiler) != [def profiler] )) \
	    || $s(ignorecfg) } {
	if { $s(profiler) } {
	    append cmd " -profiler"
	} else {
	    append cmd " -noprofiler"
	}
    }
    if { ( !$s(ignorecfg) && ( $s(translucency) != [def translucency] )) \
	    || $s(ignorecfg) } {
	if { $s(translucency) } {
	    append cmd " -translucency"
	} else {
	    append cmd " -notranslucency"
	}
    }
    if { ( !$s(ignorecfg) && ( $s(gamma) != [def gamma] )) \
	     || ( $s(ignorecfg) && ( $s(gamma) != 0.2 || [is_unix] )) } {
	if { [is_unix] } {
	    append cmd " -gamma-correction $s(gamma)"
	} else {
	    append cmd " -gamma $s(gamma)" 
	}
    }
    if { $s(flipx) } { append cmd " -flipx" }
    if { $s(flipy) } { append cmd " -flipy" }
    if { $s(norotate) } { append cmd " -norotate" }
    if { ( !$s(ignorecfg) && ( $s(mouse) != [def mouse] )) \
	     || ( $s(ignorecfg) && ( !$s(mouse) || [is_unix] )) } {
	if { $s(mouse) } {
	    append cmd " -mouse" 
	} else {
	    append cmd " -nomouse"
	}
    }
    if { ( !$s(ignorecfg) && ( $s(antialias) != [def antialias] )) \
	     || ( $s(ignorecfg) && ( !$s(antialias) || [is_unix] )) } {
	if { $s(antialias) } {
	    append cmd " -antialias" 
	} else {
	    append cmd " -noantialias"
	}
    }
    if { ( !$s(ignorecfg) && ( $s(beam) != [def beam] )) \
	     || ( $s(ignorecfg) && ( $s(beam) != 1 || [is_unix] )) } {
	append cmd " -beam $s(beam)"
    }
    if { ( !$s(ignorecfg) && ( $s(flicker) != [def flicker] )) \
	     || ( $s(ignorecfg) && ( $s(flicker) || [is_unix] )) } {
	append cmd " -flicker $s(flicker)"
    }
    if { $s(rol) } { append cmd " -rol" }
    if { $s(ror) } { append cmd " -ror" }
    if { ( $s(ignorecfg) && \
	       ( $s(samplerate) != "22050" ) && ( $s(samplerate) != "" )) || \
	     ( !$s(ignorecfg) && (( $s(samplerate) != [def samplerate] ) \
	    && ( $s(samplerate) != "" ))) } {
	if { [is_unix] } {
	    append cmd " -samplefreq $s(samplerate)"
	} else {
	    append cmd " -sr $s(samplerate)"
	}
    }
    if { ( !$s(ignorecfg) && ( $s(frameskip) != [def frameskip] )) \
	     || ( $s(ignorecfg) && ( $s(frameskip) != 0 || [is_unix] )) } {
	if { [is_unix] } {
	    if { $s(frameskip) && $s(autoframeskip) } {
		set s(autoframeskip) 0
		if { [def autoframeskip] } { append cmd " -noautoframeskip" }
	    }
	    append cmd " -frameskip [lsearch $p(frameskips) $s(frameskip)]"
	} else {
	    if { $s(frameskip) == "auto" } {
		append cmd " -frameskip auto"
	    } else {
		append cmd " -frameskip [expr $s(frameskip) / 5]"
	    }
	}
    }
    if { [lsearch $p(recordings) $s(record)] == 0 } {
	$record_name_entry configure -state disabled
	if { $s(record_name) != "" } {
	    set s(record_name) ""
	}
    } elseif { [lsearch $p(recordings) $s(record)] == 1 } {
	$record_name_entry configure -state normal
	if { $s(record_name) == "" } {
	    set s(record_name) $image
	}
	append cmd " -record $s(record_name)"
    } elseif { [lsearch $p(recordings) $s(record)] == 2 } {
	$record_name_entry configure -state normal
	if { $s(record_name) == "" } {
	    set s(record_name) $image
	}
	append cmd " -playback $s(record_name)"
    }
    
    return $cmd
}

# sets options from filename
proc set_options { filename } {
    catch {
	set fd [open $filename r]
	load_defaults $fd
	close $fd
    }
}

# procedure to replace slashes for DOS filenames
proc replace_slashes { data_string } {
    if { [is_windows] } {
	return [replace $data_string / \\]
    } else {
	return $data_string
    }
}

# search for .xpm's and prompt to convert to gifs
proc convert_snapshots { } {
    global env xmame_image_dir t

    set pattern [get_image_name]
    append pattern "-snap???.xpm"
    cd $env(HOME)
    set picture_files [glob -nocomplain $pattern]

    if { $picture_files != "" } {
	if { [tk_messageBox -title $t(0122) -type yesno \
		  -icon question -message $t(0121)] == "yes" } {
	    toplevel .pics
	    label .pics.label -text $t(0123)
	    listbox .pics.list -height 10 -yscrollcommand ".pics.scrl set"
	    foreach pic [split $picture_files] {
		.pics.list insert end $pic
	    }
	    scrollbar .pics.scrl -command ".pics.list yview"
	    frame .pics.buttons
	    button .pics.buttons.bconvert -text $t(0124) -command {
		set index [.pics.list curselection]
		if { $index == "" } {
		    tk_messageBox -title $t(0125) -type ok \
			-icon error -message $t(0126)
		} else {
		    set pic_file [.pics.list get $index]
		    set gif_file [file join / $xmame_image_dir \
				      [get_image_name]]
		    append gif_file ".gif"
		    catch { eval exec "convert $pic_file $gif_file" }
		    if { ![file exists $gif_file] } {
			tk_messageBox -title Error -type ok -icon error \
			    -message $t(0127)
		    } elseif { [.pics.list size] > 1 } {
			if { [tk_messageBox -title $t(0129) \
				  -type yesno -icon question \
				  -message $t(0128)] == "yes" } {
			    global picture_files
			    foreach file [split $picture_files] {
				catch { file delete $file }
			    }
			}
		    } else {
			catch { file delete $pic_file }
		    }
		}
	    }
	    button .pics.buttons.bcancel -text $t(0009) -command {
		destroy .pics
		return
	    }
	    pack .pics.label 
	    pack .pics.buttons -side bottom
	    pack .pics.scrl -side right -fill y
	    pack .pics.list -side left -fill both -expand 1
	    pack .pics.buttons.bconvert .pics.buttons.bcancel -side left
	}
    }
}

# Launches Mame
proc test_launch_mame { cmd } {
    global mame_basedir s wd tcl_platform pcx_dir mamecfg_fd t

    if { [is_windows] && $s(soundcard) == $t(0209)} {
	tk_messageBox -title $t(0012) -type ok -icon warning -message $t(0130)
    }
    cd $mame_basedir
    if { $cmd != "" } {
	if { [is_windows] } {
	    set fd [open m.bat w]
	    puts $fd $cmd
	    flush $fd
	    close $fd
	}
	if { [is_windows95] || [is_windows98] } {
	    set cmd "start /max /w command /c m.bat &"
	} elseif { [is_windows] } {
	    set cmd "command /c m.bat &"
	} else {
	    set cmd "xterm -e $cmd"
	}
	. configure -cursor watch
	update
	catch { eval exec $cmd }
	. configure -cursor top_left_arrow
	update
	convert_snapshots
    }
}

proc launch_mame { } {
    global wd mame_output start_time cdesc tcl_platform t
    update
    set image_name [get_image_name]
    set desc [get_description]
    if { [info exists cdesc($desc)] } {
	set fn ${image_name}.tk
	append fn $cdesc($desc)
	set config_file [file join / $wd config $fn]
    } else {
	set config_file [file join / $wd config ${image_name}.tkc]
    }
    if { [file isfile $config_file] } {
	set_options $config_file
    }
    set cmd "[get_command $image_name 0]"
    test_launch_mame $cmd
}


# view/edit a file
proc view_file { file } {
    global textedit textname edit_mapped t

    set textedit(save_name) $file
    if { [file isfile $textedit(save_name)] } {
	if { ![winfo exists .edit] } {
	    textedit_create 20
	    set edit_mapped 1
	}
	file_load .edit $textname $textedit(save_name)
    } else {
	tk_messageBox -title $t(0007) -type ok -icon error \
		-message "$t(0131) $textedit(save_name)"
    }
}

# This puts a text string on the text editor and sets the title
# to "Untitled"
proc view_command_output { output_string } {
    global textedit textname t
    if { ![winfo exists .edit] } { textedit_create 20 }
    set textedit(save_name) $t(0101)
    file_new .edit $textname $t(0101)
    $textname insert end $output_string
}

# parses the readme.txt file for notes on a selected image
proc parse_readme { filename image } {
    global t

    set str "$t(0132)\n"
    set data_found 0
    set fd [open $filename r]
    while { [gets $fd data] >= 0 } {
	if { [regexp \ +$image\ +.* $data] } {
	    set data_found 1
	    if { [regexp {[|]} $data] } {
		set str "==================================================="
		append str "=============================\n"
		append str "|                      |        |Accurate|      "
		append str "  |Hi score|Cocktail|Directory |\n"
		append str "| Game Name            |Playable| colors | Sound"
		append str "  |  save  |  mode  |   Name   |\n"
		append str "================================================"
		append str "================================\n"
		append str "$data\n"
		append str "|----------------------|--------|--------|------"
		append str "--|--------|--------|-----------\n\n"
		if { [regexp {\(1\)} $data] } {
		    append str "(1) Needs samples provided separately\n"
		}
		if { [regexp {\(2\)} $data] } {
		    append str "(2) Use the -fm option for OPL emulation "
		    append str "instead of digital emulation\n"
		}
		if { [regexp {\(3\)} $data] } {
		    append str "(3) Needs Sound Blaster OPL chip\n"
		}
		append str "\n"
	    }
	} elseif { [regexp \"+$image\".* $data] } {
	    if { [regexp ^\ .* $data] } {
		set char ""
		while { $char != "=" } {
		    seek $fd -2 current
		    set char [read $fd 1]
		    if { $char == "\n" } {
			seek $fd -1 current
		    }
		}
		while { $char != "\n" } {
		    seek $fd -2 current
		    set char [read $fd 1]
		}
		seek $fd -3 current
		set char [read $fd 1]
		while { $char != "\n" } {
		    seek $fd -2 current
		    set char [read $fd 1]
		}
		gets $fd data
		if { [regexp \"(.*)\" $data tmp new_image] } {
		    close $fd
		    return [parse_readme $filename $new_image]
		} else {
		    close $fd
		    return "$t(0133)\n"
		}
	    } else {
		set data_found 1
		append str "$data\n"
		set newlines 0
		while { [gets $fd data] >= 0 } {
		    if { $data == "" } {
			incr newlines
		    } else { 
			set newlines 0
		    }
		    if { $newlines == 2 } { break }
		    append str "$data\n"
		}
	    }
	}
    }
    close $fd
    if { !$data_found } {
	set str "$t(0133)\n"
    }

    return $str
}

proc parse_history { gamename } {
    global mame_basedir env history_data

    set found_game 0

    set parse_manufacturer 0
    set parse_year 0
    set parse_format 0
    set parse_bio 0

    set manufacturer ""
    set year ""
    set format ""
    set bio ""

    set history_data ""

    if { [is_windows] } {
	set history_file [file join / $mame_basedir history.dat]
    } else {
	set history_file [file join / $env(HOME) history.dat]
    }

    if { ![file isfile $history_file] } { return 0 }
    if { ![file readable $history_file] } { return 0 }

    set history_fd [open $history_file r]
    set history_data [read $history_fd]
    close $history_fd

    foreach line [split $history_data \n] {
	set line [string trim $line]
	if { [string index $line 0] == "#" } {
	    continue
	}
	if { $parse_manufacturer } {
	    if { [string index $line 0] == "-" } {
		set parse_manufacturer 0
	    } else {
		append manufacturer "[string trimleft $line _] "
	    }
	}
	if { $parse_year } {
	    if { [string index $line 0] == "-" } {
		set parse_year 0
	    } else {
		set year [string trimleft $line _]
	    }
	}
	if { $parse_format } {
	    if { [string compare $line \$bio] == 0 } {
		set parse_format 0
	    } else {
		append format "[string trimleft $line _] "
	    }
	}
	if { $parse_bio } {
	    if { [string compare $line \$end] == 0 } {
		set parse_bio 0
		break
	    } elseif { $line != "" } {
		append bio "\n$line"
	    }
	}
	if { $found_game } {
	    if { [string compare $line Mfg.] == 0 } {
		set parse_manufacturer 1
	    }
	    if { [string compare $line Year] == 0 } {
		set parse_year 1
	    }
	    if { [string compare $line Format] == 0 } {
		set parse_format 1
	    }
	    if { [string compare $line \$bio] == 0 } { 
		set parse_bio 1
	    }
	}
	if { [string first info= $line] != -1 } {
	    set games [string range $line [string wordend $line 5] end]
	    foreach game [split $games ,] {
		if { [string compare $gamename $game] == 0 } {
		    set found_game 1
		}
	    }
	}
    }

    if { $found_game } {
	set history_data "\nHistory Information for ${gamename}:\n\n"
	append history_data "Manufacturer: [string trimright $manufacturer]\n"
	append history_data "Year:         ${year}\n"
	append history_data "Format:       [string trimright $format]\n\n"
	if { $bio != "" } {
	    append history_data "[string trimright $bio]\n\n"
	}
	return 1
    }
    set history_data "\nNo History Information Found."
    return 0
}

# views notes on a rom
proc view_notes { } {
    global wd mame_basedir xmame_doc_dir t doc_file history_data

    set image [get_image_name]
    set notes_file [file join / $wd notes ${image}.not]
    if { [file isfile $notes_file] } {
	view_file $notes_file
    } else {
	if { [is_unix] } {
	    set doc_dir $xmame_doc_dir
	} else {
	    set doc_dir $mame_basedir
	}
	if { [doc_exists $doc_dir gamelist.txt] } {
	    set readme_file $doc_file
	} elseif { [doc_exists $doc_dir readme.txt] } {
	    set readme_file $doc_file
	} else {
	    set readme_file ""
	}
	if { ( $readme_file != "" ) && [file isfile $readme_file] } {
	    set data [parse_readme $readme_file $image]
	} else {
	    set data $t(0133)
	}
	parse_history $image
	append data "\n-------------------------------------------------\n"
	append data $history_data

	set notes_fd [open $notes_file w]
	puts $notes_fd $data
	flush $notes_fd
	close $notes_fd
	view_file $notes_file
    }
}

# shows missing roms
proc view_missing_roms { } {
    proc set_tab { str } {
	if { [string length $str] < 8 } then {
	    return "${str}\t\t"
	} else {
	    return "${str}\t"
	}
    }

    global missing_roms list_of_all_roms clones t

    if { [info exists tmp] } then { unset tmp }
    set rom_count 0
    foreach mrom [array get missing_roms] {
	if { [info exists tmp] } then {
	    incr rom_count
	    lappend lmr "[set_tab $tmp] $mrom"
	    unset tmp
	} else {
	    set tmp $mrom
	}
    }
    if { [info exists lmr] } {
	foreach mrom [lsort $lmr] { append output "$mrom\n" }
    } else {
      set output "*** $t(0134) ***"
    }
    set total_roms [llength $list_of_all_roms]
    set roms_found [expr $total_roms - $rom_count]
    append output "\n\n$t(0135) $total_roms"
    append output "\n$t(0136)   $rom_count"
    append output "\n$t(0137)   $roms_found\n"

    # do it again except dont include neogeo roms

    if { [info exists lmr] } { unset lmr }
    append output "\n\n\n\n  === $t(0138) === \n\n"
    if { [info exists tmp] } { unset tmp }
    set rom_count 0
    set ng_count 0
    set ng 0
    foreach mrom [array get missing_roms] {
	if { ( $ng == 1 ) || (( [info exists clones($mrom)] == 1 ) && \
		 ( $clones($mrom) == "neogeo" )) } {
	    if { $ng == 1 } {
		incr ng_count
		set ng 0
		continue
	    } else {
		set ng 1
		continue
	    }
	} elseif { [info exists tmp] } then {
	    incr rom_count
	    lappend lmr "[set_tab $tmp] $mrom"
	    unset tmp
	} else {
	    set tmp $mrom
	}
    }

    if { $rom_count > 0 } {
	foreach mrom [lsort $lmr] { append output "$mrom\n" }
    } else {
      append output "*** $t(0134) ***"
    }
    set total_roms [llength $list_of_all_roms]
    set roms_found [expr [expr $total_roms - $rom_count] - $ng_count]
    set roms_sup [expr $total_roms - $ng_count]
    append output "\n\n$t(0135) $roms_sup"
    append output "\n$t(0136)   $rom_count"
    append output "\n$t(0137)   $roms_found\n"
    
    view_command_output $output
}


# displays command output for verify rom
proc verify_rom { } {
    global mame mame_basedir wd

    set image_name [get_image_name]
    set tmpfile [file join / $wd tmp tktemp]
    if { [is_windows] } {
	set cmd "$mame -verifyroms $image_name > $tmpfile"
    } else {
	set cmd "$mame -verifyroms $image_name -stdout-file $tmpfile"
    }
    set output "$cmd\n\n"
    cd $mame_basedir
    catch { eval exec $cmd }
    catch {
	set fd [open $tmpfile r]
	set tmpout [read $fd]
	close $fd
	file delete $tmpfile
	append output $tmpout
    }
    view_command_output $output
}

# displays command output for verify samples
proc verify_samples { } {
    global mame mame_basedir wd

    set image_name [get_image_name]
    set tmpfile [file join / $wd tmp tktemp]
    if { [is_windows] } {
	set cmd "$mame -verifysamples $image_name > $tmpfile"
    } else {
	set cmd "$mame -verifysamples $image_name -stdout-file $tmpfile"
    }
    set output "$cmd\n\n"
    cd $mame_basedir
    catch { eval exec $cmd }
    catch {
	set fd [open $tmpfile r]
	set tmpout [read $fd]
	close $fd
	file delete $tmpfile
	append output $tmpout
    }
    view_command_output $output
}

proc very_short_doupdates { } {
    global t

    set desc [get_description]
    wm title .options "$t(0139) - $desc"
    update_command_line 0
}

proc short_doupdates { } {
    global wd textedit cdesc t

    set desc [get_description]
    wm title .options "$t(0139) - $desc"

    if { [winfo ismapped .graphics] } {
	update_graphics
    }
    if { [winfo exists .edit] && \
	    [regexp {.*\.not} $textedit(save_name)] } {
	view_notes
    }
    update_command_line 0
}

# does updates to all widgets
proc do_updates { } {
    global wd textedit cdesc t 
    set desc [get_description]
    wm title .options "$t(0139) - $desc"
    set rom [get_image_name]
    if { [info exists cdesc($desc)] } {
	set fn ${rom}.tk
	append fn $cdesc($desc)
	set config_file [file join / $wd config $fn]
    } else {
	set config_file [file join / $wd config ${rom}.tkc]
    }
    if { [file isfile $config_file] } {
	set_options $config_file
	update_command_line 1
    } else {
	load_default_values
	update_command_line 0
    }
    if { [winfo ismapped .graphics] } {
	update_graphics
    }
    if { [winfo exists .edit] && \
	    [regexp {.*\.not} $textedit(save_name)] } {
	view_notes
    }
}

# resets game keyboard settings
proc reset_keyboard { } {
    global mamecfg_fd mame_basedir xmame_working_dir t
    
    if { [is_windows] } {
	set cfg_path [read_config $mamecfg_fd cfg]
	set cfg_file [file join / $mame_basedir $cfg_path [get_image_name].cfg]
    } else {
	set cfg_file [file join / $xmame_working_dir [get_image_name].cfg]
    }
    if { [file exists $cfg_file] } {
	set msg "$t(0140) [get_description]?\n"
	if { [tk_messageBox -icon warning -type yesno -message $msg \
		-title $t(0141)] == "yes" } {
	    catch { file delete $cfg_file }
	}
    } else {
	tk_messageBox -title $t(0142) -type ok -icon info \
	    -message "$t(0143) $cfg_file"
    }
}

# resets game highscores
proc reset_highscores { } {
    global mamecfg_fd mame_basedir t

    set image [get_image_name]
    if { [is_windows] } {
	set hi_path [read_config $mamecfg_fd hi]
	set hiscore_file [file join / $mame_basedir $hi_path $image.hi]
    } else {
	set hi_path [read_config $mamecfg_fd spooldir]
	set hiscore_file [file join / $hi_path $image.hi]
    }
    if { [file exists $hiscore_file] } {
	set msg "$t(0144) [get_description]?\n"
	if { [tk_messageBox -title $t(0145) -type yesno \
		-icon warning -message $msg] == "yes" } {
	    catch { file delete $hiscore_file }
	}
    } else {
	tk_messageBox -title $t(0145) -type ok -icon info \
	    -message "$t(0143) $hiscore_file"
    }
}

proc rescan_notes { } {
    global wd t
    set notes_file [file join / $wd notes [get_image_name].not]
    if { [file exists $notes_file] } {
	if { [tk_messageBox -title $t(0146) -type yesno -icon warning \
		  -message "$t(0147)\n"] == "yes" } {
	    catch { file delete $notes_file }
	}
    }
    view_notes
}


# diagnostics
proc run_diagnostics { } {
    global rom_path mame_basedir duplicate_roms unknown_roms your_roms \
	    list_of_all_roms list_of_your_roms mame wd clones t
    
    set slyroms [lsort -dictionary [split $your_roms \n]]
    set message "$t(0148)\n\n"

    if { [is_windows] } {
	foreach dir [split $rom_path \;] {
	    if { [string match {[A-Za-z]:*} $dir] } {
		append message "[replace_slashes $dir]\n"
	    } else {
		append message "$mame_basedir/[replace_slashes $dir]\n"
	    }
	}
    } else {
	foreach dir [split $rom_path \:] {
	    append message "$dir\n"
	}
    }
    append message "\n$t(0149)\n"

    if { [is_windows] } {
	if { [tk_messageBox -title $t(0150) -type okcancel -icon warning \
		  -message $message] != "ok" } {
	    return
	}
    } else {
	global ok_pressed
	set stupid .unixcanthandledialogboxescorrectly
	toplevel $stupid
	frame $stupid.frame -relief groove -borderwidth 1
	wm protocol $stupid WM_DELETE_WINDOW {
	    destroy .unixcanthandledialogboxescorrectly
	    set ok_pressed 0
	}
	wm title $stupid Information
	label $stupid.frame.label -text $message -width 80
	button $stupid.ok -text $t(0095) -command { 
	    destroy .unixcanthandledialogboxescorrectly
	    set ok_pressed 1
	}
	button $stupid.cancel -text $t(0009) -command { 
	    destroy .unixcanthandledialogboxescorrectly
	    set ok_pressed 0
	}
	pack $stupid.frame.label -expand 1 -fill both
	grid config $stupid.frame -row 0 -column 0 -columnspan 2
	grid config $stupid.ok -row 1 -column 0 
	grid config $stupid.cancel -row 1 -column 1 
	tkwait window $stupid
	if { $ok_pressed == 0 } { return }
    }
    if { [info exists duplicate_roms] } {
	set message "$t(0151) $duplicate_roms."
	tk_messageBox -title $t(0152) -type ok -icon info -message $message
    }
    if { [info exists unknown_roms] } {
	set message "$t(0151) $unknown_roms."
	append message $t(0154)
	tk_messageBox -title $t(0217) -type ok -icon info -message $message
    }
    if { [tk_messageBox -title $t(0156) -type yesno \
	      -icon question -message $t(0155)] == "yes" } {
	set nng 1
	set ng_count 0
	foreach element [split [array get clones]] {
	    if { $element == "neogeo" } {
		incr ng_count
	    }
	}
    } else {
	set nng 0
    }
    if { $nng == 1 } {
	set yr_found [expr [llength $list_of_your_roms] - $ng_count]
	set ar_found [expr [llength $list_of_all_roms] - $ng_count]
    } else {
	set yr_found [llength $list_of_your_roms]
	set ar_found [llength $list_of_all_roms]
    }
	       
    set message "$t(0157) $yr_found $t(0158) $ar_found $t(0159)\n"
    if { [llength $list_of_your_roms] > 50 } {
	append message "\n $t(0161)"
    }
    if { [tk_messageBox -title $t(0162) -type yesno -icon question \
	    -message $message] == "yes" } {
	toplevel .please_wait
	wm withdraw .please_wait
	wm overrideredirect .please_wait 1
	frame .please_wait.frm -bd 5 -relief ridge 
	label .please_wait.frm.label -text $t(0163)
	pack .please_wait.frm.label .please_wait.frm
	center_window .please_wait
	wm deiconify .please_wait
	update
	catch {
	    cd $mame_basedir
	    set outfile [file join / $wd roms.chk]
            set cmd "$mame -verifyroms \* -stdout-file $outfile.out"
            set data ""
            set fileid [open |$cmd r]
            if { $fileid != "" } {
                set data [read $fileid]
                close $fileid
            }
        }
        set fd [open $outfile w+]
        puts -nonewline $fd $data
	destroy .please_wait
	toplevel .var
	wm title .var $t(0164)
	set frm .var.frm
	frame $frm -bd 0
	text $frm.txt -font courierfont -yscrollcommand "$frm.v_scroll set" \
		-xscrollcommand "$frm.h_scroll set"
	scrollbar $frm.h_scroll -orient horizontal -command "$frm.txt xview"
	scrollbar $frm.v_scroll -command "$frm.txt yview"
	pack $frm.v_scroll -side right -fill y
	pack $frm.h_scroll -side bottom -fill x
	pack $frm.txt -expand 1 -fill both
	pack $frm -side top -fill both -expand 1
	while { [gets $fd data] >= 0 } {
	    $frm.txt insert end "$data\n"
	}
	update
	close $fd
	tk_messageBox -title $t(0165) -type ok -icon info \
		-message "$t(0168) $outfile."
	destroy .var
    }
    set message "$t(0157) [llength $list_of_your_roms] $t(0158) [llength $list_of_all_roms] $t(0160)\n"
    if { [llength $list_of_your_roms] > 50 } {
	append message "\n $t(0161)"
    }
    if { [tk_messageBox -title $t(0166) -type yesno \
	    -icon question  -message $message] == "yes" } {
	toplevel .please_wait
	wm withdraw .please_wait
	wm overrideredirect .please_wait 1
	frame .please_wait.frm -bd 5 -relief ridge 
	label .please_wait.frm.label -text $t(0163)
	pack .please_wait.frm.label .please_wait.frm
	center_window .please_wait
	wm deiconify .please_wait
	cd $mame_basedir
	set outfile [file join / $wd samples.chk]
	update
	catch {
            set cmd "$mame -verifysamples \*"
            set data ""
            set fileid [open |$cmd r]
            if { $fileid != "" } {
                set data [read $fileid]
                close $fileid
            }
        }
	set fd [open $outfile w+]
        puts -nonewline $fd $data
	destroy .please_wait
	toplevel .var
	wm title .var $t(0164)
	set frm .var.frm
	frame $frm -bd 0
	text $frm.txt -font courierfont -yscrollcommand "$frm.v_scroll set" \
		-xscrollcommand "$frm.h_scroll set"
	scrollbar $frm.h_scroll -orient horizontal -command "$frm.txt xview"
	scrollbar $frm.v_scroll -command "$frm.txt yview"
	pack $frm.v_scroll -side right -fill y
	pack $frm.h_scroll -side bottom -fill x
	pack $frm.txt -expand 1 -fill both
	pack $frm -side top -fill both -expand 1
	while { [gets $fd data] >= 0 } {
	    $frm.txt insert end "$data\n"
	}
	close $fd
	tk_messageBox -title $t(0165) -type ok -icon info \
		-message "$t(0168) $outfile."
	destroy .var
    }
}


proc download_cheats { } {
    global t
    package require http 
    set url "http://cheat.retrogames.com/cheat.dat"
    if { [tk_messageBox -title $t(0170) -type yesno -icon question \
	    -message $t(0169)] == "yes" } {
	toplevel .progress
	label .progress.label -text $t(0171)
	label .progress.status -bd 2 -relief sunken -anchor w
	pack .progress.status .progress.label -side bottom -fill x
	::http::geturl $url -command http_callback -progress http_progress 
    }
}

# Procedure to display progress of HTTP get.
proc http_progress { token total_amt current_amt } {
    global t
    .progress.status config -text "$current_amt/$total_amt $t(0172)"
}

# Procedure to handle HTTP completion.
proc http_callback { token } {
    global mame_basedir textedit textname url xmame_doc_dir t wd

    destroy .progress
    upvar #0 $token state
    if { $state(status) == "ok" } {
	if { ![winfo exists .edit] } { textedit_create 20 }
        file_new .edit $textname CHEAT.DAT
	if { [is_windows] } {
	    set textedit(last_directory) $mame_basedir
	    set textedit(save_name) "[file join / $mame_basedir CHEAT.DAT]"
	} else {
	    set textedit(last_directory) $wd
	    set textedit(save_name) "[file join / $wd cheat.dat]"
	}
	$textname insert end $state(body)
	if { [tk_messageBox -title $t(0174) -type yesno \
		-icon question -message $t(0173)] == "yes" } {
	    if { [is_windows] } {
		set cheat_file [file join / $mame_basedir CHEAT.DAT]
		set cheat_bak [file join / $mame_basedir CHEAT.BAK]
	    } else {
		set cheat_file [file join / $wd cheat.dat]
		set cheat_bak [file join / $wd cheat.bak]
	    }
	    file rename -force $cheat_file $cheat_bak
	    set textname .edit.main.text
	    file_save $textname
	}
    } elseif { $state(status) == "error" } {
	tk_messageBox -title $t(0007) -type ok -icon error 
		-message "$state(error)"
    } else {
	tk_messageBox -title $t(0007) -type ok -icon error -message $t(0175)
    }
}


# build list with your roms
frame .f1
set menu .f1.menu_button.menu
menubutton .f1.menu_button -image star -width 13 -height 13 -menu $menu 
label .f1.label -text $t(0176)
entry .f1.entry -textvariable search_string 
pack .f1.menu_button -side left
pack .f1.label -side left
pack .f1.entry -side left -fill x -expand 1
menu .f1.menu_button.menu 
$menu add command -label $t(0177) -command launch_mame
$menu add separator
$menu add cascade -label $t(0178) -menu $menu.view
menu $menu.view
$menu.view add checkbutton -variable graphics_check -onvalue on -offvalue off \
	-label Graphics -command {
    if { $graphics_check == "off" } {
	wm withdraw .graphics
	set graphics_mapped 0
    } else {
	wm deiconify .graphics
	update
	update_graphics
	myraise .graphics
	set graphics_mapped 1
    }
}
$menu.view add checkbutton -variable options_check -onvalue on -offvalue off \
	-label Options -command {
    if { $options_check == "off" } {
	wm withdraw .options 
	set options_mapped 0
    } else {
	wm geometry $options 485x245
	wm deiconify .options 
	myraise .options
	set options_mapped 1
    }
}
$menu.view add command -label $t(0179) -command view_missing_roms
$menu.view add command -label $t(0180) -command view_notes
$menu.view add command -label $t(0181) -command {
    set listdetails [file join / $wd tmp details]
    if { ![file exists $listdetails] } {
	set output "$mame -listdetails $t(0182)"
	catch { 
	    if { [is_unix] } {
	        eval exec $mame -listdetails -stdout-file $listdetails
	    } else {
		eval exec $mame -listdetails > $listdetails
	    }
	}
    }
    set output "$t(0183) $listdetails"
    catch {
	set fd [open $listdetails r]
	set output [read $fd]
	close $fd
    }

    view_command_output $output
}
$menu.view add command -label $t(0184) -command {
    set listclones [file join / $wd tmp clones]
    if { ![file exists $listclones] } {
	set output "$mame -listclones $t(0182)."
	catch { 
	    if { [is_unix] } {
	        eval exec $mame -listclones -stdout-file $listclones
	    } else {
		eval exec $mame -listclones > $listclones
	    }
	}
    }
    set output "$t(0183) $listclones"
    catch {
	set fd [open $listclones r]
	set output [read $fd]
	close $fd
    }

    view_command_output $output
}
$menu.view add command -label $t(0185) -command {
    set listdetails [file join / $wd tmp games]
    if { ![file exists $listgames] } {
	set output "$mame -listgames $t(0182)"
	catch { 
	    if { [is_unix] } {
	        eval exec $mame -listgames -stdout-file $listgames
	    } else {
		eval exec $mame -listgames > $listgames
	    }
	}
    }
    set output "$t(0183) $listgames"
    catch {
	set fd [open $listgames r]
	set output [read $fd]
	close $fd
    }

    view_command_output $output
}
$menu.view add separator

if { [is_windows] } {
    set doc_dir $mame_basedir
} else {
    set doc_dir $xmame_doc_dir
}


if { [doc_exists $doc_dir COPYING] } {
    set license $doc_file
    $menu.view add command -label $t(0270) -command { view_file $license }
} else {
    $menu.view add command -label $t(0270) -state disabled
}

if { [is_windows] } {
    set readme_file readme.txt
} else {
    set readme_file readme.dos
}

if { [doc_exists $doc_dir $readme_file] } {
    set readme_file $doc_file
    $menu.view add command -label $t(0186) -command { view_file $readme_file }
} else {
    $menu.view add command -label $t(0186) -state disabled
}

if { [is_unix] } {
    if { [doc_exists $doc_dir README.unix] } {
	set unix_readme $doc_file
	$menu.view add command -label $t(0218) -command {
	    view_file $unix_readme
	}
    } else {
	$menu.view add command -label $t(0186) -state disabled
    }
}

if { [doc_exists $doc_dir tkmame.htm] } {
    set tkmame_doc $doc_file
    $menu.view add command -label $t(0219) -command { view_file $tkmame_doc }
} else {
    $menu.view add command -label $t(0219) -state disabled
}

if { [doc_exists $doc_dir error.log] } {
    set error_log $doc_file
    $menu.view add command -label $t(0221) -command { view_file $error_log }
} else {
    $menu.view add command -label $t(0221) -state disabled
}

if { [doc_exists $doc_dir whatsnew.txt] } {
    set whatsnew $doc_file
    $menu.view add command -label $t(0222) -command { view_file $whatsnew }
} else {
    $menu.view add command -label $t(0222) -state disabled
}

if { [doc_exists $doc_dir whatsold.txt] } {
    set whatsold $doc_file
    $menu.view add command -label $t(0223) -command { view_file $whatsold }
} else {
    $menu.view add command -label $t(0223) -state disabled
}

if { [doc_exists $doc_dir history.dat] } {
    set history_file $doc_file
    $menu.view add command -label $t(0298) -command { view_file $history_file }
} else {
    $menu.view add command -label $t(0298) -state disabled
}

if { [doc_exists $doc_dir cheat.doc] } {
    set cheat_file $doc_file
    $menu.view add command -label $t(0224) -command { view_file $cheat_file }
} else {
    $menu.view add command -label $t(0224) -state disabled
}

if { [doc_exists $doc_dir gamelist.txt] } {
    set game_file $doc_file
    $menu.view add command -label $t(0225) -command { view_file $game_file }
} else {
    $menu.view add command -label $t(0225) -state disabled
}

$menu add cascade -label $t(0227) -menu $menu.verify
menu $menu.verify 
$menu.verify add command -label $t(0226) -command verify_rom
$menu.verify add command -label $t(0228) -command verify_samples
$menu add cascade -label $t(0107) -menu $menu.edit
menu $menu.edit 
$menu.edit add command -label $t(0229) -command {
    if { [is_windows] } {
	view_file [file join / $mame_base_dir CHEAT.DAT]
    } else {
	view_file [file join / $wd cheat.dat]
    }
}
$menu.edit add command -label $t(0230) -command {
    if { [is_windows] } {
	view_file [file join / $mame_basedir mame.cfg]
    } else {
	view_file [file join / $wd xmamerc]
    }
}
$menu add cascade -label $t(0086) -menu $menu.other
menu $menu.other 
if { [is_unix] } {
    $menu.other add command -label $t(0293) -command { 
	global autoraise
	if { $autoraise } {
	    set autoraise 0
	} else {
	    set autoraise 1
	}
    }
}

$menu.other add command -label $t(0231)	-command { 
    set tmp_mame [get_executable] 
    if { $tmp_mame != "" } {
	set mame $tmp_mame
	update_command_line 0
    }
}
$menu.other add command -label $t(0232)	-command { reset_keyboard }
$menu.other add command -label $t(0233)	-command { reset_highscores }
$menu.other add command -label $t(0234)	-command { rescan_notes }
$menu add cascade -label $t(0235) -menu $menu.colors
menu $menu.colors
$menu.colors add command -label $t(0236) -command {
    set_tkmame_default_colors
    set_palette
}
$menu.colors add command -label $t(0292) -command {
    set_tkmame_us_patriotic_colors
    set_palette
}
$menu.colors add command -label $t(0237) -command {
    set_default_colors
    set_color background lightSteelBlue
}
$menu.colors add command -label $t(0238) -command {
    set_default_colors
    set_color background lightSlateGray
}
$menu.colors add command -label $t(0239) -command {
    set_default_colors
    set_palette
}
$menu.colors add separator
$menu.colors add command -label $t(0240) -command {
    set_color background [tk_chooseColor]
}
$menu.colors add command -label $t(0241) -command {
    set_color foreground [tk_chooseColor]
}
$menu.colors add command -label $t(0242) -command {
    set_color activeBackground [tk_chooseColor]
}
$menu.colors add command -label $t(0243) -command {
    set_color activeForeground [tk_chooseColor]
}
$menu.colors add command -label $t(0244) -command {
    set_color disabledForeground [tk_chooseColor]
}
$menu.colors add command -label $t(0245) -command {
    set_color highlightBackground [tk_chooseColor]
}
$menu.colors add command -label $t(0246) -command {
    set_color highlightColor [tk_chooseColor]
}
$menu.colors add command -label $t(0247) -command {
    set_color insertBackground [tk_chooseColor]
}
$menu.colors add command -label $t(0248) -command {
    set_color selectColor [tk_chooseColor]
}
$menu.colors add command -label $t(0249) -command {
    set_color selectBackground [tk_chooseColor]
}
$menu.colors add command -label $t(0250) -command {
    set_color troughColor [tk_chooseColor]
}
$menu add separator
$menu add command -label $t(0251) -command {
    run_diagnostics
}
$menu add command -label $t(0252) -command {
    download_cheats
}
$menu add separator
$menu add command -label $t(0253) -command {
    splash_create tkmame "TkMAME $ver" $t(0279) $t(0280)
    .splash configure -cursor gumby

    after 10000 splash_remove
}
$menu add command -label $t(0113) -command my_exit
menu .menu -tearoff 0
.menu add command -label $t(0255) -command launch_mame
.menu add separator
.menu add command -label $t(0256) -command { 
    update_command_line 0
    wm geometry .options 485x245
    wm deiconify .options 
    myraise .options
    set options_check on
    set options_mapped 1
}
.menu add command -label $t(0257) -command {
    set config_file [file join / $wd config [get_image_name]).tkc]
    if { [file isfile $config_file] } {
	if { [tk_messageBox -title $config_file -type yesno -icon question \
		-message $t(0258)] == "yes" } {
	    catch { file delete $config_file }
	}
    }
}
.menu add separator
.menu add checkbutton -variable graphics_check -onvalue on -offvalue off \
	-label $t(0259) -command {
    if { $graphics_check == "off" } {
	wm withdraw .graphics
	set graphics_mapped 0
    } else {
	wm deiconify .graphics
	update
	update_graphics
	myraise .graphics
	set graphics_mapped 1
    }
}
.menu add command -label $t(0260) -command view_notes
.menu add command -label $t(0261) -command verify_rom
.menu add command -label $t(0262) -command verify_samples
.menu add command -label $t(0263) -command {
    set tmpfile [file join / $wd tmp tmpfile]
    set output "$mame -listclones [get_image_name] $t(0182)"
    catch {
	if { [is_unix] } {
	    eval exec $mame -listclones [get_image_name] -stdout-file $tmpfile
	} else {
	    eval exec $mame -listclones [get_image_name] > $tmpfile
	}
    }
    set output "$t(0183) $listclones"
    catch {
	set fd [open $tmpfile r]
	set output [read $fd]
	close $fd
	file delete $tmpfile
    }

    view_command_output $output
}
.menu add separator
.menu add command -label $t(0264) -command {
    if { [FontDialog myfont] == 1 } {
	.frame.list configure -font myfont
    }
}

frame .frame -bd 0
set list .frame.list
listbox $list -selectmode single -yscrollcommand ".frame.v_scroll set" 
scrollbar .frame.v_scroll -command "$list yview"
foreach rom $slyroms { $list insert end $rom }
pack .frame.v_scroll -side left -fill y
pack .frame.list -expand 1 -fill both
frame .f2
set groups_widget [dlc .f2.groups "" 10 20 sel_group "All ROMs" disabled]
set maingrouplist [list "All Groups" "User Groups" "Year Groups" \
		       "Manufacturer Groups" "Wrong Orientation Groups" \
		       "Color Groups"]
set mgrps_widget [dlc .f2.mgrps "" 10 [llength $maingrouplist] main_group \
		      "All Groups" disabled]
set last_sel_group $sel_group
set last_main_group $main_group
set len [llength $all_groups]
$groups_widget insert end [lindex $all_groups 0]
$mgrps_widget insert end \
    [lindex $maingrouplist 0] [lindex $maingrouplist 1] \
    [lindex $maingrouplist 2] [lindex $maingrouplist 3]
if { [is_unix] } {
    $mgrps_widget insert end \
	[lindex $maingrouplist 4] [lindex $maingrouplist 5]
}
.f2.mgrps.top.frame.list activate 0
set sorted_groups [lsort -dictionary $all_groups]
for { set i 0 } { $i < $len } { incr i } {
    set group [lindex $sorted_groups $i]
    if { $group != "All ROMs" } {
	$groups_widget insert end $group
    }
}
$groups_widget configure -width 40
$mgrps_widget configure -width 25
pack .f2.mgrps .f2.groups -side right -fill x -expand 1
pack .f1 .f2 -fill x 

pack .frame -side top -fill both -expand 1 -anchor n
bind $list <Control-Home> {
    after 50 {
	set search_string ""
	set pattern "^"
	do_updates
    }
}
bind $list <Control-End> {
    after 50 {
	set search_string ""
	set pattern "^"
	do_updates
    }
}
bind $list <Button-1> {
    if { [$list curselection] != "" } {
	$list selection clear [$list curselection]
    }
    $list selection set [$list nearest %y]
    $list activate [$list nearest %y]
    set search_string ""
    set pattern "^"
    update
    do_updates
}
bind $list <Double-Button-1> {
    set search_string ""
    set pattern "^"
    launch_mame
}
bind $list <Button-3> {
    if { [$list curselection] != "" } {
	$list selection clear [$list curselection]
    }
    $list selection set [$list nearest %y]
    $list activate [$list nearest %y]
    set search_string ""
    set pattern "^"
    update
    do_updates
    .menu post [expr [winfo rootx $list] + %x] [expr [winfo rooty $list] + %y]
}
bind . <Key-Return> {
    set search_string ""
    set pattern "^"
    launch_mame
}
bind . <Control-Shift-Down> {
    set index [$list curselection]
    if { $index != "" } {
	if { $index < [llength $slyroms] } {
	    $list selection clear $index
	    incr index
	    $list see $index
	    $list selection set $index
	    set search_string ""
	    set pattern "^"
	    very_short_doupdates
	}
    }
}
bind . <Control-Shift-Up> {
    set index [$list curselection]
    if { $index != "" } {
	if { $index > 0 } {
	    $list selection clear $index
	    incr index -1
	    $list see $index
	    $list selection set $index
	    set search_string ""
	    set pattern "^"
	    very_short_doupdates
	}
    }
}
bind . <Shift-Down> {
    set index [$list curselection]
    if { $index != "" } {
	if { $index < [llength $slyroms] } {
	    $list selection clear $index
	    incr index
	    $list see $index
	    $list selection set $index
	    set search_string ""
	    set pattern "^"
	    short_doupdates
	}
    }
}
bind . <Shift-Up> {
    set index [$list curselection]
    if { $index != "" } {
	if { $index > 0 } {
	    $list selection clear $index
	    incr index -1
	    $list see $index
	    $list selection set $index
	    set search_string ""
	    set pattern "^"
	    short_doupdates
	}
    }
}
bind . <Down> {
    set index [$list curselection]
    if { $index != "" } {
	if { $index < [llength $slyroms] } {
	    $list selection clear $index
	    incr index
	    $list see $index
	    $list selection set $index
	    set search_string ""
	    set pattern "^"
	    do_updates
	}
    }
}
bind . <Up> {
    set index [$list curselection]
    if { $index != "" } {
	if { $index > 0 } {
	    $list selection clear $index
	    incr index -1
	    $list see $index
	    $list selection set $index
	    set search_string ""
	    set pattern "^"
	    do_updates
	}
    }
}
bind . <Next> {
    update 
    set old_index [$list curselection]
    set element [$list get active]
    if { $element != 0 && $old_index != "" } {
	$list selection clear $old_index
	set index [lsearch $slyroms $element]
	$list see $index
	$list selection set $index
	set search_string ""
	set pattern "^"
	do_updates
    }
}
bind . <Prior> {
    update 
    set old_index [$list curselection]
    set element [$list get active]
    if { $element != 0 && $old_index != "" } {
	$list selection clear $old_index
	set index [lsearch $slyroms $element]
	$list see $index
	$list selection set $index
	set search_string ""
	set pattern "^"
	do_updates
    }
}
bind .f1.entry <KeyRelease> {
    if { [lsearch [list Shift_L Control_L Shift_R Control_R Down Up Return \
		       Left Right Next Prior Escape] %K] == -1 } {
	set pattern "^"
	for { set i 0 } { [string index $search_string $i] != "" } { incr i } {
	    set char [string index $search_string $i]
	    if { $char == " " } {
		append pattern "\[a-zA-Z\]*\ "
	    } else {
		append pattern [string tolower "\\$char"]
	    }
	}
	set index [lsearch -regexp $sllyroms $pattern]
	if { $index == -1 } {
	    set pattern [string trimleft $pattern "^"]
	    set index [lsearch -regexp $sllyroms $pattern]
	}
	if { $index != -1 } {
	    if { [$list curselection] != "" } {
		$list selection clear [$list curselection]
	    }
	    $list see $index
	    $list selection set $index
	    $list activate $index
	    do_updates
	}
    }
}
bind . <FocusIn> {
    if { [string compare %p PlaceOnTop] == 0 } {
	raise_all_windows %W
    }
}
bind .graphics <FocusIn> {
    if { [string compare %p PlaceOnTop] == 0 } {
	raise_all_windows %W
    }
}
bind .options <FocusIn> {
    if { [string compare %p PlaceOnTop] == 0 } {
	raise_all_windows %W
    }
}
bind $list <Map> {
    raise_all_windows %W
}
bind $list <Unmap> {
    update
    minimize_all_windows
}

# map the main window

set geometry_file [file join / $wd tkmame.geo]
if { [file exists $geometry_file] } {
    source $geometry_file
}

set_palette

set numroms [llength $slyroms]
if { $numroms == 1 } { set r "ROM" } else { set r "ROMs" }
if { [is_windows]} {
    wm title . "MAME $ver - $numroms $r"
} else {
    wm title . "TkMAME $ver - $numroms $r"
    puts "\nTkMAME $ver"
    puts $t(0279)
    puts $t(0280)
}
if { $graphics_mapped } {
    wm deiconify .graphics
    myraise .graphics
    update_graphics
}
if { $options_mapped } {
    wm deiconify .options
    myraise .options
}

wm protocol . WM_DELETE_WINDOW { my_exit }
do_updates
splash_remove
wm deiconify .
myraise .
